var Output = function({ regl: r, precision: n, label: d = "", width: _, height: T }) {
  this.regl = r, this.precision = n, this.label = d, this.positionBuffer = this.regl.buffer([
    [-2, 0],
    [0, -2],
    [2, 2]
  ]), this.draw = () => {
  }, this.init(), this.pingPongIndex = 0, this.fbos = Array(2).fill().map(() => this.regl.framebuffer({
    color: this.regl.texture({
      mag: "nearest",
      width: _,
      height: T,
      format: "rgba"
    }),
    depthStencil: !1
  }));
};
Output.prototype.resize = function(r, n) {
  this.fbos.forEach((d) => {
    d.resize(r, n);
  });
};
Output.prototype.getCurrent = function() {
  return this.fbos[this.pingPongIndex];
};
Output.prototype.getTexture = function() {
  var r = this.pingPongIndex ? 0 : 1;
  return this.fbos[r];
};
Output.prototype.init = function() {
  return this.transformIndex = 0, this.fragHeader = `
  precision ${this.precision} float;

  uniform float time;
  varying vec2 uv;
  `, this.fragBody = "", this.vert = `
  precision ${this.precision} float;
  attribute vec2 position;
  varying vec2 uv;

  void main () {
    uv = position;
    gl_Position = vec4(2.0 * position - 1.0, 0, 1);
  }`, this.attributes = {
    position: this.positionBuffer
  }, this.uniforms = {
    time: this.regl.prop("time"),
    resolution: this.regl.prop("resolution")
  }, this.frag = `
       ${this.fragHeader}

      void main () {
        vec4 c = vec4(0, 0, 0, 0);
        vec2 st = uv;
        ${this.fragBody}
        gl_FragColor = c;
      }
  `, this;
};
Output.prototype.render = function(r) {
  let n = r[0];
  var d = this, _ = Object.assign(n.uniforms, {
    prevBuffer: () => d.fbos[d.pingPongIndex]
  });
  d.draw = d.regl({
    frag: n.frag,
    vert: d.vert,
    attributes: d.attributes,
    uniforms: _,
    count: 3,
    framebuffer: () => (d.pingPongIndex = d.pingPongIndex ? 0 : 1, d.fbos[d.pingPongIndex])
  });
};
Output.prototype.tick = function(r) {
  this.draw(r);
};
var commonjsGlobal = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function getDefaultExportFromCjs(r) {
  return r && r.__esModule && Object.prototype.hasOwnProperty.call(r, "default") ? r.default : r;
}
var inherits_browser = { exports: {} };
typeof Object.create == "function" ? inherits_browser.exports = function(n, d) {
  d && (n.super_ = d, n.prototype = Object.create(d.prototype, {
    constructor: {
      value: n,
      enumerable: !1,
      writable: !0,
      configurable: !0
    }
  }));
} : inherits_browser.exports = function(n, d) {
  if (d) {
    n.super_ = d;
    var _ = function() {
    };
    _.prototype = d.prototype, n.prototype = new _(), n.prototype.constructor = n;
  }
};
var inherits_browserExports = inherits_browser.exports;
function EventEmitter$1() {
  this._events = this._events || {}, this._maxListeners = this._maxListeners || void 0;
}
var events = EventEmitter$1;
EventEmitter$1.EventEmitter = EventEmitter$1;
EventEmitter$1.prototype._events = void 0;
EventEmitter$1.prototype._maxListeners = void 0;
EventEmitter$1.defaultMaxListeners = 10;
EventEmitter$1.prototype.setMaxListeners = function(r) {
  if (!isNumber(r) || r < 0 || isNaN(r))
    throw TypeError("n must be a positive number");
  return this._maxListeners = r, this;
};
EventEmitter$1.prototype.emit = function(r) {
  var n, d, _, T, N, le;
  if (this._events || (this._events = {}), r === "error" && (!this._events.error || isObject(this._events.error) && !this._events.error.length)) {
    if (n = arguments[1], n instanceof Error)
      throw n;
    var fe = new Error('Uncaught, unspecified "error" event. (' + n + ")");
    throw fe.context = n, fe;
  }
  if (d = this._events[r], isUndefined(d))
    return !1;
  if (isFunction(d))
    switch (arguments.length) {
      case 1:
        d.call(this);
        break;
      case 2:
        d.call(this, arguments[1]);
        break;
      case 3:
        d.call(this, arguments[1], arguments[2]);
        break;
      default:
        T = Array.prototype.slice.call(arguments, 1), d.apply(this, T);
    }
  else if (isObject(d))
    for (T = Array.prototype.slice.call(arguments, 1), le = d.slice(), _ = le.length, N = 0; N < _; N++)
      le[N].apply(this, T);
  return !0;
};
EventEmitter$1.prototype.addListener = function(r, n) {
  var d;
  if (!isFunction(n))
    throw TypeError("listener must be a function");
  return this._events || (this._events = {}), this._events.newListener && this.emit(
    "newListener",
    r,
    isFunction(n.listener) ? n.listener : n
  ), this._events[r] ? isObject(this._events[r]) ? this._events[r].push(n) : this._events[r] = [this._events[r], n] : this._events[r] = n, isObject(this._events[r]) && !this._events[r].warned && (isUndefined(this._maxListeners) ? d = EventEmitter$1.defaultMaxListeners : d = this._maxListeners, d && d > 0 && this._events[r].length > d && (this._events[r].warned = !0, console.error(
    "(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",
    this._events[r].length
  ), typeof console.trace == "function" && console.trace())), this;
};
EventEmitter$1.prototype.on = EventEmitter$1.prototype.addListener;
EventEmitter$1.prototype.once = function(r, n) {
  if (!isFunction(n))
    throw TypeError("listener must be a function");
  var d = !1;
  function _() {
    this.removeListener(r, _), d || (d = !0, n.apply(this, arguments));
  }
  return _.listener = n, this.on(r, _), this;
};
EventEmitter$1.prototype.removeListener = function(r, n) {
  var d, _, T, N;
  if (!isFunction(n))
    throw TypeError("listener must be a function");
  if (!this._events || !this._events[r])
    return this;
  if (d = this._events[r], T = d.length, _ = -1, d === n || isFunction(d.listener) && d.listener === n)
    delete this._events[r], this._events.removeListener && this.emit("removeListener", r, n);
  else if (isObject(d)) {
    for (N = T; N-- > 0; )
      if (d[N] === n || d[N].listener && d[N].listener === n) {
        _ = N;
        break;
      }
    if (_ < 0)
      return this;
    d.length === 1 ? (d.length = 0, delete this._events[r]) : d.splice(_, 1), this._events.removeListener && this.emit("removeListener", r, n);
  }
  return this;
};
EventEmitter$1.prototype.removeAllListeners = function(r) {
  var n, d;
  if (!this._events)
    return this;
  if (!this._events.removeListener)
    return arguments.length === 0 ? this._events = {} : this._events[r] && delete this._events[r], this;
  if (arguments.length === 0) {
    for (n in this._events)
      n !== "removeListener" && this.removeAllListeners(n);
    return this.removeAllListeners("removeListener"), this._events = {}, this;
  }
  if (d = this._events[r], isFunction(d))
    this.removeListener(r, d);
  else if (d)
    for (; d.length; )
      this.removeListener(r, d[d.length - 1]);
  return delete this._events[r], this;
};
EventEmitter$1.prototype.listeners = function(r) {
  var n;
  return !this._events || !this._events[r] ? n = [] : isFunction(this._events[r]) ? n = [this._events[r]] : n = this._events[r].slice(), n;
};
EventEmitter$1.prototype.listenerCount = function(r) {
  if (this._events) {
    var n = this._events[r];
    if (isFunction(n))
      return 1;
    if (n)
      return n.length;
  }
  return 0;
};
EventEmitter$1.listenerCount = function(r, n) {
  return r.listenerCount(n);
};
function isFunction(r) {
  return typeof r == "function";
}
function isNumber(r) {
  return typeof r == "number";
}
function isObject(r) {
  return typeof r == "object" && r !== null;
}
function isUndefined(r) {
  return r === void 0;
}
var browser = commonjsGlobal.performance && commonjsGlobal.performance.now ? function() {
  return performance.now();
} : Date.now || function() {
  return +/* @__PURE__ */ new Date();
}, raf$2 = { exports: {} }, performanceNow = { exports: {} };
(function() {
  var r, n, d, _, T, N;
  typeof performance < "u" && performance !== null && performance.now ? performanceNow.exports = function() {
    return performance.now();
  } : typeof process < "u" && process !== null && process.hrtime ? (performanceNow.exports = function() {
    return (r() - T) / 1e6;
  }, n = process.hrtime, r = function() {
    var le;
    return le = n(), le[0] * 1e9 + le[1];
  }, _ = r(), N = process.uptime() * 1e9, T = _ - N) : Date.now ? (performanceNow.exports = function() {
    return Date.now() - d;
  }, d = Date.now()) : (performanceNow.exports = function() {
    return (/* @__PURE__ */ new Date()).getTime() - d;
  }, d = (/* @__PURE__ */ new Date()).getTime());
}).call(commonjsGlobal);
var performanceNowExports = performanceNow.exports, now$1 = performanceNowExports, root = typeof window > "u" ? commonjsGlobal : window, vendors = ["moz", "webkit"], suffix = "AnimationFrame", raf$1 = root["request" + suffix], caf = root["cancel" + suffix] || root["cancelRequest" + suffix];
for (var i = 0; !raf$1 && i < vendors.length; i++)
  raf$1 = root[vendors[i] + "Request" + suffix], caf = root[vendors[i] + "Cancel" + suffix] || root[vendors[i] + "CancelRequest" + suffix];
if (!raf$1 || !caf) {
  var last = 0, id = 0, queue = [], frameDuration = 1e3 / 60;
  raf$1 = function(r) {
    if (queue.length === 0) {
      var n = now$1(), d = Math.max(0, frameDuration - (n - last));
      last = d + n, setTimeout(function() {
        var _ = queue.slice(0);
        queue.length = 0;
        for (var T = 0; T < _.length; T++)
          if (!_[T].cancelled)
            try {
              _[T].callback(last);
            } catch (N) {
              setTimeout(function() {
                throw N;
              }, 0);
            }
      }, Math.round(d));
    }
    return queue.push({
      handle: ++id,
      callback: r,
      cancelled: !1
    }), id;
  }, caf = function(r) {
    for (var n = 0; n < queue.length; n++)
      queue[n].handle === r && (queue[n].cancelled = !0);
  };
}
raf$2.exports = function(r) {
  return raf$1.call(root, r);
};
raf$2.exports.cancel = function() {
  caf.apply(root, arguments);
};
raf$2.exports.polyfill = function(r) {
  r || (r = root), r.requestAnimationFrame = raf$1, r.cancelAnimationFrame = caf;
};
var rafExports = raf$2.exports, inherits = inherits_browserExports, EventEmitter = events.EventEmitter, now = browser, raf = rafExports, rafLoop = Engine;
function Engine(r) {
  if (!(this instanceof Engine))
    return new Engine(r);
  this.running = !1, this.last = now(), this._frame = 0, this._tick = this.tick.bind(this), r && this.on("tick", r);
}
inherits(Engine, EventEmitter);
Engine.prototype.start = function() {
  if (!this.running)
    return this.running = !0, this.last = now(), this._frame = raf(this._tick), this;
};
Engine.prototype.stop = function() {
  return this.running = !1, this._frame !== 0 && raf.cancel(this._frame), this._frame = 0, this;
};
Engine.prototype.tick = function() {
  this._frame = raf(this._tick);
  var r = now(), n = r - this.last;
  this.emit("tick", n), this.last = r;
};
const loop = /* @__PURE__ */ getDefaultExportFromCjs(rafLoop);
function Webcam(r) {
  return navigator.mediaDevices.enumerateDevices().then((n) => n.filter((d) => d.kind === "videoinput")).then((n) => {
    let d = { audio: !1, video: !0 };
    return n[r] && (d.video = {
      deviceId: { exact: n[r].deviceId }
    }), window.navigator.mediaDevices.getUserMedia(d);
  }).then((n) => {
    const d = document.createElement("video");
    return d.setAttribute("autoplay", ""), d.setAttribute("muted", ""), d.setAttribute("playsinline", ""), d.srcObject = n, new Promise((_, T) => {
      d.addEventListener("loadedmetadata", () => {
        d.play().then(() => _({ video: d }));
      });
    });
  }).catch(console.log.bind(console));
}
function Screen(r) {
  return new Promise(function(n, d) {
    navigator.mediaDevices.getDisplayMedia(r).then((_) => {
      const T = document.createElement("video");
      T.srcObject = _, T.addEventListener("loadedmetadata", () => {
        T.play(), n({ video: T });
      });
    }).catch((_) => d(_));
  });
}
class HydraSource {
  constructor({ regl: n, width: d, height: _, pb: T, label: N = "" }) {
    this.label = N, this.regl = n, this.src = null, this.dynamic = !0, this.width = d, this.height = _, this.tex = this.regl.texture({
      //  shape: [width, height]
      shape: [1, 1]
    }), this.pb = T;
  }
  init(n, d) {
    "src" in n && (this.src = n.src, this.tex = this.regl.texture({ data: this.src, ...d })), "dynamic" in n && (this.dynamic = n.dynamic);
  }
  initCam(n, d) {
    const _ = this;
    Webcam(n).then((T) => {
      _.src = T.video, _.dynamic = !0, _.tex = _.regl.texture({ data: _.src, ...d });
    }).catch((T) => console.log("could not get camera", T));
  }
  initVideo(n = "", d) {
    const _ = document.createElement("video");
    _.crossOrigin = "anonymous", _.autoplay = !0, _.loop = !0, _.muted = !0, _.addEventListener("loadeddata", () => {
      this.src = _, _.play(), this.tex = this.regl.texture({ data: this.src, ...d }), this.dynamic = !0;
    }), _.src = n;
  }
  initImage(n = "", d) {
    const _ = document.createElement("img");
    _.crossOrigin = "anonymous", _.src = n, _.onload = () => {
      this.src = _, this.dynamic = !1, this.tex = this.regl.texture({ data: this.src, ...d });
    };
  }
  initStream(n, d) {
    let _ = this;
    n && this.pb && (this.pb.initSource(n), this.pb.on("got video", function(T, N) {
      T === n && (_.src = N, _.dynamic = !0, _.tex = _.regl.texture({ data: _.src, ...d }));
    }));
  }
  // index only relevant in atom-hydra + desktop apps
  initScreen(n = 0, d) {
    const _ = this;
    Screen().then(function(T) {
      _.src = T.video, _.tex = _.regl.texture({ data: _.src, ...d }), _.dynamic = !0;
    }).catch((T) => console.log("could not get screen", T));
  }
  resize(n, d) {
    this.width = n, this.height = d;
  }
  clear() {
    this.src && this.src.srcObject && this.src.srcObject.getTracks && this.src.srcObject.getTracks().forEach((n) => n.stop()), this.src = null, this.tex = this.regl.texture({ shape: [1, 1] });
  }
  tick(n) {
    this.src !== null && this.dynamic === !0 && (this.src.videoWidth && this.src.videoWidth !== this.tex.width && (console.log(
      this.src.videoWidth,
      this.src.videoHeight,
      this.tex.width,
      this.tex.height
    ), this.tex.resize(this.src.videoWidth, this.src.videoHeight)), this.src.width && this.src.width !== this.tex.width && this.tex.resize(this.src.width, this.src.height), this.tex.subimage(this.src));
  }
  getTexture() {
    return this.tex;
  }
}
const mouse = {};
function mouseButtons(r) {
  if (typeof r == "object") {
    if ("buttons" in r)
      return r.buttons;
    if ("which" in r) {
      var n = r.which;
      if (n === 2)
        return 4;
      if (n === 3)
        return 2;
      if (n > 0)
        return 1 << n - 1;
    } else if ("button" in r) {
      var n = r.button;
      if (n === 1)
        return 4;
      if (n === 2)
        return 2;
      if (n >= 0)
        return 1 << n;
    }
  }
  return 0;
}
mouse.buttons = mouseButtons;
function mouseElement(r) {
  return r.target || r.srcElement || window;
}
mouse.element = mouseElement;
function mouseRelativeX(r) {
  return typeof r == "object" && "pageX" in r ? r.pageX : 0;
}
mouse.x = mouseRelativeX;
function mouseRelativeY(r) {
  return typeof r == "object" && "pageY" in r ? r.pageY : 0;
}
mouse.y = mouseRelativeY;
function mouseListen(r, n) {
  n || (n = r, r = window);
  var d = 0, _ = 0, T = 0, N = {
    shift: !1,
    alt: !1,
    control: !1,
    meta: !1
  }, le = !1;
  function fe(Ne) {
    var Ze = !1;
    return "altKey" in Ne && (Ze = Ze || Ne.altKey !== N.alt, N.alt = !!Ne.altKey), "shiftKey" in Ne && (Ze = Ze || Ne.shiftKey !== N.shift, N.shift = !!Ne.shiftKey), "ctrlKey" in Ne && (Ze = Ze || Ne.ctrlKey !== N.control, N.control = !!Ne.ctrlKey), "metaKey" in Ne && (Ze = Ze || Ne.metaKey !== N.meta, N.meta = !!Ne.metaKey), Ze;
  }
  function Oe(Ne, Ze) {
    var Ct = mouse.x(Ze), yt = mouse.y(Ze);
    "buttons" in Ze && (Ne = Ze.buttons | 0), (Ne !== d || Ct !== _ || yt !== T || fe(Ze)) && (d = Ne | 0, _ = Ct || 0, T = yt || 0, n && n(d, _, T, N));
  }
  function pe(Ne) {
    Oe(0, Ne);
  }
  function Ie() {
    (d || _ || T || N.shift || N.alt || N.meta || N.control) && (_ = T = 0, d = 0, N.shift = N.alt = N.control = N.meta = !1, n && n(0, 0, 0, N));
  }
  function ve(Ne) {
    fe(Ne) && n && n(d, _, T, N);
  }
  function Be(Ne) {
    mouse.buttons(Ne) === 0 ? Oe(0, Ne) : Oe(d, Ne);
  }
  function We(Ne) {
    Oe(d | mouse.buttons(Ne), Ne);
  }
  function je(Ne) {
    Oe(d & ~mouse.buttons(Ne), Ne);
  }
  function Qe() {
    le || (le = !0, r.addEventListener("mousemove", Be), r.addEventListener("mousedown", We), r.addEventListener("mouseup", je), r.addEventListener("mouseleave", pe), r.addEventListener("mouseenter", pe), r.addEventListener("mouseout", pe), r.addEventListener("mouseover", pe), r.addEventListener("blur", Ie), r.addEventListener("keyup", ve), r.addEventListener("keydown", ve), r.addEventListener("keypress", ve), r !== window && (window.addEventListener("blur", Ie), window.addEventListener("keyup", ve), window.addEventListener("keydown", ve), window.addEventListener("keypress", ve)));
  }
  function ut() {
    le && (le = !1, r.removeEventListener("mousemove", Be), r.removeEventListener("mousedown", We), r.removeEventListener("mouseup", je), r.removeEventListener("mouseleave", pe), r.removeEventListener("mouseenter", pe), r.removeEventListener("mouseout", pe), r.removeEventListener("mouseover", pe), r.removeEventListener("blur", Ie), r.removeEventListener("keyup", ve), r.removeEventListener("keydown", ve), r.removeEventListener("keypress", ve), r !== window && (window.removeEventListener("blur", Ie), window.removeEventListener("keyup", ve), window.removeEventListener("keydown", ve), window.removeEventListener("keypress", ve)));
  }
  Qe();
  var vt = {
    element: r
  };
  return Object.defineProperties(vt, {
    enabled: {
      get: function() {
        return le;
      },
      set: function(Ne) {
        Ne ? Qe() : ut();
      },
      enumerable: !0
    },
    buttons: {
      get: function() {
        return d;
      },
      enumerable: !0
    },
    x: {
      get: function() {
        return _;
      },
      enumerable: !0
    },
    y: {
      get: function() {
        return T;
      },
      enumerable: !0
    },
    mods: {
      get: function() {
        return N;
      },
      enumerable: !0
    }
  }), vt;
}
var meyda_min = { exports: {} }, dct_1, hasRequiredDct$1;
function requireDct$1() {
  if (hasRequiredDct$1)
    return dct_1;
  hasRequiredDct$1 = 1;
  var r = null, n = function(_) {
    r = r || {}, r[_] = new Array(_ * _);
    for (var T = Math.PI / _, N = 0; N < _; N++)
      for (var le = 0; le < _; le++)
        r[_][le + N * _] = Math.cos(T * (le + 0.5) * N);
  };
  function d(_, T) {
    var N = _.length;
    T = T || 2, (!r || !r[N]) && n(N);
    var le = _.map(function() {
      return 0;
    });
    return le.map(function(fe, Oe) {
      return T * _.reduce(function(pe, Ie, ve, Be) {
        return pe + Ie * r[N][ve + Oe * N];
      }, 0);
    });
  }
  return dct_1 = d, dct_1;
}
var dct, hasRequiredDct;
function requireDct() {
  return hasRequiredDct || (hasRequiredDct = 1, dct = requireDct$1()), dct;
}
var utils, hasRequiredUtils;
function requireUtils() {
  if (hasRequiredUtils)
    return utils;
  hasRequiredUtils = 1;
  function r(Ie) {
    if (Array.isArray(Ie)) {
      for (var ve = 0, Be = Array(Ie.length); ve < Ie.length; ve++)
        Be[ve] = Ie[ve];
      return Be;
    } else
      return Array.from(Ie);
  }
  var n = {}, d = {}, _ = function(ve) {
    var Be = {};
    Be.real = ve.real === void 0 ? ve.slice() : ve.real.slice();
    var We = Be.real.length;
    return d[We] === void 0 && (d[We] = Array.apply(null, Array(We)).map(Number.prototype.valueOf, 0)), Be.imag = d[We].slice(), Be;
  }, T = function(ve) {
    if (n[ve] === void 0) {
      for (var Be = (ve - 1).toString(2).length, We = "0".repeat(Be), je = {}, Qe = 0; Qe < ve; Qe++) {
        var ut = Qe.toString(2);
        ut = We.substr(ut.length) + ut, ut = [].concat(r(ut)).reverse().join(""), je[Qe] = parseInt(ut, 2);
      }
      n[ve] = je;
    }
    return n[ve];
  }, N = function(ve, Be) {
    return {
      real: ve.real * Be.real - ve.imag * Be.imag,
      imag: ve.real * Be.imag + ve.imag * Be.real
    };
  }, le = function(ve, Be) {
    return {
      real: ve.real + Be.real,
      imag: ve.imag + Be.imag
    };
  }, fe = function(ve, Be) {
    return {
      real: ve.real - Be.real,
      imag: ve.imag - Be.imag
    };
  }, Oe = function(ve, Be) {
    var We = -2 * Math.PI * ve / Be;
    return { real: Math.cos(We), imag: Math.sin(We) };
  }, pe = function(ve) {
    return ve.imag *= -1, ve;
  };
  return utils = {
    bitReverseArray: T,
    multiply: N,
    add: le,
    subtract: fe,
    euler: Oe,
    conj: pe,
    constructComplexArray: _
  }, utils;
}
var fft_1, hasRequiredFft;
function requireFft() {
  if (hasRequiredFft)
    return fft_1;
  hasRequiredFft = 1;
  var r = requireUtils(), n = function(T) {
    var N = {};
    T.real === void 0 || T.imag === void 0 ? N = r.constructComplexArray(T) : (N.real = T.real.slice(), N.imag = T.imag.slice());
    var le = N.real.length, fe = Math.log2(le);
    if (Math.round(fe) != fe)
      throw new Error("Input size must be a power of 2.");
    if (N.real.length != N.imag.length)
      throw new Error("Real and imaginary components must have the same length.");
    for (var Oe = r.bitReverseArray(le), pe = {
      real: [],
      imag: []
    }, Ie = 0; Ie < le; Ie++)
      pe.real[Oe[Ie]] = N.real[Ie], pe.imag[Oe[Ie]] = N.imag[Ie];
    for (var ve = 0; ve < le; ve++)
      N.real[ve] = pe.real[ve], N.imag[ve] = pe.imag[ve];
    for (var Be = 1; Be <= fe; Be++)
      for (var We = Math.pow(2, Be), je = 0; je < We / 2; je++)
        for (var Qe = r.euler(je, We), ut = 0; ut < le / We; ut++) {
          var vt = We * ut + je, Ne = We * ut + je + We / 2, Ze = {
            real: N.real[vt],
            imag: N.imag[vt]
          }, Ct = {
            real: N.real[Ne],
            imag: N.imag[Ne]
          }, yt = r.multiply(Qe, Ct), I = r.subtract(Ze, yt);
          N.real[Ne] = I.real, N.imag[Ne] = I.imag;
          var O = r.add(yt, Ze);
          N.real[vt] = O.real, N.imag[vt] = O.imag;
        }
    return N;
  }, d = function(T) {
    if (T.real === void 0 || T.imag === void 0)
      throw new Error("IFFT only accepts a complex input.");
    for (var N = T.real.length, le = {
      real: [],
      imag: []
    }, fe = 0; fe < N; fe++) {
      var Oe = {
        real: T.real[fe],
        imag: T.imag[fe]
      }, pe = r.conj(Oe);
      le.real[fe] = pe.real, le.imag[fe] = pe.imag;
    }
    var Ie = n(le);
    return le.real = Ie.real.map(function(ve) {
      return ve / N;
    }), le.imag = Ie.imag.map(function(ve) {
      return ve / N;
    }), le;
  };
  return fft_1 = {
    fft: n,
    ifft: d
  }, fft_1;
}
(function(r, n) {
  (function(d, _) {
    r.exports = _(requireDct(), requireFft());
  })(commonjsGlobal, function(d, _) {
    function T(I, O, ee) {
      if (ee || arguments.length === 2)
        for (var M, oe = 0, xe = O.length; oe < xe; oe++)
          !M && oe in O || (M || (M = Array.prototype.slice.call(O, 0, oe)), M[oe] = O[oe]);
      return I.concat(M || Array.prototype.slice.call(O));
    }
    var N = Object.freeze({ __proto__: null, blackman: function(I) {
      for (var O = new Float32Array(I), ee = 2 * Math.PI / (I - 1), M = 2 * ee, oe = 0; oe < I / 2; oe++)
        O[oe] = 0.42 - 0.5 * Math.cos(oe * ee) + 0.08 * Math.cos(oe * M);
      for (oe = Math.ceil(I / 2); oe > 0; oe--)
        O[I - oe] = O[oe - 1];
      return O;
    }, hamming: function(I) {
      for (var O = new Float32Array(I), ee = 0; ee < I; ee++)
        O[ee] = 0.54 - 0.46 * Math.cos(2 * Math.PI * (ee / I - 1));
      return O;
    }, hanning: function(I) {
      for (var O = new Float32Array(I), ee = 0; ee < I; ee++)
        O[ee] = 0.5 - 0.5 * Math.cos(2 * Math.PI * ee / (I - 1));
      return O;
    }, sine: function(I) {
      for (var O = Math.PI / (I - 1), ee = new Float32Array(I), M = 0; M < I; M++)
        ee[M] = Math.sin(O * M);
      return ee;
    } }), le = {};
    function fe(I) {
      for (; I % 2 == 0 && I > 1; )
        I /= 2;
      return I === 1;
    }
    function Oe(I, O) {
      if (O !== "rect") {
        if (O !== "" && O || (O = "hanning"), le[O] || (le[O] = {}), !le[O][I.length])
          try {
            le[O][I.length] = N[O](I.length);
          } catch {
            throw new Error("Invalid windowing function");
          }
        I = function(ee, M) {
          for (var oe = [], xe = 0; xe < Math.min(ee.length, M.length); xe++)
            oe[xe] = ee[xe] * M[xe];
          return oe;
        }(I, le[O][I.length]);
      }
      return I;
    }
    function pe(I, O, ee) {
      for (var M = new Float32Array(I), oe = 0; oe < M.length; oe++)
        M[oe] = oe * O / ee, M[oe] = 13 * Math.atan(M[oe] / 1315.8) + 3.5 * Math.atan(Math.pow(M[oe] / 7518, 2));
      return M;
    }
    function Ie(I) {
      return Float32Array.from(I);
    }
    function ve(I) {
      return 1125 * Math.log(1 + I / 700);
    }
    function Be(I, O, ee) {
      for (var M, oe = new Float32Array(I + 2), xe = new Float32Array(I + 2), He = O / 2, qe = ve(0), Se = (ve(He) - qe) / (I + 1), Fe = new Array(I + 2), Ve = 0; Ve < oe.length; Ve++)
        oe[Ve] = Ve * Se, xe[Ve] = (M = oe[Ve], 700 * (Math.exp(M / 1125) - 1)), Fe[Ve] = Math.floor((ee + 1) * xe[Ve] / O);
      for (var _t = new Array(I), ze = 0; ze < _t.length; ze++) {
        for (_t[ze] = new Array(ee / 2 + 1).fill(0), Ve = Fe[ze]; Ve < Fe[ze + 1]; Ve++)
          _t[ze][Ve] = (Ve - Fe[ze]) / (Fe[ze + 1] - Fe[ze]);
        for (Ve = Fe[ze + 1]; Ve < Fe[ze + 2]; Ve++)
          _t[ze][Ve] = (Fe[ze + 2] - Ve) / (Fe[ze + 2] - Fe[ze + 1]);
      }
      return _t;
    }
    function We(I, O, ee, M, oe, xe, He) {
      M === void 0 && (M = 5), oe === void 0 && (oe = 2), xe === void 0 && (xe = !0), He === void 0 && (He = 440);
      var qe = Math.floor(ee / 2) + 1, Se = new Array(ee).fill(0).map(function(dt, xt) {
        return I * function(Lt, kt) {
          return Math.log2(16 * Lt / kt);
        }(O * xt / ee, He);
      });
      Se[0] = Se[1] - 1.5 * I;
      var Fe, Ve, _t, ze = Se.slice(1).map(function(dt, xt) {
        return Math.max(dt - Se[xt]);
      }, 1).concat([1]), qt = Math.round(I / 2), Ft = new Array(I).fill(0).map(function(dt, xt) {
        return Se.map(function(Lt) {
          return (10 * I + qt + Lt - xt) % I - qt;
        });
      }), Gt = Ft.map(function(dt, xt) {
        return dt.map(function(Lt, kt) {
          return Math.exp(-0.5 * Math.pow(2 * Ft[xt][kt] / ze[kt], 2));
        });
      });
      if (Ve = (Fe = Gt)[0].map(function() {
        return 0;
      }), _t = Fe.reduce(function(dt, xt) {
        return xt.forEach(function(Lt, kt) {
          dt[kt] += Math.pow(Lt, 2);
        }), dt;
      }, Ve).map(Math.sqrt), Gt = Fe.map(function(dt, xt) {
        return dt.map(function(Lt, kt) {
          return Lt / (_t[kt] || 1);
        });
      }), oe) {
        var yn = Se.map(function(dt) {
          return Math.exp(-0.5 * Math.pow((dt / I - M) / oe, 2));
        });
        Gt = Gt.map(function(dt) {
          return dt.map(function(xt, Lt) {
            return xt * yn[Lt];
          });
        });
      }
      return xe && (Gt = T(T([], Gt.slice(3), !0), Gt.slice(0, 3), !0)), Gt.map(function(dt) {
        return dt.slice(0, qe);
      });
    }
    function je(I, O) {
      for (var ee = 0, M = 0, oe = 0; oe < O.length; oe++)
        ee += Math.pow(oe, I) * Math.abs(O[oe]), M += O[oe];
      return ee / M;
    }
    function Qe(I) {
      var O = I.ampSpectrum, ee = I.barkScale, M = I.numberOfBarkBands, oe = M === void 0 ? 24 : M;
      if (typeof O != "object" || typeof ee != "object")
        throw new TypeError();
      var xe = oe, He = new Float32Array(xe), qe = 0, Se = O, Fe = new Int32Array(xe + 1);
      Fe[0] = 0;
      for (var Ve = ee[Se.length - 1] / xe, _t = 1, ze = 0; ze < Se.length; ze++)
        for (; ee[ze] > Ve; )
          Fe[_t++] = ze, Ve = _t * ee[Se.length - 1] / xe;
      for (Fe[xe] = Se.length - 1, ze = 0; ze < xe; ze++) {
        for (var qt = 0, Ft = Fe[ze]; Ft < Fe[ze + 1]; Ft++)
          qt += Se[Ft];
        He[ze] = Math.pow(qt, 0.23);
      }
      for (ze = 0; ze < He.length; ze++)
        qe += He[ze];
      return { specific: He, total: qe };
    }
    function ut(I) {
      var O = I.ampSpectrum;
      if (typeof O != "object")
        throw new TypeError();
      for (var ee = new Float32Array(O.length), M = 0; M < ee.length; M++)
        ee[M] = Math.pow(O[M], 2);
      return ee;
    }
    function vt(I) {
      var O = I.ampSpectrum, ee = I.melFilterBank, M = I.bufferSize;
      if (typeof O != "object")
        throw new TypeError("Valid ampSpectrum is required to generate melBands");
      if (typeof ee != "object")
        throw new TypeError("Valid melFilterBank is required to generate melBands");
      for (var oe = ut({ ampSpectrum: O }), xe = ee.length, He = Array(xe), qe = new Float32Array(xe), Se = 0; Se < qe.length; Se++) {
        He[Se] = new Float32Array(M / 2), qe[Se] = 0;
        for (var Fe = 0; Fe < M / 2; Fe++)
          He[Se][Fe] = ee[Se][Fe] * oe[Fe], qe[Se] += He[Se][Fe];
        qe[Se] = Math.log(qe[Se] + 1);
      }
      return Array.prototype.slice.call(qe);
    }
    var Ne = Object.freeze({ __proto__: null, amplitudeSpectrum: function(I) {
      return I.ampSpectrum;
    }, buffer: function(I) {
      return I.signal;
    }, chroma: function(I) {
      var O = I.ampSpectrum, ee = I.chromaFilterBank;
      if (typeof O != "object")
        throw new TypeError("Valid ampSpectrum is required to generate chroma");
      if (typeof ee != "object")
        throw new TypeError("Valid chromaFilterBank is required to generate chroma");
      var M = ee.map(function(xe, He) {
        return O.reduce(function(qe, Se, Fe) {
          return qe + Se * xe[Fe];
        }, 0);
      }), oe = Math.max.apply(Math, M);
      return oe ? M.map(function(xe) {
        return xe / oe;
      }) : M;
    }, complexSpectrum: function(I) {
      return I.complexSpectrum;
    }, energy: function(I) {
      var O = I.signal;
      if (typeof O != "object")
        throw new TypeError();
      for (var ee = 0, M = 0; M < O.length; M++)
        ee += Math.pow(Math.abs(O[M]), 2);
      return ee;
    }, loudness: Qe, melBands: vt, mfcc: function(I) {
      var O = I.ampSpectrum, ee = I.melFilterBank, M = I.numberOfMFCCCoefficients, oe = I.bufferSize, xe = Math.min(40, Math.max(1, M || 13));
      if (ee.length < xe)
        throw new Error("Insufficient filter bank for requested number of coefficients");
      var He = vt({ ampSpectrum: O, melFilterBank: ee, bufferSize: oe });
      return d(He).slice(0, xe);
    }, perceptualSharpness: function(I) {
      for (var O = Qe({ ampSpectrum: I.ampSpectrum, barkScale: I.barkScale }), ee = O.specific, M = 0, oe = 0; oe < ee.length; oe++)
        M += oe < 15 ? (oe + 1) * ee[oe + 1] : 0.066 * Math.exp(0.171 * (oe + 1));
      return M *= 0.11 / O.total;
    }, perceptualSpread: function(I) {
      for (var O = Qe({ ampSpectrum: I.ampSpectrum, barkScale: I.barkScale }), ee = 0, M = 0; M < O.specific.length; M++)
        O.specific[M] > ee && (ee = O.specific[M]);
      return Math.pow((O.total - ee) / O.total, 2);
    }, powerSpectrum: ut, rms: function(I) {
      var O = I.signal;
      if (typeof O != "object")
        throw new TypeError();
      for (var ee = 0, M = 0; M < O.length; M++)
        ee += Math.pow(O[M], 2);
      return ee /= O.length, ee = Math.sqrt(ee);
    }, spectralCentroid: function(I) {
      var O = I.ampSpectrum;
      if (typeof O != "object")
        throw new TypeError();
      return je(1, O);
    }, spectralCrest: function(I) {
      var O = I.ampSpectrum;
      if (typeof O != "object")
        throw new TypeError();
      var ee = 0, M = -1 / 0;
      return O.forEach(function(oe) {
        ee += Math.pow(oe, 2), M = oe > M ? oe : M;
      }), ee /= O.length, ee = Math.sqrt(ee), M / ee;
    }, spectralFlatness: function(I) {
      var O = I.ampSpectrum;
      if (typeof O != "object")
        throw new TypeError();
      for (var ee = 0, M = 0, oe = 0; oe < O.length; oe++)
        ee += Math.log(O[oe]), M += O[oe];
      return Math.exp(ee / O.length) * O.length / M;
    }, spectralFlux: function(I) {
      var O = I.signal, ee = I.previousSignal, M = I.bufferSize;
      if (typeof O != "object" || typeof ee != "object")
        throw new TypeError();
      for (var oe = 0, xe = -M / 2; xe < O.length / 2 - 1; xe++)
        x = Math.abs(O[xe]) - Math.abs(ee[xe]), oe += (x + Math.abs(x)) / 2;
      return oe;
    }, spectralKurtosis: function(I) {
      var O = I.ampSpectrum;
      if (typeof O != "object")
        throw new TypeError();
      var ee = O, M = je(1, ee), oe = je(2, ee), xe = je(3, ee), He = je(4, ee);
      return (-3 * Math.pow(M, 4) + 6 * M * oe - 4 * M * xe + He) / Math.pow(Math.sqrt(oe - Math.pow(M, 2)), 4);
    }, spectralRolloff: function(I) {
      var O = I.ampSpectrum, ee = I.sampleRate;
      if (typeof O != "object")
        throw new TypeError();
      for (var M = O, oe = ee / (2 * (M.length - 1)), xe = 0, He = 0; He < M.length; He++)
        xe += M[He];
      for (var qe = 0.99 * xe, Se = M.length - 1; xe > qe && Se >= 0; )
        xe -= M[Se], --Se;
      return (Se + 1) * oe;
    }, spectralSkewness: function(I) {
      var O = I.ampSpectrum;
      if (typeof O != "object")
        throw new TypeError();
      var ee = je(1, O), M = je(2, O), oe = je(3, O);
      return (2 * Math.pow(ee, 3) - 3 * ee * M + oe) / Math.pow(Math.sqrt(M - Math.pow(ee, 2)), 3);
    }, spectralSlope: function(I) {
      var O = I.ampSpectrum, ee = I.sampleRate, M = I.bufferSize;
      if (typeof O != "object")
        throw new TypeError();
      for (var oe = 0, xe = 0, He = new Float32Array(O.length), qe = 0, Se = 0, Fe = 0; Fe < O.length; Fe++) {
        oe += O[Fe];
        var Ve = Fe * ee / M;
        He[Fe] = Ve, qe += Ve * Ve, xe += Ve, Se += Ve * O[Fe];
      }
      return (O.length * Se - xe * oe) / (oe * (qe - Math.pow(xe, 2)));
    }, spectralSpread: function(I) {
      var O = I.ampSpectrum;
      if (typeof O != "object")
        throw new TypeError();
      return Math.sqrt(je(2, O) - Math.pow(je(1, O), 2));
    }, zcr: function(I) {
      var O = I.signal;
      if (typeof O != "object")
        throw new TypeError();
      for (var ee = 0, M = 1; M < O.length; M++)
        (O[M - 1] >= 0 && O[M] < 0 || O[M - 1] < 0 && O[M] >= 0) && ee++;
      return ee;
    } }), Ze = function() {
      function I(O, ee) {
        var M = this;
        if (this._m = ee, !O.audioContext)
          throw this._m.errors.noAC;
        if (O.bufferSize && !fe(O.bufferSize))
          throw this._m._errors.notPow2;
        if (!O.source)
          throw this._m._errors.noSource;
        this._m.audioContext = O.audioContext, this._m.bufferSize = O.bufferSize || this._m.bufferSize || 256, this._m.hopSize = O.hopSize || this._m.hopSize || this._m.bufferSize, this._m.sampleRate = O.sampleRate || this._m.audioContext.sampleRate || 44100, this._m.callback = O.callback, this._m.windowingFunction = O.windowingFunction || "hanning", this._m.featureExtractors = Ne, this._m.EXTRACTION_STARTED = O.startImmediately || !1, this._m.channel = typeof O.channel == "number" ? O.channel : 0, this._m.inputs = O.inputs || 1, this._m.outputs = O.outputs || 1, this._m.numberOfMFCCCoefficients = O.numberOfMFCCCoefficients || this._m.numberOfMFCCCoefficients || 13, this._m.numberOfBarkBands = O.numberOfBarkBands || this._m.numberOfBarkBands || 24, this._m.spn = this._m.audioContext.createScriptProcessor(this._m.bufferSize, this._m.inputs, this._m.outputs), this._m.spn.connect(this._m.audioContext.destination), this._m._featuresToExtract = O.featureExtractors || [], this._m.barkScale = pe(this._m.bufferSize, this._m.sampleRate, this._m.bufferSize), this._m.melFilterBank = Be(Math.max(this._m.melBands, this._m.numberOfMFCCCoefficients), this._m.sampleRate, this._m.bufferSize), this._m.inputData = null, this._m.previousInputData = null, this._m.frame = null, this._m.previousFrame = null, this.setSource(O.source), this._m.spn.onaudioprocess = function(oe) {
          var xe;
          M._m.inputData !== null && (M._m.previousInputData = M._m.inputData), M._m.inputData = oe.inputBuffer.getChannelData(M._m.channel), M._m.previousInputData ? ((xe = new Float32Array(M._m.previousInputData.length + M._m.inputData.length - M._m.hopSize)).set(M._m.previousInputData.slice(M._m.hopSize)), xe.set(M._m.inputData, M._m.previousInputData.length - M._m.hopSize)) : xe = M._m.inputData;
          var He = function(qe, Se, Fe) {
            if (qe.length < Se)
              throw new Error("Buffer is too short for frame length");
            if (Fe < 1)
              throw new Error("Hop length cannot be less that 1");
            if (Se < 1)
              throw new Error("Frame length cannot be less that 1");
            var Ve = 1 + Math.floor((qe.length - Se) / Fe);
            return new Array(Ve).fill(0).map(function(_t, ze) {
              return qe.slice(ze * Fe, ze * Fe + Se);
            });
          }(xe, M._m.bufferSize, M._m.hopSize);
          He.forEach(function(qe) {
            M._m.frame = qe;
            var Se = M._m.extract(M._m._featuresToExtract, M._m.frame, M._m.previousFrame);
            typeof M._m.callback == "function" && M._m.EXTRACTION_STARTED && M._m.callback(Se), M._m.previousFrame = M._m.frame;
          });
        };
      }
      return I.prototype.start = function(O) {
        this._m._featuresToExtract = O || this._m._featuresToExtract, this._m.EXTRACTION_STARTED = !0;
      }, I.prototype.stop = function() {
        this._m.EXTRACTION_STARTED = !1;
      }, I.prototype.setSource = function(O) {
        this._m.source && this._m.source.disconnect(this._m.spn), this._m.source = O, this._m.source.connect(this._m.spn);
      }, I.prototype.setChannel = function(O) {
        O <= this._m.inputs ? this._m.channel = O : console.error("Channel ".concat(O, " does not exist. Make sure you've provided a value for 'inputs' that is greater than ").concat(O, " when instantiating the MeydaAnalyzer"));
      }, I.prototype.get = function(O) {
        return this._m.inputData ? this._m.extract(O || this._m._featuresToExtract, this._m.inputData, this._m.previousInputData) : null;
      }, I;
    }(), Ct = { audioContext: null, spn: null, bufferSize: 512, sampleRate: 44100, melBands: 26, chromaBands: 12, callback: null, windowingFunction: "hanning", featureExtractors: Ne, EXTRACTION_STARTED: !1, numberOfMFCCCoefficients: 13, numberOfBarkBands: 24, _featuresToExtract: [], windowing: Oe, _errors: { notPow2: new Error("Meyda: Buffer size must be a power of 2, e.g. 64 or 512"), featureUndef: new Error("Meyda: No features defined."), invalidFeatureFmt: new Error("Meyda: Invalid feature format"), invalidInput: new Error("Meyda: Invalid input."), noAC: new Error("Meyda: No AudioContext specified."), noSource: new Error("Meyda: No source node specified.") }, createMeydaAnalyzer: function(I) {
      return new Ze(I, Object.assign({}, Ct));
    }, listAvailableFeatureExtractors: function() {
      return Object.keys(this.featureExtractors);
    }, extract: function(I, O, ee) {
      var M = this;
      if (!O)
        throw this._errors.invalidInput;
      if (typeof O != "object")
        throw this._errors.invalidInput;
      if (!I)
        throw this._errors.featureUndef;
      if (!fe(O.length))
        throw this._errors.notPow2;
      this.barkScale !== void 0 && this.barkScale.length == this.bufferSize || (this.barkScale = pe(this.bufferSize, this.sampleRate, this.bufferSize)), this.melFilterBank !== void 0 && this.barkScale.length == this.bufferSize && this.melFilterBank.length == this.melBands || (this.melFilterBank = Be(Math.max(this.melBands, this.numberOfMFCCCoefficients), this.sampleRate, this.bufferSize)), this.chromaFilterBank !== void 0 && this.chromaFilterBank.length == this.chromaBands || (this.chromaFilterBank = We(this.chromaBands, this.sampleRate, this.bufferSize)), "buffer" in O && O.buffer === void 0 ? this.signal = Ie(O) : this.signal = O;
      var oe = yt(O, this.windowingFunction, this.bufferSize);
      if (this.signal = oe.windowedSignal, this.complexSpectrum = oe.complexSpectrum, this.ampSpectrum = oe.ampSpectrum, ee) {
        var xe = yt(ee, this.windowingFunction, this.bufferSize);
        this.previousSignal = xe.windowedSignal, this.previousComplexSpectrum = xe.complexSpectrum, this.previousAmpSpectrum = xe.ampSpectrum;
      }
      var He = function(qe) {
        return M.featureExtractors[qe]({ ampSpectrum: M.ampSpectrum, chromaFilterBank: M.chromaFilterBank, complexSpectrum: M.complexSpectrum, signal: M.signal, bufferSize: M.bufferSize, sampleRate: M.sampleRate, barkScale: M.barkScale, melFilterBank: M.melFilterBank, previousSignal: M.previousSignal, previousAmpSpectrum: M.previousAmpSpectrum, previousComplexSpectrum: M.previousComplexSpectrum, numberOfMFCCCoefficients: M.numberOfMFCCCoefficients, numberOfBarkBands: M.numberOfBarkBands });
      };
      if (typeof I == "object")
        return I.reduce(function(qe, Se) {
          var Fe;
          return Object.assign({}, qe, ((Fe = {})[Se] = He(Se), Fe));
        }, {});
      if (typeof I == "string")
        return He(I);
      throw this._errors.invalidFeatureFmt;
    } }, yt = function(I, O, ee) {
      var M = {};
      I.buffer === void 0 ? M.signal = Ie(I) : M.signal = I, M.windowedSignal = Oe(M.signal, O), M.complexSpectrum = _.fft(M.windowedSignal), M.ampSpectrum = new Float32Array(ee / 2);
      for (var oe = 0; oe < ee / 2; oe++)
        M.ampSpectrum[oe] = Math.sqrt(Math.pow(M.complexSpectrum.real[oe], 2) + Math.pow(M.complexSpectrum.imag[oe], 2));
      return M;
    };
    return typeof window < "u" && (window.Meyda = Ct), Ct;
  });
})(meyda_min);
var meyda_minExports = meyda_min.exports;
const Meyda = /* @__PURE__ */ getDefaultExportFromCjs(meyda_minExports);
class Audio {
  constructor({
    numBins: n = 4,
    cutoff: d = 2,
    smooth: _ = 0.4,
    max: T = 15,
    scale: N = 10,
    isDrawing: le = !1,
    parentEl: fe = document.body
  }) {
    this.vol = 0, this.scale = N, this.max = T, this.cutoff = d, this.smooth = _, this.setBins(n), this.beat = {
      holdFrames: 20,
      threshold: 40,
      _cutoff: 0,
      // adaptive based on sound state
      decay: 0.98,
      _framesSinceBeat: 0
      // keeps track of frames
    }, this.onBeat = () => {
    }, this.canvas = document.createElement("canvas"), this.canvas.width = 100, this.canvas.height = 80, this.canvas.style.width = "100px", this.canvas.style.height = "80px", this.canvas.style.position = "absolute", this.canvas.style.right = "0px", this.canvas.style.bottom = "0px", fe.appendChild(this.canvas), this.isDrawing = le, this.ctx = this.canvas.getContext("2d"), this.ctx.fillStyle = "#DFFFFF", this.ctx.strokeStyle = "#0ff", this.ctx.lineWidth = 0.5, window.navigator.mediaDevices && window.navigator.mediaDevices.getUserMedia({ video: !1, audio: !0 }).then((Oe) => {
      this.stream = Oe, this.context = new AudioContext();
      let pe = this.context.createMediaStreamSource(Oe);
      this.meyda = Meyda.createMeydaAnalyzer({
        audioContext: this.context,
        source: pe,
        featureExtractors: [
          "loudness"
          //  'perceptualSpread',
          //  'perceptualSharpness',
          //  'spectralCentroid'
        ]
      });
    }).catch((Oe) => console.log("ERROR", Oe));
  }
  detectBeat(n) {
    n > this.beat._cutoff && n > this.beat.threshold ? (this.onBeat(), this.beat._cutoff = n * 1.2, this.beat._framesSinceBeat = 0) : this.beat._framesSinceBeat <= this.beat.holdFrames ? this.beat._framesSinceBeat++ : (this.beat._cutoff *= this.beat.decay, this.beat._cutoff = Math.max(this.beat._cutoff, this.beat.threshold));
  }
  tick() {
    if (this.meyda) {
      var n = this.meyda.get();
      if (n && n !== null) {
        this.vol = n.loudness.total, this.detectBeat(this.vol);
        const d = (T, N) => T + N;
        let _ = Math.floor(n.loudness.specific.length / this.bins.length);
        this.prevBins = this.bins.slice(0), this.bins = this.bins.map((T, N) => n.loudness.specific.slice(N * _, (N + 1) * _).reduce(d)).map((T, N) => T * (1 - this.settings[N].smooth) + this.prevBins[N] * this.settings[N].smooth), this.fft = this.bins.map((T, N) => (
          // Math.max(0, (bin - this.cutoff) / (this.max - this.cutoff))
          Math.max(0, (T - this.settings[N].cutoff) / this.settings[N].scale)
        )), this.isDrawing && this.draw();
      }
    }
  }
  setCutoff(n) {
    this.cutoff = n, this.settings = this.settings.map((d) => (d.cutoff = n, d));
  }
  setSmooth(n) {
    this.smooth = n, this.settings = this.settings.map((d) => (d.smooth = n, d));
  }
  setBins(n) {
    this.bins = Array(n).fill(0), this.prevBins = Array(n).fill(0), this.fft = Array(n).fill(0), this.settings = Array(n).fill(0).map(() => ({
      cutoff: this.cutoff,
      scale: this.scale,
      smooth: this.smooth
    })), this.bins.forEach((d, _) => {
      window["a" + _] = (T = 1, N = 0) => () => a.fft[_] * T + N;
    });
  }
  setScale(n) {
    this.scale = n, this.settings = this.settings.map((d) => (d.scale = n, d));
  }
  setMax(n) {
    this.max = n, console.log("set max is deprecated");
  }
  hide() {
    this.isDrawing = !1, this.canvas.style.display = "none";
  }
  show() {
    this.isDrawing = !0, this.canvas.style.display = "block";
  }
  draw() {
    this.ctx.clearRect(0, 0, this.canvas.width, this.canvas.height);
    var n = this.canvas.width / this.bins.length, d = this.canvas.height / (this.max * 2);
    this.bins.forEach((_, T) => {
      var N = _ * d;
      this.ctx.fillRect(T * n, this.canvas.height - N, n, N);
      var le = this.canvas.height - d * this.settings[T].cutoff;
      this.ctx.beginPath(), this.ctx.moveTo(T * n, le), this.ctx.lineTo((T + 1) * n, le), this.ctx.stroke();
      var fe = this.canvas.height - d * (this.settings[T].scale + this.settings[T].cutoff);
      this.ctx.beginPath(), this.ctx.moveTo(T * n, fe), this.ctx.lineTo((T + 1) * n, fe), this.ctx.stroke();
    });
  }
}
class VideoRecorder {
  constructor(n) {
    this.mediaSource = new MediaSource(), this.stream = n, this.output = document.createElement("video"), this.output.autoplay = !0, this.output.loop = !0;
    let d = this;
    this.mediaSource.addEventListener("sourceopen", () => {
      console.log("MediaSource opened"), d.sourceBuffer = d.mediaSource.addSourceBuffer('video/webm; codecs="vp8"'), console.log("Source buffer: ", sourceBuffer);
    });
  }
  start() {
    let n = { mimeType: "video/webm;codecs=vp9" };
    this.recordedBlobs = [];
    try {
      this.mediaRecorder = new MediaRecorder(this.stream, n);
    } catch (d) {
      console.log("Unable to create MediaRecorder with options Object: ", d);
      try {
        n = { mimeType: "video/webm,codecs=vp9" }, this.mediaRecorder = new MediaRecorder(this.stream, n);
      } catch (_) {
        console.log("Unable to create MediaRecorder with options Object: ", _);
        try {
          n = "video/vp8", this.mediaRecorder = new MediaRecorder(this.stream, n);
        } catch (T) {
          alert(`MediaRecorder is not supported by this browser.

Try Firefox 29 or later, or Chrome 47 or later, with Enable experimental Web Platform features enabled from chrome://flags.`), console.error("Exception while creating MediaRecorder:", T);
          return;
        }
      }
    }
    console.log("Created MediaRecorder", this.mediaRecorder, "with options", n), this.mediaRecorder.onstop = this._handleStop.bind(this), this.mediaRecorder.ondataavailable = this._handleDataAvailable.bind(this), this.mediaRecorder.start(100), console.log("MediaRecorder started", this.mediaRecorder);
  }
  stop() {
    this.mediaRecorder.stop();
  }
  _handleStop() {
    const n = new Blob(this.recordedBlobs, { type: this.mediaRecorder.mimeType }), d = window.URL.createObjectURL(n);
    this.output.src = d;
    const _ = document.createElement("a");
    _.style.display = "none", _.href = d;
    let T = /* @__PURE__ */ new Date();
    _.download = `hydra-${T.getFullYear()}-${T.getMonth() + 1}-${T.getDate()}-${T.getHours()}.${T.getMinutes()}.${T.getSeconds()}.webm`, document.body.appendChild(_), _.click(), setTimeout(() => {
      document.body.removeChild(_), window.URL.revokeObjectURL(d);
    }, 300);
  }
  _handleDataAvailable(n) {
    n.data && n.data.size > 0 && this.recordedBlobs.push(n.data);
  }
}
const easing = {
  // no easing, no acceleration
  linear: function(r) {
    return r;
  },
  // accelerating from zero velocity
  easeInQuad: function(r) {
    return r * r;
  },
  // decelerating to zero velocity
  easeOutQuad: function(r) {
    return r * (2 - r);
  },
  // acceleration until halfway, then deceleration
  easeInOutQuad: function(r) {
    return r < 0.5 ? 2 * r * r : -1 + (4 - 2 * r) * r;
  },
  // accelerating from zero velocity
  easeInCubic: function(r) {
    return r * r * r;
  },
  // decelerating to zero velocity
  easeOutCubic: function(r) {
    return --r * r * r + 1;
  },
  // acceleration until halfway, then deceleration
  easeInOutCubic: function(r) {
    return r < 0.5 ? 4 * r * r * r : (r - 1) * (2 * r - 2) * (2 * r - 2) + 1;
  },
  // accelerating from zero velocity
  easeInQuart: function(r) {
    return r * r * r * r;
  },
  // decelerating to zero velocity
  easeOutQuart: function(r) {
    return 1 - --r * r * r * r;
  },
  // acceleration until halfway, then deceleration
  easeInOutQuart: function(r) {
    return r < 0.5 ? 8 * r * r * r * r : 1 - 8 * --r * r * r * r;
  },
  // accelerating from zero velocity
  easeInQuint: function(r) {
    return r * r * r * r * r;
  },
  // decelerating to zero velocity
  easeOutQuint: function(r) {
    return 1 + --r * r * r * r * r;
  },
  // acceleration until halfway, then deceleration
  easeInOutQuint: function(r) {
    return r < 0.5 ? 16 * r * r * r * r * r : 1 + 16 * --r * r * r * r * r;
  },
  // sin shape
  sin: function(r) {
    return (1 + Math.sin(Math.PI * r - Math.PI / 2)) / 2;
  }
};
var map = (r, n, d, _, T) => (r - n) * (T - _) / (d - n) + _;
const ArrayUtils = {
  init: () => {
    Array.prototype.fast = function(r = 1) {
      return this._speed = r, this;
    }, Array.prototype.smooth = function(r = 1) {
      return this._smooth = r, this;
    }, Array.prototype.ease = function(r = "linear") {
      return typeof r == "function" ? (this._smooth = 1, this._ease = r) : easing[r] && (this._smooth = 1, this._ease = easing[r]), this;
    }, Array.prototype.offset = function(r = 0.5) {
      return this._offset = r % 1, this;
    }, Array.prototype.fit = function(r = 0, n = 1) {
      let d = Math.min(...this), _ = Math.max(...this);
      var T = this.map((N) => map(N, d, _, r, n));
      return T._speed = this._speed, T._smooth = this._smooth, T._ease = this._ease, T;
    };
  },
  getValue: (r = []) => ({ time: n, bpm: d }) => {
    let _ = r._speed ? r._speed : 1, T = r._smooth ? r._smooth : 0, N = n * _ * (d / 60) + (r._offset || 0);
    if (T !== 0) {
      let le = r._ease ? r._ease : easing.linear, fe = N - T / 2, Oe = r[Math.floor(fe % r.length)], pe = r[Math.floor((fe + 1) % r.length)], Ie = Math.min(fe % 1 / T, 1);
      return le(Ie) * (pe - Oe) + Oe;
    } else
      return r[Math.floor(N % r.length)], r[Math.floor(N % r.length)];
  }
}, Sandbox = (r) => {
  var n = "", d = T(n), _ = (N, le) => {
    n += `
      var ${N} = ${le}
    `, d = T(n);
  };
  return {
    addToContext: _,
    eval: (N) => d.eval(N)
  };
  function T(N) {
    globalThis.eval(N);
    var le = function(fe) {
      globalThis.eval(fe);
    };
    return {
      eval: le
    };
  }
};
class EvalSandbox {
  constructor(n, d, _ = []) {
    this.makeGlobal = d, this.sandbox = Sandbox(), this.parent = n;
    var T = Object.keys(n);
    T.forEach((N) => this.add(N)), this.userProps = _;
  }
  add(n) {
    this.makeGlobal && (window[n] = this.parent[n]);
  }
  // sets on window as well as synth object if global (not needed for objects, which can be set directly)
  set(n, d) {
    this.makeGlobal && (window[n] = d), this.parent[n] = d;
  }
  tick() {
    this.makeGlobal && this.userProps.forEach((n) => {
      this.parent[n] = window[n];
    });
  }
  eval(n) {
    this.sandbox.eval(n);
  }
}
const DEFAULT_CONVERSIONS = {
  float: {
    vec4: { name: "sum", args: [[1, 1, 1, 1]] },
    vec2: { name: "sum", args: [[1, 1]] }
  }
}, ensure_decimal_dot = (r) => (r = r.toString(), r.indexOf(".") < 0 && (r += "."), r);
function formatArguments(r, n, d) {
  const _ = r.transform.inputs, T = r.userArgs, { generators: N } = r.synth, { src: le } = N;
  return _.map((fe, Oe) => {
    const pe = {
      value: fe.default,
      type: fe.type,
      //
      isUniform: !1,
      name: fe.name,
      vecLen: 0
      //  generateGlsl: null // function for creating glsl
    };
    if (pe.type === "float" && (pe.value = ensure_decimal_dot(fe.default)), fe.type.startsWith("vec"))
      try {
        pe.vecLen = Number.parseInt(fe.type.substr(3));
      } catch {
        console.log(`Error determining length of vector input type ${fe.type} (${fe.name})`);
      }
    if (T.length > Oe && (pe.value = T[Oe], typeof T[Oe] == "function" ? (pe.value = (Be, We, je) => {
      try {
        const Qe = T[Oe](We);
        return typeof Qe == "number" ? Qe : (console.warn("function does not return a number", T[Oe]), fe.default);
      } catch (Qe) {
        return console.warn("ERROR", Qe), fe.default;
      }
    }, pe.isUniform = !0) : T[Oe].constructor === Array && (pe.value = (Be, We, je) => ArrayUtils.getValue(T[Oe])(We), pe.isUniform = !0)), !(n < 0)) {
      if (pe.value && pe.value.transforms) {
        const Be = pe.value.transforms[pe.value.transforms.length - 1];
        if (Be.transform.glsl_return_type !== fe.type) {
          const We = DEFAULT_CONVERSIONS[fe.type];
          if (typeof We < "u") {
            const je = We[Be.transform.glsl_return_type];
            if (typeof je < "u") {
              const { name: Qe, args: ut } = je;
              pe.value = pe.value[Qe](...ut);
            }
          }
        }
        pe.isUniform = !1;
      } else if (pe.type === "float" && typeof pe.value == "number")
        pe.value = ensure_decimal_dot(pe.value);
      else if (pe.type.startsWith("vec") && typeof pe.value == "object" && Array.isArray(pe.value))
        pe.isUniform = !1, pe.value = `${pe.type}(${pe.value.map(ensure_decimal_dot).join(", ")})`;
      else if (fe.type === "sampler2D") {
        var Ie = pe.value;
        pe.value = () => Ie.getTexture(), pe.isUniform = !0;
      } else if (pe.value.getTexture && fe.type === "vec4") {
        var ve = pe.value;
        pe.value = le(ve), pe.isUniform = !1;
      }
      pe.isUniform && (pe.name += n);
    }
    return pe;
  });
}
function generateGlsl(r) {
  var n = {
    uniforms: [],
    // list of uniforms used in shader
    glslFunctions: [],
    // list of functions used in shader
    fragColor: ""
  }, d = generateGlsl$1(r, n)("st");
  n.fragColor = d;
  let _ = {};
  return n.uniforms.forEach((T) => _[T.name] = T), n.uniforms = Object.values(_), n;
}
function generateGlsl$1(r, n) {
  var d = () => "";
  return r.forEach((_) => {
    var T = formatArguments(_, n.uniforms.length);
    T.forEach((fe) => {
      fe.isUniform && n.uniforms.push(fe);
    }), contains(_, n.glslFunctions) || n.glslFunctions.push(_);
    var N = d;
    if (_.transform.type === "src")
      d = (fe) => `${shaderString(fe, _.name, T, n)}`;
    else if (_.transform.type === "coord")
      d = (fe) => `${N(`${shaderString(fe, _.name, T, n)}`)}`;
    else if (_.transform.type === "color")
      d = (fe) => `${shaderString(`${N(fe)}`, _.name, T, n)}`;
    else if (_.transform.type === "combine") {
      var le = T[0].value && T[0].value.transforms ? (fe) => `${generateGlsl$1(T[0].value.transforms, n)(fe)}` : T[0].isUniform ? () => T[0].name : () => T[0].value;
      d = (fe) => `${shaderString(`${N(fe)}, ${le(fe)}`, _.name, T.slice(1), n)}`;
    } else if (_.transform.type === "combineCoord") {
      var le = T[0].value && T[0].value.transforms ? (Oe) => `${generateGlsl$1(T[0].value.transforms, n)(Oe)}` : T[0].isUniform ? () => T[0].name : () => T[0].value;
      d = (Oe) => `${N(`${shaderString(`${Oe}, ${le(Oe)}`, _.name, T.slice(1), n)}`)}`;
    }
  }), d;
}
function shaderString(r, n, d, _) {
  const T = d.map((N) => N.isUniform ? N.name : N.value && N.value.transforms ? `${generateGlsl$1(N.value.transforms, _)("st")}` : N.value).reduce((N, le) => `${N}, ${le}`, "");
  return `${n}(${r}${T})`;
}
function contains(r, n) {
  for (var d = 0; d < n.length; d++)
    if (r.name == n[d].name)
      return !0;
  return !1;
}
const utilityGlsl = {
  _luminance: {
    type: "util",
    glsl: `float _luminance(vec3 rgb){
      const vec3 W = vec3(0.2125, 0.7154, 0.0721);
      return dot(rgb, W);
    }`
  },
  _noise: {
    type: "util",
    glsl: `
    //	Simplex 3D Noise
    //	by Ian McEwan, Ashima Arts
    vec4 permute(vec4 x){return mod(((x*34.0)+1.0)*x, 289.0);}
  vec4 taylorInvSqrt(vec4 r){return 1.79284291400159 - 0.85373472095314 * r;}

  float _noise(vec3 v){
    const vec2  C = vec2(1.0/6.0, 1.0/3.0) ;
    const vec4  D = vec4(0.0, 0.5, 1.0, 2.0);

  // First corner
    vec3 i  = floor(v + dot(v, C.yyy) );
    vec3 x0 =   v - i + dot(i, C.xxx) ;

  // Other corners
    vec3 g = step(x0.yzx, x0.xyz);
    vec3 l = 1.0 - g;
    vec3 i1 = min( g.xyz, l.zxy );
    vec3 i2 = max( g.xyz, l.zxy );

    //  x0 = x0 - 0. + 0.0 * C
    vec3 x1 = x0 - i1 + 1.0 * C.xxx;
    vec3 x2 = x0 - i2 + 2.0 * C.xxx;
    vec3 x3 = x0 - 1. + 3.0 * C.xxx;

  // Permutations
    i = mod(i, 289.0 );
    vec4 p = permute( permute( permute(
               i.z + vec4(0.0, i1.z, i2.z, 1.0 ))
             + i.y + vec4(0.0, i1.y, i2.y, 1.0 ))
             + i.x + vec4(0.0, i1.x, i2.x, 1.0 ));

  // Gradients
  // ( N*N points uniformly over a square, mapped onto an octahedron.)
    float n_ = 1.0/7.0; // N=7
    vec3  ns = n_ * D.wyz - D.xzx;

    vec4 j = p - 49.0 * floor(p * ns.z *ns.z);  //  mod(p,N*N)

    vec4 x_ = floor(j * ns.z);
    vec4 y_ = floor(j - 7.0 * x_ );    // mod(j,N)

    vec4 x = x_ *ns.x + ns.yyyy;
    vec4 y = y_ *ns.x + ns.yyyy;
    vec4 h = 1.0 - abs(x) - abs(y);

    vec4 b0 = vec4( x.xy, y.xy );
    vec4 b1 = vec4( x.zw, y.zw );

    vec4 s0 = floor(b0)*2.0 + 1.0;
    vec4 s1 = floor(b1)*2.0 + 1.0;
    vec4 sh = -step(h, vec4(0.0));

    vec4 a0 = b0.xzyw + s0.xzyw*sh.xxyy ;
    vec4 a1 = b1.xzyw + s1.xzyw*sh.zzww ;

    vec3 p0 = vec3(a0.xy,h.x);
    vec3 p1 = vec3(a0.zw,h.y);
    vec3 p2 = vec3(a1.xy,h.z);
    vec3 p3 = vec3(a1.zw,h.w);

  //Normalise gradients
    vec4 norm = taylorInvSqrt(vec4(dot(p0,p0), dot(p1,p1), dot(p2, p2), dot(p3,p3)));
    p0 *= norm.x;
    p1 *= norm.y;
    p2 *= norm.z;
    p3 *= norm.w;

  // Mix final noise value
    vec4 m = max(0.6 - vec4(dot(x0,x0), dot(x1,x1), dot(x2,x2), dot(x3,x3)), 0.0);
    m = m * m;
    return 42.0 * dot( m*m, vec4( dot(p0,x0), dot(p1,x1),
                                  dot(p2,x2), dot(p3,x3) ) );
  }
    `
  },
  _rgbToHsv: {
    type: "util",
    glsl: `vec3 _rgbToHsv(vec3 c){
            vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
            vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
            vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

            float d = q.x - min(q.w, q.y);
            float e = 1.0e-10;
            return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
        }`
  },
  _hsvToRgb: {
    type: "util",
    glsl: `vec3 _hsvToRgb(vec3 c){
        vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
        vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
        return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
    }`
  }
};
var GlslSource = function(r) {
  return this.transforms = [], this.transforms.push(r), this.defaultOutput = r.defaultOutput, this.synth = r.synth, this.type = "GlslSource", this.defaultUniforms = r.defaultUniforms, this;
};
GlslSource.prototype.addTransform = function(r) {
  this.transforms.push(r);
};
GlslSource.prototype.out = function(r) {
  var n = r || this.defaultOutput, d = this.glsl(n);
  if (this.synth.currentFunctions = [], n)
    try {
      n.render(d);
    } catch (_) {
      console.log("shader could not compile", _);
    }
};
GlslSource.prototype.glsl = function() {
  var r = [], n = [];
  return this.transforms.forEach((d) => {
    d.transform.type === "renderpass" ? console.warn("no support for renderpass") : n.push(d);
  }), n.length > 0 && r.push(this.compile(n)), r;
};
GlslSource.prototype.compile = function(r) {
  var n = generateGlsl(r, this.synth), d = {};
  n.uniforms.forEach((T) => {
    d[T.name] = T.value;
  });
  var _ = `
  precision ${this.defaultOutput.precision} float;
  ${Object.values(n.uniforms).map((T) => {
    let N = T.type;
    switch (T.type) {
      case "texture":
        N = "sampler2D";
        break;
    }
    return `
      uniform ${N} ${T.name};`;
  }).join("")}
  uniform float time;
  uniform vec2 resolution;
  varying vec2 uv;
  uniform sampler2D prevBuffer;

  ${Object.values(utilityGlsl).map((T) => `
            ${T.glsl}
          `).join("")}

  ${n.glslFunctions.map((T) => `
            ${T.transform.glsl}
          `).join("")}

  void main () {
    vec4 c = vec4(1, 0, 0, 1);
    vec2 st = gl_FragCoord.xy/resolution.xy;
    gl_FragColor = ${n.fragColor};
  }
  `;
  return {
    frag: _,
    uniforms: Object.assign({}, this.defaultUniforms, d)
  };
};
const glslFunctions = () => [
  {
    name: "noise",
    type: "src",
    inputs: [
      {
        type: "float",
        name: "scale",
        default: 10
      },
      {
        type: "float",
        name: "offset",
        default: 0.1
      }
    ],
    glsl: "   return vec4(vec3(_noise(vec3(_st*scale, offset*time))), 1.0);"
  },
  {
    name: "voronoi",
    type: "src",
    inputs: [
      {
        type: "float",
        name: "scale",
        default: 5
      },
      {
        type: "float",
        name: "speed",
        default: 0.3
      },
      {
        type: "float",
        name: "blending",
        default: 0.3
      }
    ],
    glsl: `   vec3 color = vec3(.0);
   // Scale
   _st *= scale;
   // Tile the space
   vec2 i_st = floor(_st);
   vec2 f_st = fract(_st);
   float m_dist = 10.;  // minimun distance
   vec2 m_point;        // minimum point
   for (int j=-1; j<=1; j++ ) {
   for (int i=-1; i<=1; i++ ) {
   vec2 neighbor = vec2(float(i),float(j));
   vec2 p = i_st + neighbor;
   vec2 point = fract(sin(vec2(dot(p,vec2(127.1,311.7)),dot(p,vec2(269.5,183.3))))*43758.5453);
   point = 0.5 + 0.5*sin(time*speed + 6.2831*point);
   vec2 diff = neighbor + point - f_st;
   float dist = length(diff);
   if( dist < m_dist ) {
   m_dist = dist;
   m_point = point;
   }
   }
   }
   // Assign a color using the closest point position
   color += dot(m_point,vec2(.3,.6));
   color *= 1.0 - blending*m_dist;
   return vec4(color, 1.0);`
  },
  {
    name: "osc",
    type: "src",
    inputs: [
      {
        type: "float",
        name: "frequency",
        default: 60
      },
      {
        type: "float",
        name: "sync",
        default: 0.1
      },
      {
        type: "float",
        name: "offset",
        default: 0
      }
    ],
    glsl: `   vec2 st = _st;
   float r = sin((st.x-offset/frequency+time*sync)*frequency)*0.5  + 0.5;
   float g = sin((st.x+time*sync)*frequency)*0.5 + 0.5;
   float b = sin((st.x+offset/frequency+time*sync)*frequency)*0.5  + 0.5;
   return vec4(r, g, b, 1.0);`
  },
  {
    name: "shape",
    type: "src",
    inputs: [
      {
        type: "float",
        name: "sides",
        default: 3
      },
      {
        type: "float",
        name: "radius",
        default: 0.3
      },
      {
        type: "float",
        name: "smoothing",
        default: 0.01
      }
    ],
    glsl: `   vec2 st = _st * 2. - 1.;
   // Angle and radius from the current pixel
   float a = atan(st.x,st.y)+3.1416;
   float r = (2.*3.1416)/sides;
   float d = cos(floor(.5+a/r)*r-a)*length(st);
   return vec4(vec3(1.0-smoothstep(radius,radius + smoothing + 0.0000001,d)), 1.0);`
  },
  {
    name: "gradient",
    type: "src",
    inputs: [
      {
        type: "float",
        name: "speed",
        default: 0
      }
    ],
    glsl: "   return vec4(_st, sin(time*speed), 1.0);"
  },
  {
    name: "src",
    type: "src",
    inputs: [
      {
        type: "sampler2D",
        name: "tex",
        default: NaN
      }
    ],
    glsl: `   //  vec2 uv = gl_FragCoord.xy/vec2(1280., 720.);
   return texture2D(tex, fract(_st));`
  },
  {
    name: "solid",
    type: "src",
    inputs: [
      {
        type: "float",
        name: "r",
        default: 0
      },
      {
        type: "float",
        name: "g",
        default: 0
      },
      {
        type: "float",
        name: "b",
        default: 0
      },
      {
        type: "float",
        name: "a",
        default: 1
      }
    ],
    glsl: "   return vec4(r, g, b, a);"
  },
  {
    name: "rotate",
    type: "coord",
    inputs: [
      {
        type: "float",
        name: "angle",
        default: 10
      },
      {
        type: "float",
        name: "speed",
        default: 0
      }
    ],
    glsl: `   vec2 xy = _st - vec2(0.5);
   float ang = angle + speed *time;
   xy = mat2(cos(ang),-sin(ang), sin(ang),cos(ang))*xy;
   xy += 0.5;
   return xy;`
  },
  {
    name: "scale",
    type: "coord",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 1.5
      },
      {
        type: "float",
        name: "xMult",
        default: 1
      },
      {
        type: "float",
        name: "yMult",
        default: 1
      },
      {
        type: "float",
        name: "offsetX",
        default: 0.5
      },
      {
        type: "float",
        name: "offsetY",
        default: 0.5
      }
    ],
    glsl: `   vec2 xy = _st - vec2(offsetX, offsetY);
   xy*=(1.0/vec2(amount*xMult, amount*yMult));
   xy+=vec2(offsetX, offsetY);
   return xy;
   `
  },
  {
    name: "pixelate",
    type: "coord",
    inputs: [
      {
        type: "float",
        name: "pixelX",
        default: 20
      },
      {
        type: "float",
        name: "pixelY",
        default: 20
      }
    ],
    glsl: `   vec2 xy = vec2(pixelX, pixelY);
   return (floor(_st * xy) + 0.5)/xy;`
  },
  {
    name: "posterize",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "bins",
        default: 3
      },
      {
        type: "float",
        name: "gamma",
        default: 0.6
      }
    ],
    glsl: `   vec4 c2 = pow(_c0, vec4(gamma));
   c2 *= vec4(bins);
   c2 = floor(c2);
   c2/= vec4(bins);
   c2 = pow(c2, vec4(1.0/gamma));
   return vec4(c2.xyz, _c0.a);`
  },
  {
    name: "shift",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "r",
        default: 0.5
      },
      {
        type: "float",
        name: "g",
        default: 0
      },
      {
        type: "float",
        name: "b",
        default: 0
      },
      {
        type: "float",
        name: "a",
        default: 0
      }
    ],
    glsl: `   vec4 c2 = vec4(_c0);
   c2.r = fract(c2.r + r);
   c2.g = fract(c2.g + g);
   c2.b = fract(c2.b + b);
   c2.a = fract(c2.a + a);
   return vec4(c2.rgba);`
  },
  {
    name: "repeat",
    type: "coord",
    inputs: [
      {
        type: "float",
        name: "repeatX",
        default: 3
      },
      {
        type: "float",
        name: "repeatY",
        default: 3
      },
      {
        type: "float",
        name: "offsetX",
        default: 0
      },
      {
        type: "float",
        name: "offsetY",
        default: 0
      }
    ],
    glsl: `   vec2 st = _st * vec2(repeatX, repeatY);
   st.x += step(1., mod(st.y,2.0)) * offsetX;
   st.y += step(1., mod(st.x,2.0)) * offsetY;
   return fract(st);`
  },
  {
    name: "modulateRepeat",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "repeatX",
        default: 3
      },
      {
        type: "float",
        name: "repeatY",
        default: 3
      },
      {
        type: "float",
        name: "offsetX",
        default: 0.5
      },
      {
        type: "float",
        name: "offsetY",
        default: 0.5
      }
    ],
    glsl: `   vec2 st = _st * vec2(repeatX, repeatY);
   st.x += step(1., mod(st.y,2.0)) + _c0.r * offsetX;
   st.y += step(1., mod(st.x,2.0)) + _c0.g * offsetY;
   return fract(st);`
  },
  {
    name: "repeatX",
    type: "coord",
    inputs: [
      {
        type: "float",
        name: "reps",
        default: 3
      },
      {
        type: "float",
        name: "offset",
        default: 0
      }
    ],
    glsl: `   vec2 st = _st * vec2(reps, 1.0);
   //  float f =  mod(_st.y,2.0);
   st.y += step(1., mod(st.x,2.0))* offset;
   return fract(st);`
  },
  {
    name: "modulateRepeatX",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "reps",
        default: 3
      },
      {
        type: "float",
        name: "offset",
        default: 0.5
      }
    ],
    glsl: `   vec2 st = _st * vec2(reps, 1.0);
   //  float f =  mod(_st.y,2.0);
   st.y += step(1., mod(st.x,2.0)) + _c0.r * offset;
   return fract(st);`
  },
  {
    name: "repeatY",
    type: "coord",
    inputs: [
      {
        type: "float",
        name: "reps",
        default: 3
      },
      {
        type: "float",
        name: "offset",
        default: 0
      }
    ],
    glsl: `   vec2 st = _st * vec2(1.0, reps);
   //  float f =  mod(_st.y,2.0);
   st.x += step(1., mod(st.y,2.0))* offset;
   return fract(st);`
  },
  {
    name: "modulateRepeatY",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "reps",
        default: 3
      },
      {
        type: "float",
        name: "offset",
        default: 0.5
      }
    ],
    glsl: `   vec2 st = _st * vec2(reps, 1.0);
   //  float f =  mod(_st.y,2.0);
   st.x += step(1., mod(st.y,2.0)) + _c0.r * offset;
   return fract(st);`
  },
  {
    name: "kaleid",
    type: "coord",
    inputs: [
      {
        type: "float",
        name: "nSides",
        default: 4
      }
    ],
    glsl: `   vec2 st = _st;
   st -= 0.5;
   float r = length(st);
   float a = atan(st.y, st.x);
   float pi = 2.*3.1416;
   a = mod(a,pi/nSides);
   a = abs(a-pi/nSides/2.);
   return r*vec2(cos(a), sin(a));`
  },
  {
    name: "modulateKaleid",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "nSides",
        default: 4
      }
    ],
    glsl: `   vec2 st = _st - 0.5;
   float r = length(st);
   float a = atan(st.y, st.x);
   float pi = 2.*3.1416;
   a = mod(a,pi/nSides);
   a = abs(a-pi/nSides/2.);
   return (_c0.r+r)*vec2(cos(a), sin(a));`
  },
  {
    name: "scroll",
    type: "coord",
    inputs: [
      {
        type: "float",
        name: "scrollX",
        default: 0.5
      },
      {
        type: "float",
        name: "scrollY",
        default: 0.5
      },
      {
        type: "float",
        name: "speedX",
        default: 0
      },
      {
        type: "float",
        name: "speedY",
        default: 0
      }
    ],
    glsl: `
   _st.x += scrollX + time*speedX;
   _st.y += scrollY + time*speedY;
   return fract(_st);`
  },
  {
    name: "scrollX",
    type: "coord",
    inputs: [
      {
        type: "float",
        name: "scrollX",
        default: 0.5
      },
      {
        type: "float",
        name: "speed",
        default: 0
      }
    ],
    glsl: `   _st.x += scrollX + time*speed;
   return fract(_st);`
  },
  {
    name: "modulateScrollX",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "scrollX",
        default: 0.5
      },
      {
        type: "float",
        name: "speed",
        default: 0
      }
    ],
    glsl: `   _st.x += _c0.r*scrollX + time*speed;
   return fract(_st);`
  },
  {
    name: "scrollY",
    type: "coord",
    inputs: [
      {
        type: "float",
        name: "scrollY",
        default: 0.5
      },
      {
        type: "float",
        name: "speed",
        default: 0
      }
    ],
    glsl: `   _st.y += scrollY + time*speed;
   return fract(_st);`
  },
  {
    name: "modulateScrollY",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "scrollY",
        default: 0.5
      },
      {
        type: "float",
        name: "speed",
        default: 0
      }
    ],
    glsl: `   _st.y += _c0.r*scrollY + time*speed;
   return fract(_st);`
  },
  {
    name: "add",
    type: "combine",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 1
      }
    ],
    glsl: "   return (_c0+_c1)*amount + _c0*(1.0-amount);"
  },
  {
    name: "sub",
    type: "combine",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 1
      }
    ],
    glsl: "   return (_c0-_c1)*amount + _c0*(1.0-amount);"
  },
  {
    name: "layer",
    type: "combine",
    inputs: [],
    glsl: "   return vec4(mix(_c0.rgb, _c1.rgb, _c1.a), clamp(_c0.a + _c1.a, 0.0, 1.0));"
  },
  {
    name: "blend",
    type: "combine",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 0.5
      }
    ],
    glsl: "   return _c0*(1.0-amount)+_c1*amount;"
  },
  {
    name: "mult",
    type: "combine",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 1
      }
    ],
    glsl: "   return _c0*(1.0-amount)+(_c0*_c1)*amount;"
  },
  {
    name: "diff",
    type: "combine",
    inputs: [],
    glsl: "   return vec4(abs(_c0.rgb-_c1.rgb), max(_c0.a, _c1.a));"
  },
  {
    name: "modulate",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 0.1
      }
    ],
    glsl: `   //  return fract(st+(_c0.xy-0.5)*amount);
   return _st + _c0.xy*amount;`
  },
  {
    name: "modulateScale",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "multiple",
        default: 1
      },
      {
        type: "float",
        name: "offset",
        default: 1
      }
    ],
    glsl: `   vec2 xy = _st - vec2(0.5);
   xy*=(1.0/vec2(offset + multiple*_c0.r, offset + multiple*_c0.g));
   xy+=vec2(0.5);
   return xy;`
  },
  {
    name: "modulatePixelate",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "multiple",
        default: 10
      },
      {
        type: "float",
        name: "offset",
        default: 3
      }
    ],
    glsl: `   vec2 xy = vec2(offset + _c0.x*multiple, offset + _c0.y*multiple);
   return (floor(_st * xy) + 0.5)/xy;`
  },
  {
    name: "modulateRotate",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "multiple",
        default: 1
      },
      {
        type: "float",
        name: "offset",
        default: 0
      }
    ],
    glsl: `   vec2 xy = _st - vec2(0.5);
   float angle = offset + _c0.x * multiple;
   xy = mat2(cos(angle),-sin(angle), sin(angle),cos(angle))*xy;
   xy += 0.5;
   return xy;`
  },
  {
    name: "modulateHue",
    type: "combineCoord",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 1
      }
    ],
    glsl: "   return _st + (vec2(_c0.g - _c0.r, _c0.b - _c0.g) * amount * 1.0/resolution);"
  },
  {
    name: "invert",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 1
      }
    ],
    glsl: "   return vec4((1.0-_c0.rgb)*amount + _c0.rgb*(1.0-amount), _c0.a);"
  },
  {
    name: "contrast",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 1.6
      }
    ],
    glsl: `   vec4 c = (_c0-vec4(0.5))*vec4(amount) + vec4(0.5);
   return vec4(c.rgb, _c0.a);`
  },
  {
    name: "brightness",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 0.4
      }
    ],
    glsl: "   return vec4(_c0.rgb + vec3(amount), _c0.a);"
  },
  {
    name: "mask",
    type: "combine",
    inputs: [],
    glsl: `   float a = _luminance(_c1.rgb);
  return vec4(_c0.rgb*a, a*_c0.a);`
  },
  {
    name: "luma",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "threshold",
        default: 0.5
      },
      {
        type: "float",
        name: "tolerance",
        default: 0.1
      }
    ],
    glsl: `   float a = smoothstep(threshold-(tolerance+0.0000001), threshold+(tolerance+0.0000001), _luminance(_c0.rgb));
   return vec4(_c0.rgb*a, a);`
  },
  {
    name: "thresh",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "threshold",
        default: 0.5
      },
      {
        type: "float",
        name: "tolerance",
        default: 0.04
      }
    ],
    glsl: "   return vec4(vec3(smoothstep(threshold-(tolerance+0.0000001), threshold+(tolerance+0.0000001), _luminance(_c0.rgb))), _c0.a);"
  },
  {
    name: "color",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "r",
        default: 1
      },
      {
        type: "float",
        name: "g",
        default: 1
      },
      {
        type: "float",
        name: "b",
        default: 1
      },
      {
        type: "float",
        name: "a",
        default: 1
      }
    ],
    glsl: `   vec4 c = vec4(r, g, b, a);
   vec4 pos = step(0.0, c); // detect whether negative
   // if > 0, return r * _c0
   // if < 0 return (1.0-r) * _c0
   return vec4(mix((1.0-_c0)*abs(c), c*_c0, pos));`
  },
  {
    name: "saturate",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 2
      }
    ],
    glsl: `   const vec3 W = vec3(0.2125, 0.7154, 0.0721);
   vec3 intensity = vec3(dot(_c0.rgb, W));
   return vec4(mix(intensity, _c0.rgb, amount), _c0.a);`
  },
  {
    name: "hue",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "hue",
        default: 0.4
      }
    ],
    glsl: `   vec3 c = _rgbToHsv(_c0.rgb);
   c.r += hue;
   //  c.r = fract(c.r);
   return vec4(_hsvToRgb(c), _c0.a);`
  },
  {
    name: "colorama",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "amount",
        default: 5e-3
      }
    ],
    glsl: `   vec3 c = _rgbToHsv(_c0.rgb);
   c += vec3(amount);
   c = _hsvToRgb(c);
   c = fract(c);
   return vec4(c, _c0.a);`
  },
  {
    name: "prev",
    type: "src",
    inputs: [],
    glsl: "   return texture2D(prevBuffer, fract(_st));"
  },
  {
    name: "sum",
    type: "color",
    inputs: [
      {
        type: "vec4",
        name: "scale",
        default: 1
      }
    ],
    glsl: `   vec4 v = _c0 * s;
   return v.r + v.g + v.b + v.a;
   }
   float sum(vec2 _st, vec4 s) { // vec4 is not a typo, because argument type is not overloaded
   vec2 v = _st.xy * s.xy;
   return v.x + v.y;`
  },
  {
    name: "r",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "scale",
        default: 1
      },
      {
        type: "float",
        name: "offset",
        default: 0
      }
    ],
    glsl: "   return vec4(_c0.r * scale + offset);"
  },
  {
    name: "g",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "scale",
        default: 1
      },
      {
        type: "float",
        name: "offset",
        default: 0
      }
    ],
    glsl: "   return vec4(_c0.g * scale + offset);"
  },
  {
    name: "b",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "scale",
        default: 1
      },
      {
        type: "float",
        name: "offset",
        default: 0
      }
    ],
    glsl: "   return vec4(_c0.b * scale + offset);"
  },
  {
    name: "a",
    type: "color",
    inputs: [
      {
        type: "float",
        name: "scale",
        default: 1
      },
      {
        type: "float",
        name: "offset",
        default: 0
      }
    ],
    glsl: "   return vec4(_c0.a * scale + offset);"
  }
];
class GeneratorFactory {
  constructor({
    defaultUniforms: n,
    defaultOutput: d,
    extendTransforms: _ = [],
    changeListener: T = () => {
    }
  } = {}) {
    this.defaultOutput = d, this.defaultUniforms = n, this.changeListener = T, this.extendTransforms = _, this.generators = {}, this.init();
  }
  init() {
    const n = glslFunctions();
    return this.glslTransforms = {}, this.generators = Object.entries(this.generators).reduce((d, [_, T]) => (this.changeListener({ type: "remove", synth: this, method: _ }), d), {}), this.sourceClass = class extends GlslSource {
    }, Array.isArray(this.extendTransforms) ? n.concat(this.extendTransforms) : typeof this.extendTransforms == "object" && this.extendTransforms.type && n.push(this.extendTransforms), n.map((d) => this.setFunction(d));
  }
  _addMethod(n, d) {
    const _ = this;
    if (this.glslTransforms[n] = d, d.type === "src") {
      const T = (...N) => new this.sourceClass({
        name: n,
        transform: d,
        userArgs: N,
        defaultOutput: this.defaultOutput,
        defaultUniforms: this.defaultUniforms,
        synth: _
      });
      return this.generators[n] = T, this.changeListener({ type: "add", synth: this, method: n }), T;
    } else
      this.sourceClass.prototype[n] = function(...T) {
        return this.transforms.push({ name: n, transform: d, userArgs: T, synth: _ }), this;
      };
  }
  setFunction(n) {
    var d = processGlsl(n);
    d && this._addMethod(n.name, d);
  }
}
const typeLookup = {
  src: {
    returnType: "vec4",
    args: ["vec2 _st"]
  },
  coord: {
    returnType: "vec2",
    args: ["vec2 _st"]
  },
  color: {
    returnType: "vec4",
    args: ["vec4 _c0"]
  },
  combine: {
    returnType: "vec4",
    args: ["vec4 _c0", "vec4 _c1"]
  },
  combineCoord: {
    returnType: "vec2",
    args: ["vec2 _st", "vec4 _c0"]
  }
};
function processGlsl(r) {
  let n = typeLookup[r.type];
  if (n) {
    let d = n.args.map((le) => le).join(", "), _ = r.inputs.map((le) => `${le.type} ${le.name}`).join(", "), T = `${d}${_.length > 0 ? ", " + _ : ""}`, N = `
  ${n.returnType} ${r.name}(${T}) {
      ${r.glsl}
  }
`;
    return (r.type === "combine" || r.type === "combineCoord") && r.inputs.unshift({
      name: "color",
      type: "vec4"
    }), Object.assign({}, r, { glsl: N });
  } else
    console.warn(`type ${r.type} not recognized`, r);
}
var regl$1 = { exports: {} };
(function(r, n) {
  (function(d, _) {
    r.exports = _();
  })(commonjsGlobal, function() {
    var d = function(e) {
      return e instanceof Uint8Array || e instanceof Uint16Array || e instanceof Uint32Array || e instanceof Int8Array || e instanceof Int16Array || e instanceof Int32Array || e instanceof Float32Array || e instanceof Float64Array || e instanceof Uint8ClampedArray;
    }, _ = function(e, o) {
      for (var h = Object.keys(o), C = 0; C < h.length; ++C)
        e[h[C]] = o[h[C]];
      return e;
    }, T = `
`;
    function N(e) {
      return typeof atob < "u" ? atob(e) : "base64:" + e;
    }
    function le(e) {
      var o = new Error("(regl) " + e);
      throw console.error(o), o;
    }
    function fe(e, o) {
      e || le(o);
    }
    function Oe(e) {
      return e ? ": " + e : "";
    }
    function pe(e, o, h) {
      e in o || le("unknown parameter (" + e + ")" + Oe(h) + ". possible values: " + Object.keys(o).join());
    }
    function Ie(e, o) {
      d(e) || le(
        "invalid parameter type" + Oe(o) + ". must be a typed array"
      );
    }
    function ve(e, o) {
      switch (o) {
        case "number":
          return typeof e == "number";
        case "object":
          return typeof e == "object";
        case "string":
          return typeof e == "string";
        case "boolean":
          return typeof e == "boolean";
        case "function":
          return typeof e == "function";
        case "undefined":
          return typeof e > "u";
        case "symbol":
          return typeof e == "symbol";
      }
    }
    function Be(e, o, h) {
      ve(e, o) || le(
        "invalid parameter type" + Oe(h) + ". expected " + o + ", got " + typeof e
      );
    }
    function We(e, o) {
      e >= 0 && (e | 0) === e || le("invalid parameter type, (" + e + ")" + Oe(o) + ". must be a nonnegative integer");
    }
    function je(e, o, h) {
      o.indexOf(e) < 0 && le("invalid value" + Oe(h) + ". must be one of: " + o);
    }
    var Qe = [
      "gl",
      "canvas",
      "container",
      "attributes",
      "pixelRatio",
      "extensions",
      "optionalExtensions",
      "profile",
      "onDone"
    ];
    function ut(e) {
      Object.keys(e).forEach(function(o) {
        Qe.indexOf(o) < 0 && le('invalid regl constructor argument "' + o + '". must be one of ' + Qe);
      });
    }
    function vt(e, o) {
      for (e = e + ""; e.length < o; )
        e = " " + e;
      return e;
    }
    function Ne() {
      this.name = "unknown", this.lines = [], this.index = {}, this.hasErrors = !1;
    }
    function Ze(e, o) {
      this.number = e, this.line = o, this.errors = [];
    }
    function Ct(e, o, h) {
      this.file = e, this.line = o, this.message = h;
    }
    function yt() {
      var e = new Error(), o = (e.stack || e).toString(), h = /compileProcedure.*\n\s*at.*\((.*)\)/.exec(o);
      if (h)
        return h[1];
      var C = /compileProcedure.*\n\s*at\s+(.*)(\n|$)/.exec(o);
      return C ? C[1] : "unknown";
    }
    function I() {
      var e = new Error(), o = (e.stack || e).toString(), h = /at REGLCommand.*\n\s+at.*\((.*)\)/.exec(o);
      if (h)
        return h[1];
      var C = /at REGLCommand.*\n\s+at\s+(.*)\n/.exec(o);
      return C ? C[1] : "unknown";
    }
    function O(e, o) {
      var h = e.split(`
`), C = 1, P = 0, R = {
        unknown: new Ne(),
        0: new Ne()
      };
      R.unknown.name = R[0].name = o || yt(), R.unknown.lines.push(new Ze(0, ""));
      for (var G = 0; G < h.length; ++G) {
        var V = h[G], q = /^\s*#\s*(\w+)\s+(.+)\s*$/.exec(V);
        if (q)
          switch (q[1]) {
            case "line":
              var Q = /(\d+)(\s+\d+)?/.exec(q[2]);
              Q && (C = Q[1] | 0, Q[2] && (P = Q[2] | 0, P in R || (R[P] = new Ne())));
              break;
            case "define":
              var W = /SHADER_NAME(_B64)?\s+(.*)$/.exec(q[2]);
              W && (R[P].name = W[1] ? N(W[2]) : W[2]);
              break;
          }
        R[P].lines.push(new Ze(C++, V));
      }
      return Object.keys(R).forEach(function(J) {
        var ae = R[J];
        ae.lines.forEach(function(H) {
          ae.index[H.number] = H;
        });
      }), R;
    }
    function ee(e) {
      var o = [];
      return e.split(`
`).forEach(function(h) {
        if (!(h.length < 5)) {
          var C = /^ERROR:\s+(\d+):(\d+):\s*(.*)$/.exec(h);
          C ? o.push(new Ct(
            C[1] | 0,
            C[2] | 0,
            C[3].trim()
          )) : h.length > 0 && o.push(new Ct("unknown", 0, h));
        }
      }), o;
    }
    function M(e, o) {
      o.forEach(function(h) {
        var C = e[h.file];
        if (C) {
          var P = C.index[h.line];
          if (P) {
            P.errors.push(h), C.hasErrors = !0;
            return;
          }
        }
        e.unknown.hasErrors = !0, e.unknown.lines[0].errors.push(h);
      });
    }
    function oe(e, o, h, C, P) {
      if (!e.getShaderParameter(o, e.COMPILE_STATUS)) {
        var R = e.getShaderInfoLog(o), G = C === e.FRAGMENT_SHADER ? "fragment" : "vertex";
        _t(h, "string", G + " shader source must be a string", P);
        var V = O(h, P), q = ee(R);
        M(V, q), Object.keys(V).forEach(function(Q) {
          var W = V[Q];
          if (!W.hasErrors)
            return;
          var J = [""], ae = [""];
          function H(te, A) {
            J.push(te), ae.push(A || "");
          }
          H("file number " + Q + ": " + W.name + `
`, "color:red;text-decoration:underline;font-weight:bold"), W.lines.forEach(function(te) {
            if (te.errors.length > 0) {
              H(vt(te.number, 4) + "|  ", "background-color:yellow; font-weight:bold"), H(te.line + T, "color:red; background-color:yellow; font-weight:bold");
              var A = 0;
              te.errors.forEach(function(D) {
                var K = D.message, se = /^\s*'(.*)'\s*:\s*(.*)$/.exec(K);
                if (se) {
                  var z = se[1];
                  switch (K = se[2], z) {
                    case "assign":
                      z = "=";
                      break;
                  }
                  A = Math.max(te.line.indexOf(z, A), 0);
                } else
                  A = 0;
                H(vt("| ", 6)), H(vt("^^^", A + 3) + T, "font-weight:bold"), H(vt("| ", 6)), H(K + T, "font-weight:bold");
              }), H(vt("| ", 6) + T);
            } else
              H(vt(te.number, 4) + "|  "), H(te.line + T, "color:red");
          }), typeof document < "u" && !window.chrome ? (ae[0] = J.join("%c"), console.log.apply(console, ae)) : console.log(J.join(""));
        }), fe.raise("Error compiling " + G + " shader, " + V[0].name);
      }
    }
    function xe(e, o, h, C, P) {
      if (!e.getProgramParameter(o, e.LINK_STATUS)) {
        var R = e.getProgramInfoLog(o), G = O(h, P), V = O(C, P), q = 'Error linking program with vertex shader, "' + V[0].name + '", and fragment shader "' + G[0].name + '"';
        typeof document < "u" ? console.log(
          "%c" + q + T + "%c" + R,
          "color:red;text-decoration:underline;font-weight:bold",
          "color:red"
        ) : console.log(q + T + R), fe.raise(q);
      }
    }
    function He(e) {
      e._commandRef = yt();
    }
    function qe(e, o, h, C) {
      He(e);
      function P(q) {
        return q ? C.id(q) : 0;
      }
      e._fragId = P(e.static.frag), e._vertId = P(e.static.vert);
      function R(q, Q) {
        Object.keys(Q).forEach(function(W) {
          q[C.id(W)] = !0;
        });
      }
      var G = e._uniformSet = {};
      R(G, o.static), R(G, o.dynamic);
      var V = e._attributeSet = {};
      R(V, h.static), R(V, h.dynamic), e._hasCount = "count" in e.static || "count" in e.dynamic || "elements" in e.static || "elements" in e.dynamic;
    }
    function Se(e, o) {
      var h = I();
      le(e + " in command " + (o || yt()) + (h === "unknown" ? "" : " called from " + h));
    }
    function Fe(e, o, h) {
      e || Se(o, h || yt());
    }
    function Ve(e, o, h, C) {
      e in o || Se(
        "unknown parameter (" + e + ")" + Oe(h) + ". possible values: " + Object.keys(o).join(),
        C || yt()
      );
    }
    function _t(e, o, h, C) {
      ve(e, o) || Se(
        "invalid parameter type" + Oe(h) + ". expected " + o + ", got " + typeof e,
        C || yt()
      );
    }
    function ze(e) {
      e();
    }
    function qt(e, o, h) {
      e.texture ? je(
        e.texture._texture.internalformat,
        o,
        "unsupported texture format for attachment"
      ) : je(
        e.renderbuffer._renderbuffer.format,
        h,
        "unsupported renderbuffer format for attachment"
      );
    }
    var Ft = 33071, Gt = 9728, yn = 9984, dt = 9985, xt = 9986, Lt = 9987, kt = 5120, bo = 5121, go = 5122, xo = 5123, Eo = 5124, Ao = 5125, ma = 5126, pa = 32819, va = 32820, ya = 33635, _a = 34042, To = 36193, Tt = {};
    Tt[kt] = Tt[bo] = 1, Tt[go] = Tt[xo] = Tt[To] = Tt[ya] = Tt[pa] = Tt[va] = 2, Tt[Eo] = Tt[Ao] = Tt[ma] = Tt[_a] = 4;
    function ba(e, o) {
      return e === va || e === pa || e === ya ? 2 : e === _a ? 4 : Tt[e] * o;
    }
    function Ur(e) {
      return !(e & e - 1) && !!e;
    }
    function So(e, o, h) {
      var C, P = o.width, R = o.height, G = o.channels;
      fe(
        P > 0 && P <= h.maxTextureSize && R > 0 && R <= h.maxTextureSize,
        "invalid texture shape"
      ), (e.wrapS !== Ft || e.wrapT !== Ft) && fe(
        Ur(P) && Ur(R),
        "incompatible wrap mode for texture, both width and height must be power of 2"
      ), o.mipmask === 1 ? P !== 1 && R !== 1 && fe(
        e.minFilter !== yn && e.minFilter !== xt && e.minFilter !== dt && e.minFilter !== Lt,
        "min filter requires mipmap"
      ) : (fe(
        Ur(P) && Ur(R),
        "texture must be a square power of 2 to support mipmapping"
      ), fe(
        o.mipmask === (P << 1) - 1,
        "missing or incomplete mipmap data"
      )), o.type === ma && (h.extensions.indexOf("oes_texture_float_linear") < 0 && fe(
        e.minFilter === Gt && e.magFilter === Gt,
        "filter not supported, must enable oes_texture_float_linear"
      ), fe(
        !e.genMipmaps,
        "mipmap generation not supported with float textures"
      ));
      var V = o.images;
      for (C = 0; C < 16; ++C)
        if (V[C]) {
          var q = P >> C, Q = R >> C;
          fe(o.mipmask & 1 << C, "missing mipmap data");
          var W = V[C];
          if (fe(
            W.width === q && W.height === Q,
            "invalid shape for mip images"
          ), fe(
            W.format === o.format && W.internalformat === o.internalformat && W.type === o.type,
            "incompatible type for mip image"
          ), !W.compressed)
            if (W.data) {
              var J = Math.ceil(ba(W.type, G) * q / W.unpackAlignment) * W.unpackAlignment;
              fe(
                W.data.byteLength === J * Q,
                "invalid data for image, buffer size is inconsistent with image format"
              );
            } else
              W.element || W.copy;
        } else
          e.genMipmaps || fe((o.mipmask & 1 << C) === 0, "extra mipmap data");
      o.compressed && fe(
        !e.genMipmaps,
        "mipmap generation for compressed images not supported"
      );
    }
    function wo(e, o, h, C) {
      var P = e.width, R = e.height, G = e.channels;
      fe(
        P > 0 && P <= C.maxTextureSize && R > 0 && R <= C.maxTextureSize,
        "invalid texture shape"
      ), fe(
        P === R,
        "cube map must be square"
      ), fe(
        o.wrapS === Ft && o.wrapT === Ft,
        "wrap mode not supported by cube map"
      );
      for (var V = 0; V < h.length; ++V) {
        var q = h[V];
        fe(
          q.width === P && q.height === R,
          "inconsistent cube map face shape"
        ), o.genMipmaps && (fe(
          !q.compressed,
          "can not generate mipmap for compressed textures"
        ), fe(
          q.mipmask === 1,
          "can not specify mipmaps and generate mipmaps"
        ));
        for (var Q = q.images, W = 0; W < 16; ++W) {
          var J = Q[W];
          if (J) {
            var ae = P >> W, H = R >> W;
            fe(q.mipmask & 1 << W, "missing mipmap data"), fe(
              J.width === ae && J.height === H,
              "invalid shape for mip images"
            ), fe(
              J.format === e.format && J.internalformat === e.internalformat && J.type === e.type,
              "incompatible type for mip image"
            ), J.compressed || (J.data ? fe(
              J.data.byteLength === ae * H * Math.max(ba(J.type, G), J.unpackAlignment),
              "invalid data for image, buffer size is inconsistent with image format"
            ) : J.element || J.copy);
          }
        }
      }
    }
    var c = _(fe, {
      optional: ze,
      raise: le,
      commandRaise: Se,
      command: Fe,
      parameter: pe,
      commandParameter: Ve,
      constructor: ut,
      type: Be,
      commandType: _t,
      isTypedArray: Ie,
      nni: We,
      oneOf: je,
      shaderError: oe,
      linkError: xe,
      callSite: I,
      saveCommandRef: He,
      saveDrawInfo: qe,
      framebufferFormat: qt,
      guessCommand: yt,
      texture2D: So,
      textureCube: wo
    }), Lo = 0, Ro = 0, Oo = 5, Co = 6;
    function Wt(e, o) {
      this.id = Lo++, this.type = e, this.data = o;
    }
    function ga(e) {
      return e.replace(/\\/g, "\\\\").replace(/"/g, '\\"');
    }
    function Er(e) {
      if (e.length === 0)
        return [];
      var o = e.charAt(0), h = e.charAt(e.length - 1);
      if (e.length > 1 && o === h && (o === '"' || o === "'"))
        return ['"' + ga(e.substr(1, e.length - 2)) + '"'];
      var C = /\[(false|true|null|\d+|'[^']*'|"[^"]*")\]/.exec(e);
      if (C)
        return Er(e.substr(0, C.index)).concat(Er(C[1])).concat(Er(e.substr(C.index + C[0].length)));
      var P = e.split(".");
      if (P.length === 1)
        return ['"' + ga(e) + '"'];
      for (var R = [], G = 0; G < P.length; ++G)
        R = R.concat(Er(P[G]));
      return R;
    }
    function xa(e) {
      return "[" + Er(e).join("][") + "]";
    }
    function Fo(e, o) {
      return new Wt(e, xa(o + ""));
    }
    function Go(e) {
      return typeof e == "function" && !e._reglType || e instanceof Wt;
    }
    function Ea(e, o) {
      if (typeof e == "function")
        return new Wt(Ro, e);
      if (typeof e == "number" || typeof e == "boolean")
        return new Wt(Oo, e);
      if (Array.isArray(e))
        return new Wt(Co, e.map((h, C) => Ea(h, o + "[" + C + "]")));
      if (e instanceof Wt)
        return e;
      c(!1, "invalid option type in uniform " + o);
    }
    var St = {
      DynamicVariable: Wt,
      define: Fo,
      isDynamic: Go,
      unbox: Ea,
      accessor: xa
    }, _n = {
      next: typeof requestAnimationFrame == "function" ? function(e) {
        return requestAnimationFrame(e);
      } : function(e) {
        return setTimeout(e, 16);
      },
      cancel: typeof cancelAnimationFrame == "function" ? function(e) {
        return cancelAnimationFrame(e);
      } : clearTimeout
    }, Aa = typeof performance < "u" && performance.now ? function() {
      return performance.now();
    } : function() {
      return +/* @__PURE__ */ new Date();
    };
    function Do() {
      var e = { "": 0 }, o = [""];
      return {
        id: function(h) {
          var C = e[h];
          return C || (C = e[h] = o.length, o.push(h), C);
        },
        str: function(h) {
          return o[h];
        }
      };
    }
    function Mo(e, o, h) {
      var C = document.createElement("canvas");
      _(C.style, {
        border: 0,
        margin: 0,
        padding: 0,
        top: 0,
        left: 0
      }), e.appendChild(C), e === document.body && (C.style.position = "absolute", _(e.style, {
        margin: 0,
        padding: 0
      }));
      function P() {
        var V = window.innerWidth, q = window.innerHeight;
        if (e !== document.body) {
          var Q = e.getBoundingClientRect();
          V = Q.right - Q.left, q = Q.bottom - Q.top;
        }
        C.width = h * V, C.height = h * q, _(C.style, {
          width: V + "px",
          height: q + "px"
        });
      }
      var R;
      e !== document.body && typeof ResizeObserver == "function" ? (R = new ResizeObserver(function() {
        setTimeout(P);
      }), R.observe(e)) : window.addEventListener("resize", P, !1);
      function G() {
        R ? R.disconnect() : window.removeEventListener("resize", P), e.removeChild(C);
      }
      return P(), {
        canvas: C,
        onDestroy: G
      };
    }
    function No(e, o) {
      function h(C) {
        try {
          return e.getContext(C, o);
        } catch {
          return null;
        }
      }
      return h("webgl") || h("experimental-webgl") || h("webgl-experimental");
    }
    function ko(e) {
      return typeof e.nodeName == "string" && typeof e.appendChild == "function" && typeof e.getBoundingClientRect == "function";
    }
    function Bo(e) {
      return typeof e.drawArrays == "function" || typeof e.drawElements == "function";
    }
    function Ta(e) {
      return typeof e == "string" ? e.split() : (c(Array.isArray(e), "invalid extension array"), e);
    }
    function Sa(e) {
      return typeof e == "string" ? (c(typeof document < "u", "not supported outside of DOM"), document.querySelector(e)) : e;
    }
    function Io(e) {
      var o = e || {}, h, C, P, R, G = {}, V = [], q = [], Q = typeof window > "u" ? 1 : window.devicePixelRatio, W = !1, J = function(te) {
        te && c.raise(te);
      }, ae = function() {
      };
      if (typeof o == "string" ? (c(
        typeof document < "u",
        "selector queries only supported in DOM enviroments"
      ), h = document.querySelector(o), c(h, "invalid query string for element")) : typeof o == "object" ? ko(o) ? h = o : Bo(o) ? (R = o, P = R.canvas) : (c.constructor(o), "gl" in o ? R = o.gl : "canvas" in o ? P = Sa(o.canvas) : "container" in o && (C = Sa(o.container)), "attributes" in o && (G = o.attributes, c.type(G, "object", "invalid context attributes")), "extensions" in o && (V = Ta(o.extensions)), "optionalExtensions" in o && (q = Ta(o.optionalExtensions)), "onDone" in o && (c.type(
        o.onDone,
        "function",
        "invalid or missing onDone callback"
      ), J = o.onDone), "profile" in o && (W = !!o.profile), "pixelRatio" in o && (Q = +o.pixelRatio, c(Q > 0, "invalid pixel ratio"))) : c.raise("invalid arguments to regl"), h && (h.nodeName.toLowerCase() === "canvas" ? P = h : C = h), !R) {
        if (!P) {
          c(
            typeof document < "u",
            "must manually specify webgl context outside of DOM environments"
          );
          var H = Mo(C || document.body, J, Q);
          if (!H)
            return null;
          P = H.canvas, ae = H.onDestroy;
        }
        G.premultipliedAlpha === void 0 && (G.premultipliedAlpha = !0), R = No(P, G);
      }
      return R ? {
        gl: R,
        canvas: P,
        container: C,
        extensions: V,
        optionalExtensions: q,
        pixelRatio: Q,
        profile: W,
        onDone: J,
        onDestroy: ae
      } : (ae(), J("webgl not supported, try upgrading your browser or graphics drivers http://get.webgl.org"), null);
    }
    function Po(e, o) {
      var h = {};
      function C(G) {
        c.type(G, "string", "extension name must be string");
        var V = G.toLowerCase(), q;
        try {
          q = h[V] = e.getExtension(V);
        } catch {
        }
        return !!q;
      }
      for (var P = 0; P < o.extensions.length; ++P) {
        var R = o.extensions[P];
        if (!C(R))
          return o.onDestroy(), o.onDone('"' + R + '" extension is not supported by the current WebGL context, try upgrading your system or a different browser'), null;
      }
      return o.optionalExtensions.forEach(C), {
        extensions: h,
        restore: function() {
          Object.keys(h).forEach(function(G) {
            if (h[G] && !C(G))
              throw new Error("(regl): error restoring extension " + G);
          });
        }
      };
    }
    function Et(e, o) {
      for (var h = Array(e), C = 0; C < e; ++C)
        h[C] = o(C);
      return h;
    }
    var Uo = 5120, $o = 5121, zo = 5122, jo = 5123, Xo = 5124, Vo = 5125, Ho = 5126;
    function qo(e) {
      for (var o = 16; o <= 1 << 28; o *= 16)
        if (e <= o)
          return o;
      return 0;
    }
    function wa(e) {
      var o, h;
      return o = (e > 65535) << 4, e >>>= o, h = (e > 255) << 3, e >>>= h, o |= h, h = (e > 15) << 2, e >>>= h, o |= h, h = (e > 3) << 1, e >>>= h, o |= h, o | e >> 1;
    }
    function La() {
      var e = Et(8, function() {
        return [];
      });
      function o(R) {
        var G = qo(R), V = e[wa(G) >> 2];
        return V.length > 0 ? V.pop() : new ArrayBuffer(G);
      }
      function h(R) {
        e[wa(R.byteLength) >> 2].push(R);
      }
      function C(R, G) {
        var V = null;
        switch (R) {
          case Uo:
            V = new Int8Array(o(G), 0, G);
            break;
          case $o:
            V = new Uint8Array(o(G), 0, G);
            break;
          case zo:
            V = new Int16Array(o(2 * G), 0, G);
            break;
          case jo:
            V = new Uint16Array(o(2 * G), 0, G);
            break;
          case Xo:
            V = new Int32Array(o(4 * G), 0, G);
            break;
          case Vo:
            V = new Uint32Array(o(4 * G), 0, G);
            break;
          case Ho:
            V = new Float32Array(o(4 * G), 0, G);
            break;
          default:
            return null;
        }
        return V.length !== G ? V.subarray(0, G) : V;
      }
      function P(R) {
        h(R.buffer);
      }
      return {
        alloc: o,
        free: h,
        allocType: C,
        freeType: P
      };
    }
    var rt = La();
    rt.zero = La();
    var Wo = 3408, Yo = 3410, Ko = 3411, Qo = 3412, Zo = 3413, Jo = 3414, es = 3415, ts = 33901, rs = 33902, ns = 3379, as = 3386, is = 34921, os = 36347, ss = 36348, fs = 35661, us = 35660, cs = 34930, ls = 36349, ds = 34076, hs = 34024, ms = 7936, ps = 7937, vs = 7938, ys = 35724, _s = 34047, bs = 36063, gs = 34852, $r = 3553, Ra = 34067, xs = 34069, Es = 33984, Ar = 6408, bn = 5126, Oa = 5121, gn = 36160, As = 36053, Ts = 36064, Ss = 16384, ws = function(e, o) {
      var h = 1;
      o.ext_texture_filter_anisotropic && (h = e.getParameter(_s));
      var C = 1, P = 1;
      o.webgl_draw_buffers && (C = e.getParameter(gs), P = e.getParameter(bs));
      var R = !!o.oes_texture_float;
      if (R) {
        var G = e.createTexture();
        e.bindTexture($r, G), e.texImage2D($r, 0, Ar, 1, 1, 0, Ar, bn, null);
        var V = e.createFramebuffer();
        if (e.bindFramebuffer(gn, V), e.framebufferTexture2D(gn, Ts, $r, G, 0), e.bindTexture($r, null), e.checkFramebufferStatus(gn) !== As)
          R = !1;
        else {
          e.viewport(0, 0, 1, 1), e.clearColor(1, 0, 0, 1), e.clear(Ss);
          var q = rt.allocType(bn, 4);
          e.readPixels(0, 0, 1, 1, Ar, bn, q), e.getError() ? R = !1 : (e.deleteFramebuffer(V), e.deleteTexture(G), R = q[0] === 1), rt.freeType(q);
        }
      }
      var Q = typeof navigator < "u" && (/MSIE/.test(navigator.userAgent) || /Trident\//.test(navigator.appVersion) || /Edge/.test(navigator.userAgent)), W = !0;
      if (!Q) {
        var J = e.createTexture(), ae = rt.allocType(Oa, 36);
        e.activeTexture(Es), e.bindTexture(Ra, J), e.texImage2D(xs, 0, Ar, 3, 3, 0, Ar, Oa, ae), rt.freeType(ae), e.bindTexture(Ra, null), e.deleteTexture(J), W = !e.getError();
      }
      return {
        // drawing buffer bit depth
        colorBits: [
          e.getParameter(Yo),
          e.getParameter(Ko),
          e.getParameter(Qo),
          e.getParameter(Zo)
        ],
        depthBits: e.getParameter(Jo),
        stencilBits: e.getParameter(es),
        subpixelBits: e.getParameter(Wo),
        // supported extensions
        extensions: Object.keys(o).filter(function(H) {
          return !!o[H];
        }),
        // max aniso samples
        maxAnisotropic: h,
        // max draw buffers
        maxDrawbuffers: C,
        maxColorAttachments: P,
        // point and line size ranges
        pointSizeDims: e.getParameter(ts),
        lineWidthDims: e.getParameter(rs),
        maxViewportDims: e.getParameter(as),
        maxCombinedTextureUnits: e.getParameter(fs),
        maxCubeMapSize: e.getParameter(ds),
        maxRenderbufferSize: e.getParameter(hs),
        maxTextureUnits: e.getParameter(cs),
        maxTextureSize: e.getParameter(ns),
        maxAttributes: e.getParameter(is),
        maxVertexUniforms: e.getParameter(os),
        maxVertexTextureUnits: e.getParameter(us),
        maxVaryingVectors: e.getParameter(ss),
        maxFragmentUniforms: e.getParameter(ls),
        // vendor info
        glsl: e.getParameter(ys),
        renderer: e.getParameter(ps),
        vendor: e.getParameter(ms),
        version: e.getParameter(vs),
        // quirks
        readFloat: R,
        npotTextureCube: W
      };
    };
    function Dt(e) {
      return !!e && typeof e == "object" && Array.isArray(e.shape) && Array.isArray(e.stride) && typeof e.offset == "number" && e.shape.length === e.stride.length && (Array.isArray(e.data) || d(e.data));
    }
    var wt = function(e) {
      return Object.keys(e).map(function(o) {
        return e[o];
      });
    }, zr = {
      shape: Cs,
      flatten: Os
    };
    function Ls(e, o, h) {
      for (var C = 0; C < o; ++C)
        h[C] = e[C];
    }
    function Rs(e, o, h, C) {
      for (var P = 0, R = 0; R < o; ++R)
        for (var G = e[R], V = 0; V < h; ++V)
          C[P++] = G[V];
    }
    function Ca(e, o, h, C, P, R) {
      for (var G = R, V = 0; V < o; ++V)
        for (var q = e[V], Q = 0; Q < h; ++Q)
          for (var W = q[Q], J = 0; J < C; ++J)
            P[G++] = W[J];
    }
    function Fa(e, o, h, C, P) {
      for (var R = 1, G = h + 1; G < o.length; ++G)
        R *= o[G];
      var V = o[h];
      if (o.length - h === 4) {
        var q = o[h + 1], Q = o[h + 2], W = o[h + 3];
        for (G = 0; G < V; ++G)
          Ca(e[G], q, Q, W, C, P), P += R;
      } else
        for (G = 0; G < V; ++G)
          Fa(e[G], o, h + 1, C, P), P += R;
    }
    function Os(e, o, h, C) {
      var P = 1;
      if (o.length)
        for (var R = 0; R < o.length; ++R)
          P *= o[R];
      else
        P = 0;
      var G = C || rt.allocType(h, P);
      switch (o.length) {
        case 0:
          break;
        case 1:
          Ls(e, o[0], G);
          break;
        case 2:
          Rs(e, o[0], o[1], G);
          break;
        case 3:
          Ca(e, o[0], o[1], o[2], G, 0);
          break;
        default:
          Fa(e, o, 0, G, 0);
      }
      return G;
    }
    function Cs(e) {
      for (var o = [], h = e; h.length; h = h[0])
        o.push(h.length);
      return o;
    }
    var xn = {
      "[object Int8Array]": 5120,
      "[object Int16Array]": 5122,
      "[object Int32Array]": 5124,
      "[object Uint8Array]": 5121,
      "[object Uint8ClampedArray]": 5121,
      "[object Uint16Array]": 5123,
      "[object Uint32Array]": 5125,
      "[object Float32Array]": 5126,
      "[object Float64Array]": 5121,
      "[object ArrayBuffer]": 5121
    }, Fs = 5120, Gs = 5122, Ds = 5124, Ms = 5121, Ns = 5123, ks = 5125, Bs = 5126, Is = 5126, Yt = {
      int8: Fs,
      int16: Gs,
      int32: Ds,
      uint8: Ms,
      uint16: Ns,
      uint32: ks,
      float: Bs,
      float32: Is
    }, Ps = 35048, Us = 35040, jr = {
      dynamic: Ps,
      stream: Us,
      static: 35044
    }, En = zr.flatten, Ga = zr.shape, Da = 35044, $s = 35040, An = 5121, Tn = 5126, zt = [];
    zt[5120] = 1, zt[5122] = 2, zt[5124] = 4, zt[5121] = 1, zt[5123] = 2, zt[5125] = 4, zt[5126] = 4;
    function Xr(e) {
      return xn[Object.prototype.toString.call(e)] | 0;
    }
    function Ma(e, o) {
      for (var h = 0; h < o.length; ++h)
        e[h] = o[h];
    }
    function Na(e, o, h, C, P, R, G) {
      for (var V = 0, q = 0; q < h; ++q)
        for (var Q = 0; Q < C; ++Q)
          e[V++] = o[P * q + R * Q + G];
    }
    function zs(e, o, h, C) {
      var P = 0, R = {};
      function G(A) {
        this.id = P++, this.buffer = e.createBuffer(), this.type = A, this.usage = Da, this.byteLength = 0, this.dimension = 1, this.dtype = An, this.persistentData = null, h.profile && (this.stats = { size: 0 });
      }
      G.prototype.bind = function() {
        e.bindBuffer(this.type, this.buffer);
      }, G.prototype.destroy = function() {
        ae(this);
      };
      var V = [];
      function q(A, D) {
        var K = V.pop();
        return K || (K = new G(A)), K.bind(), J(K, D, $s, 0, 1, !1), K;
      }
      function Q(A) {
        V.push(A);
      }
      function W(A, D, K) {
        A.byteLength = D.byteLength, e.bufferData(A.type, D, K);
      }
      function J(A, D, K, se, z, ue) {
        var X;
        if (A.usage = K, Array.isArray(D)) {
          if (A.dtype = se || Tn, D.length > 0) {
            var re;
            if (Array.isArray(D[0])) {
              X = Ga(D);
              for (var j = 1, ne = 1; ne < X.length; ++ne)
                j *= X[ne];
              A.dimension = j, re = En(D, X, A.dtype), W(A, re, K), ue ? A.persistentData = re : rt.freeType(re);
            } else if (typeof D[0] == "number") {
              A.dimension = z;
              var ye = rt.allocType(A.dtype, D.length);
              Ma(ye, D), W(A, ye, K), ue ? A.persistentData = ye : rt.freeType(ye);
            } else
              d(D[0]) ? (A.dimension = D[0].length, A.dtype = se || Xr(D[0]) || Tn, re = En(
                D,
                [D.length, D[0].length],
                A.dtype
              ), W(A, re, K), ue ? A.persistentData = re : rt.freeType(re)) : c.raise("invalid buffer data");
          }
        } else if (d(D))
          A.dtype = se || Xr(D), A.dimension = z, W(A, D, K), ue && (A.persistentData = new Uint8Array(new Uint8Array(D.buffer)));
        else if (Dt(D)) {
          X = D.shape;
          var Ee = D.stride, ie = D.offset, Z = 0, $ = 0, ge = 0, we = 0;
          X.length === 1 ? (Z = X[0], $ = 1, ge = Ee[0], we = 0) : X.length === 2 ? (Z = X[0], $ = X[1], ge = Ee[0], we = Ee[1]) : c.raise("invalid shape"), A.dtype = se || Xr(D.data) || Tn, A.dimension = $;
          var de = rt.allocType(A.dtype, Z * $);
          Na(
            de,
            D.data,
            Z,
            $,
            ge,
            we,
            ie
          ), W(A, de, K), ue ? A.persistentData = de : rt.freeType(de);
        } else
          D instanceof ArrayBuffer ? (A.dtype = An, A.dimension = z, W(A, D, K), ue && (A.persistentData = new Uint8Array(new Uint8Array(D)))) : c.raise("invalid buffer data");
      }
      function ae(A) {
        o.bufferCount--, C(A);
        var D = A.buffer;
        c(D, "buffer must not be deleted already"), e.deleteBuffer(D), A.buffer = null, delete R[A.id];
      }
      function H(A, D, K, se) {
        o.bufferCount++;
        var z = new G(D);
        R[z.id] = z;
        function ue(j) {
          var ne = Da, ye = null, Ee = 0, ie = 0, Z = 1;
          return Array.isArray(j) || d(j) || Dt(j) || j instanceof ArrayBuffer ? ye = j : typeof j == "number" ? Ee = j | 0 : j && (c.type(
            j,
            "object",
            "buffer arguments must be an object, a number or an array"
          ), "data" in j && (c(
            ye === null || Array.isArray(ye) || d(ye) || Dt(ye),
            "invalid data for buffer"
          ), ye = j.data), "usage" in j && (c.parameter(j.usage, jr, "invalid buffer usage"), ne = jr[j.usage]), "type" in j && (c.parameter(j.type, Yt, "invalid buffer type"), ie = Yt[j.type]), "dimension" in j && (c.type(j.dimension, "number", "invalid dimension"), Z = j.dimension | 0), "length" in j && (c.nni(Ee, "buffer length must be a nonnegative integer"), Ee = j.length | 0)), z.bind(), ye ? J(z, ye, ne, ie, Z, se) : (Ee && e.bufferData(z.type, Ee, ne), z.dtype = ie || An, z.usage = ne, z.dimension = Z, z.byteLength = Ee), h.profile && (z.stats.size = z.byteLength * zt[z.dtype]), ue;
        }
        function X(j, ne) {
          c(
            ne + j.byteLength <= z.byteLength,
            "invalid buffer subdata call, buffer is too small.  Can't write data of size " + j.byteLength + " starting from offset " + ne + " to a buffer of size " + z.byteLength
          ), e.bufferSubData(z.type, ne, j);
        }
        function re(j, ne) {
          var ye = (ne || 0) | 0, Ee;
          if (z.bind(), d(j) || j instanceof ArrayBuffer)
            X(j, ye);
          else if (Array.isArray(j)) {
            if (j.length > 0)
              if (typeof j[0] == "number") {
                var ie = rt.allocType(z.dtype, j.length);
                Ma(ie, j), X(ie, ye), rt.freeType(ie);
              } else if (Array.isArray(j[0]) || d(j[0])) {
                Ee = Ga(j);
                var Z = En(j, Ee, z.dtype);
                X(Z, ye), rt.freeType(Z);
              } else
                c.raise("invalid buffer data");
          } else if (Dt(j)) {
            Ee = j.shape;
            var $ = j.stride, ge = 0, we = 0, de = 0, Ge = 0;
            Ee.length === 1 ? (ge = Ee[0], we = 1, de = $[0], Ge = 0) : Ee.length === 2 ? (ge = Ee[0], we = Ee[1], de = $[0], Ge = $[1]) : c.raise("invalid shape");
            var Ae = Array.isArray(j.data) ? z.dtype : Xr(j.data), Ce = rt.allocType(Ae, ge * we);
            Na(
              Ce,
              j.data,
              ge,
              we,
              de,
              Ge,
              j.offset
            ), X(Ce, ye), rt.freeType(Ce);
          } else
            c.raise("invalid data for buffer subdata");
          return ue;
        }
        return K || ue(A), ue._reglType = "buffer", ue._buffer = z, ue.subdata = re, h.profile && (ue.stats = z.stats), ue.destroy = function() {
          ae(z);
        }, ue;
      }
      function te() {
        wt(R).forEach(function(A) {
          A.buffer = e.createBuffer(), e.bindBuffer(A.type, A.buffer), e.bufferData(
            A.type,
            A.persistentData || A.byteLength,
            A.usage
          );
        });
      }
      return h.profile && (o.getTotalBufferSize = function() {
        var A = 0;
        return Object.keys(R).forEach(function(D) {
          A += R[D].stats.size;
        }), A;
      }), {
        create: H,
        createStream: q,
        destroyStream: Q,
        clear: function() {
          wt(R).forEach(ae), V.forEach(ae);
        },
        getBuffer: function(A) {
          return A && A._buffer instanceof G ? A._buffer : null;
        },
        restore: te,
        _initBuffer: J
      };
    }
    var js = 0, Xs = 0, Vs = 1, Hs = 1, qs = 4, Ws = 4, or = {
      points: js,
      point: Xs,
      lines: Vs,
      line: Hs,
      triangles: qs,
      triangle: Ws,
      "line loop": 2,
      "line strip": 3,
      "triangle strip": 5,
      "triangle fan": 6
    }, Ys = 0, Ks = 1, Tr = 4, Qs = 5120, sr = 5121, ka = 5122, fr = 5123, Ba = 5124, Kt = 5125, Sn = 34963, Zs = 35040, Js = 35044;
    function ef(e, o, h, C) {
      var P = {}, R = 0, G = {
        uint8: sr,
        uint16: fr
      };
      o.oes_element_index_uint && (G.uint32 = Kt);
      function V(te) {
        this.id = R++, P[this.id] = this, this.buffer = te, this.primType = Tr, this.vertCount = 0, this.type = 0;
      }
      V.prototype.bind = function() {
        this.buffer.bind();
      };
      var q = [];
      function Q(te) {
        var A = q.pop();
        return A || (A = new V(h.create(
          null,
          Sn,
          !0,
          !1
        )._buffer)), J(A, te, Zs, -1, -1, 0, 0), A;
      }
      function W(te) {
        q.push(te);
      }
      function J(te, A, D, K, se, z, ue) {
        te.buffer.bind();
        var X;
        if (A) {
          var re = ue;
          !ue && (!d(A) || Dt(A) && !d(A.data)) && (re = o.oes_element_index_uint ? Kt : fr), h._initBuffer(
            te.buffer,
            A,
            D,
            re,
            3
          );
        } else
          e.bufferData(Sn, z, D), te.buffer.dtype = X || sr, te.buffer.usage = D, te.buffer.dimension = 3, te.buffer.byteLength = z;
        if (X = ue, !ue) {
          switch (te.buffer.dtype) {
            case sr:
            case Qs:
              X = sr;
              break;
            case fr:
            case ka:
              X = fr;
              break;
            case Kt:
            case Ba:
              X = Kt;
              break;
            default:
              c.raise("unsupported type for element array");
          }
          te.buffer.dtype = X;
        }
        te.type = X, c(
          X !== Kt || !!o.oes_element_index_uint,
          "32 bit element buffers not supported, enable oes_element_index_uint first"
        );
        var j = se;
        j < 0 && (j = te.buffer.byteLength, X === fr ? j >>= 1 : X === Kt && (j >>= 2)), te.vertCount = j;
        var ne = K;
        if (K < 0) {
          ne = Tr;
          var ye = te.buffer.dimension;
          ye === 1 && (ne = Ys), ye === 2 && (ne = Ks), ye === 3 && (ne = Tr);
        }
        te.primType = ne;
      }
      function ae(te) {
        C.elementsCount--, c(te.buffer !== null, "must not double destroy elements"), delete P[te.id], te.buffer.destroy(), te.buffer = null;
      }
      function H(te, A) {
        var D = h.create(null, Sn, !0), K = new V(D._buffer);
        C.elementsCount++;
        function se(z) {
          if (!z)
            D(), K.primType = Tr, K.vertCount = 0, K.type = sr;
          else if (typeof z == "number")
            D(z), K.primType = Tr, K.vertCount = z | 0, K.type = sr;
          else {
            var ue = null, X = Js, re = -1, j = -1, ne = 0, ye = 0;
            Array.isArray(z) || d(z) || Dt(z) ? ue = z : (c.type(z, "object", "invalid arguments for elements"), "data" in z && (ue = z.data, c(
              Array.isArray(ue) || d(ue) || Dt(ue),
              "invalid data for element buffer"
            )), "usage" in z && (c.parameter(
              z.usage,
              jr,
              "invalid element buffer usage"
            ), X = jr[z.usage]), "primitive" in z && (c.parameter(
              z.primitive,
              or,
              "invalid element buffer primitive"
            ), re = or[z.primitive]), "count" in z && (c(
              typeof z.count == "number" && z.count >= 0,
              "invalid vertex count for elements"
            ), j = z.count | 0), "type" in z && (c.parameter(
              z.type,
              G,
              "invalid buffer type"
            ), ye = G[z.type]), "length" in z ? ne = z.length | 0 : (ne = j, ye === fr || ye === ka ? ne *= 2 : (ye === Kt || ye === Ba) && (ne *= 4))), J(
              K,
              ue,
              X,
              re,
              j,
              ne,
              ye
            );
          }
          return se;
        }
        return se(te), se._reglType = "elements", se._elements = K, se.subdata = function(z, ue) {
          return D.subdata(z, ue), se;
        }, se.destroy = function() {
          ae(K);
        }, se;
      }
      return {
        create: H,
        createStream: Q,
        destroyStream: W,
        getElements: function(te) {
          return typeof te == "function" && te._elements instanceof V ? te._elements : null;
        },
        clear: function() {
          wt(P).forEach(ae);
        }
      };
    }
    var Ia = new Float32Array(1), tf = new Uint32Array(Ia.buffer), rf = 5123;
    function Pa(e) {
      for (var o = rt.allocType(rf, e.length), h = 0; h < e.length; ++h)
        if (isNaN(e[h]))
          o[h] = 65535;
        else if (e[h] === 1 / 0)
          o[h] = 31744;
        else if (e[h] === -1 / 0)
          o[h] = 64512;
        else {
          Ia[0] = e[h];
          var C = tf[0], P = C >>> 31 << 15, R = (C << 1 >>> 24) - 127, G = C >> 13 & 1023;
          if (R < -24)
            o[h] = P;
          else if (R < -14) {
            var V = -14 - R;
            o[h] = P + (G + 1024 >> V);
          } else
            R > 15 ? o[h] = P + 31744 : o[h] = P + (R + 15 << 10) + G;
        }
      return o;
    }
    function Je(e) {
      return Array.isArray(e) || d(e);
    }
    var Ua = function(e) {
      return !(e & e - 1) && !!e;
    }, nf = 34467, Bt = 3553, wn = 34067, Vr = 34069, Qt = 6408, Ln = 6406, Hr = 6407, Sr = 6409, qr = 6410, $a = 32854, Rn = 32855, za = 36194, af = 32819, of = 32820, sf = 33635, ff = 34042, On = 6402, Wr = 34041, Cn = 35904, Fn = 35906, ur = 36193, Gn = 33776, Dn = 33777, Mn = 33778, Nn = 33779, ja = 35986, Xa = 35987, Va = 34798, Ha = 35840, qa = 35841, Wa = 35842, Ya = 35843, Ka = 36196, cr = 5121, kn = 5123, Bn = 5125, wr = 5126, uf = 10242, cf = 10243, lf = 10497, In = 33071, df = 33648, hf = 10240, mf = 10241, Pn = 9728, pf = 9729, Un = 9984, Qa = 9985, Za = 9986, $n = 9987, vf = 33170, Yr = 4352, yf = 4353, _f = 4354, bf = 34046, gf = 3317, xf = 37440, Ef = 37441, Af = 37443, Ja = 37444, Lr = 33984, Tf = [
      Un,
      Za,
      Qa,
      $n
    ], Kr = [
      0,
      Sr,
      qr,
      Hr,
      Qt
    ], Rt = {};
    Rt[Sr] = Rt[Ln] = Rt[On] = 1, Rt[Wr] = Rt[qr] = 2, Rt[Hr] = Rt[Cn] = 3, Rt[Qt] = Rt[Fn] = 4;
    function lr(e) {
      return "[object " + e + "]";
    }
    var ei = lr("HTMLCanvasElement"), ti = lr("OffscreenCanvas"), ri = lr("CanvasRenderingContext2D"), ni = lr("ImageBitmap"), ai = lr("HTMLImageElement"), ii = lr("HTMLVideoElement"), Sf = Object.keys(xn).concat([
      ei,
      ti,
      ri,
      ni,
      ai,
      ii
    ]), dr = [];
    dr[cr] = 1, dr[wr] = 4, dr[ur] = 2, dr[kn] = 2, dr[Bn] = 4;
    var ht = [];
    ht[$a] = 2, ht[Rn] = 2, ht[za] = 2, ht[Wr] = 4, ht[Gn] = 0.5, ht[Dn] = 0.5, ht[Mn] = 1, ht[Nn] = 1, ht[ja] = 0.5, ht[Xa] = 1, ht[Va] = 1, ht[Ha] = 0.5, ht[qa] = 0.25, ht[Wa] = 0.5, ht[Ya] = 0.25, ht[Ka] = 0.5;
    function oi(e) {
      return Array.isArray(e) && (e.length === 0 || typeof e[0] == "number");
    }
    function si(e) {
      if (!Array.isArray(e))
        return !1;
      var o = e.length;
      return !(o === 0 || !Je(e[0]));
    }
    function Zt(e) {
      return Object.prototype.toString.call(e);
    }
    function fi(e) {
      return Zt(e) === ei;
    }
    function ui(e) {
      return Zt(e) === ti;
    }
    function wf(e) {
      return Zt(e) === ri;
    }
    function Lf(e) {
      return Zt(e) === ni;
    }
    function Rf(e) {
      return Zt(e) === ai;
    }
    function Of(e) {
      return Zt(e) === ii;
    }
    function zn(e) {
      if (!e)
        return !1;
      var o = Zt(e);
      return Sf.indexOf(o) >= 0 ? !0 : oi(e) || si(e) || Dt(e);
    }
    function ci(e) {
      return xn[Object.prototype.toString.call(e)] | 0;
    }
    function Cf(e, o) {
      var h = o.length;
      switch (e.type) {
        case cr:
        case kn:
        case Bn:
        case wr:
          var C = rt.allocType(e.type, h);
          C.set(o), e.data = C;
          break;
        case ur:
          e.data = Pa(o);
          break;
        default:
          c.raise("unsupported texture type, must specify a typed array");
      }
    }
    function li(e, o) {
      return rt.allocType(
        e.type === ur ? wr : e.type,
        o
      );
    }
    function di(e, o) {
      e.type === ur ? (e.data = Pa(o), rt.freeType(o)) : e.data = o;
    }
    function Ff(e, o, h, C, P, R) {
      for (var G = e.width, V = e.height, q = e.channels, Q = G * V * q, W = li(e, Q), J = 0, ae = 0; ae < V; ++ae)
        for (var H = 0; H < G; ++H)
          for (var te = 0; te < q; ++te)
            W[J++] = o[h * H + C * ae + P * te + R];
      di(e, W);
    }
    function Qr(e, o, h, C, P, R) {
      var G;
      if (typeof ht[e] < "u" ? G = ht[e] : G = Rt[e] * dr[o], R && (G *= 6), P) {
        for (var V = 0, q = h; q >= 1; )
          V += G * q * q, q /= 2;
        return V;
      } else
        return G * h * C;
    }
    function Gf(e, o, h, C, P, R, G) {
      var V = {
        "don't care": Yr,
        "dont care": Yr,
        nice: _f,
        fast: yf
      }, q = {
        repeat: lf,
        clamp: In,
        mirror: df
      }, Q = {
        nearest: Pn,
        linear: pf
      }, W = _({
        mipmap: $n,
        "nearest mipmap nearest": Un,
        "linear mipmap nearest": Qa,
        "nearest mipmap linear": Za,
        "linear mipmap linear": $n
      }, Q), J = {
        none: 0,
        browser: Ja
      }, ae = {
        uint8: cr,
        rgba4: af,
        rgb565: sf,
        "rgb5 a1": of
      }, H = {
        alpha: Ln,
        luminance: Sr,
        "luminance alpha": qr,
        rgb: Hr,
        rgba: Qt,
        rgba4: $a,
        "rgb5 a1": Rn,
        rgb565: za
      }, te = {};
      o.ext_srgb && (H.srgb = Cn, H.srgba = Fn), o.oes_texture_float && (ae.float32 = ae.float = wr), o.oes_texture_half_float && (ae.float16 = ae["half float"] = ur), o.webgl_depth_texture && (_(H, {
        depth: On,
        "depth stencil": Wr
      }), _(ae, {
        uint16: kn,
        uint32: Bn,
        "depth stencil": ff
      })), o.webgl_compressed_texture_s3tc && _(te, {
        "rgb s3tc dxt1": Gn,
        "rgba s3tc dxt1": Dn,
        "rgba s3tc dxt3": Mn,
        "rgba s3tc dxt5": Nn
      }), o.webgl_compressed_texture_atc && _(te, {
        "rgb atc": ja,
        "rgba atc explicit alpha": Xa,
        "rgba atc interpolated alpha": Va
      }), o.webgl_compressed_texture_pvrtc && _(te, {
        "rgb pvrtc 4bppv1": Ha,
        "rgb pvrtc 2bppv1": qa,
        "rgba pvrtc 4bppv1": Wa,
        "rgba pvrtc 2bppv1": Ya
      }), o.webgl_compressed_texture_etc1 && (te["rgb etc1"] = Ka);
      var A = Array.prototype.slice.call(
        e.getParameter(nf)
      );
      Object.keys(te).forEach(function(l) {
        var F = te[l];
        A.indexOf(F) >= 0 && (H[l] = F);
      });
      var D = Object.keys(H);
      h.textureFormats = D;
      var K = [];
      Object.keys(H).forEach(function(l) {
        var F = H[l];
        K[F] = l;
      });
      var se = [];
      Object.keys(ae).forEach(function(l) {
        var F = ae[l];
        se[F] = l;
      });
      var z = [];
      Object.keys(Q).forEach(function(l) {
        var F = Q[l];
        z[F] = l;
      });
      var ue = [];
      Object.keys(W).forEach(function(l) {
        var F = W[l];
        ue[F] = l;
      });
      var X = [];
      Object.keys(q).forEach(function(l) {
        var F = q[l];
        X[F] = l;
      });
      var re = D.reduce(function(l, F) {
        var L = H[F];
        return L === Sr || L === Ln || L === Sr || L === qr || L === On || L === Wr || o.ext_srgb && (L === Cn || L === Fn) ? l[L] = L : L === Rn || F.indexOf("rgba") >= 0 ? l[L] = Qt : l[L] = Hr, l;
      }, {});
      function j() {
        this.internalformat = Qt, this.format = Qt, this.type = cr, this.compressed = !1, this.premultiplyAlpha = !1, this.flipY = !1, this.unpackAlignment = 1, this.colorSpace = Ja, this.width = 0, this.height = 0, this.channels = 0;
      }
      function ne(l, F) {
        l.internalformat = F.internalformat, l.format = F.format, l.type = F.type, l.compressed = F.compressed, l.premultiplyAlpha = F.premultiplyAlpha, l.flipY = F.flipY, l.unpackAlignment = F.unpackAlignment, l.colorSpace = F.colorSpace, l.width = F.width, l.height = F.height, l.channels = F.channels;
      }
      function ye(l, F) {
        if (!(typeof F != "object" || !F)) {
          if ("premultiplyAlpha" in F && (c.type(
            F.premultiplyAlpha,
            "boolean",
            "invalid premultiplyAlpha"
          ), l.premultiplyAlpha = F.premultiplyAlpha), "flipY" in F && (c.type(
            F.flipY,
            "boolean",
            "invalid texture flip"
          ), l.flipY = F.flipY), "alignment" in F && (c.oneOf(
            F.alignment,
            [1, 2, 4, 8],
            "invalid texture unpack alignment"
          ), l.unpackAlignment = F.alignment), "colorSpace" in F && (c.parameter(
            F.colorSpace,
            J,
            "invalid colorSpace"
          ), l.colorSpace = J[F.colorSpace]), "type" in F) {
            var L = F.type;
            c(
              o.oes_texture_float || !(L === "float" || L === "float32"),
              "you must enable the OES_texture_float extension in order to use floating point textures."
            ), c(
              o.oes_texture_half_float || !(L === "half float" || L === "float16"),
              "you must enable the OES_texture_half_float extension in order to use 16-bit floating point textures."
            ), c(
              o.webgl_depth_texture || !(L === "uint16" || L === "uint32" || L === "depth stencil"),
              "you must enable the WEBGL_depth_texture extension in order to use depth/stencil textures."
            ), c.parameter(
              L,
              ae,
              "invalid texture type"
            ), l.type = ae[L];
          }
          var ce = l.width, De = l.height, f = l.channels, t = !1;
          "shape" in F ? (c(
            Array.isArray(F.shape) && F.shape.length >= 2,
            "shape must be an array"
          ), ce = F.shape[0], De = F.shape[1], F.shape.length === 3 && (f = F.shape[2], c(f > 0 && f <= 4, "invalid number of channels"), t = !0), c(ce >= 0 && ce <= h.maxTextureSize, "invalid width"), c(De >= 0 && De <= h.maxTextureSize, "invalid height")) : ("radius" in F && (ce = De = F.radius, c(ce >= 0 && ce <= h.maxTextureSize, "invalid radius")), "width" in F && (ce = F.width, c(ce >= 0 && ce <= h.maxTextureSize, "invalid width")), "height" in F && (De = F.height, c(De >= 0 && De <= h.maxTextureSize, "invalid height")), "channels" in F && (f = F.channels, c(f > 0 && f <= 4, "invalid number of channels"), t = !0)), l.width = ce | 0, l.height = De | 0, l.channels = f | 0;
          var p = !1;
          if ("format" in F) {
            var E = F.format;
            c(
              o.webgl_depth_texture || !(E === "depth" || E === "depth stencil"),
              "you must enable the WEBGL_depth_texture extension in order to use depth/stencil textures."
            ), c.parameter(
              E,
              H,
              "invalid texture format"
            );
            var S = l.internalformat = H[E];
            l.format = re[S], E in ae && ("type" in F || (l.type = ae[E])), E in te && (l.compressed = !0), p = !0;
          }
          !t && p ? l.channels = Rt[l.format] : t && !p ? l.channels !== Kr[l.format] && (l.format = l.internalformat = Kr[l.channels]) : p && t && c(
            l.channels === Rt[l.format],
            "number of channels inconsistent with specified format"
          );
        }
      }
      function Ee(l) {
        e.pixelStorei(xf, l.flipY), e.pixelStorei(Ef, l.premultiplyAlpha), e.pixelStorei(Af, l.colorSpace), e.pixelStorei(gf, l.unpackAlignment);
      }
      function ie() {
        j.call(this), this.xOffset = 0, this.yOffset = 0, this.data = null, this.needsFree = !1, this.element = null, this.needsCopy = !1;
      }
      function Z(l, F) {
        var L = null;
        if (zn(F) ? L = F : F && (c.type(F, "object", "invalid pixel data type"), ye(l, F), "x" in F && (l.xOffset = F.x | 0), "y" in F && (l.yOffset = F.y | 0), zn(F.data) && (L = F.data)), c(
          !l.compressed || L instanceof Uint8Array,
          "compressed texture data must be stored in a uint8array"
        ), F.copy) {
          c(!L, "can not specify copy and data field for the same texture");
          var ce = P.viewportWidth, De = P.viewportHeight;
          l.width = l.width || ce - l.xOffset, l.height = l.height || De - l.yOffset, l.needsCopy = !0, c(
            l.xOffset >= 0 && l.xOffset < ce && l.yOffset >= 0 && l.yOffset < De && l.width > 0 && l.width <= ce && l.height > 0 && l.height <= De,
            "copy texture read out of bounds"
          );
        } else if (!L)
          l.width = l.width || 1, l.height = l.height || 1, l.channels = l.channels || 4;
        else if (d(L))
          l.channels = l.channels || 4, l.data = L, !("type" in F) && l.type === cr && (l.type = ci(L));
        else if (oi(L))
          l.channels = l.channels || 4, Cf(l, L), l.alignment = 1, l.needsFree = !0;
        else if (Dt(L)) {
          var f = L.data;
          !Array.isArray(f) && l.type === cr && (l.type = ci(f));
          var t = L.shape, p = L.stride, E, S, y, v, b, u;
          t.length === 3 ? (y = t[2], u = p[2]) : (c(t.length === 2, "invalid ndarray pixel data, must be 2 or 3D"), y = 1, u = 1), E = t[0], S = t[1], v = p[0], b = p[1], l.alignment = 1, l.width = E, l.height = S, l.channels = y, l.format = l.internalformat = Kr[y], l.needsFree = !0, Ff(l, f, v, b, u, L.offset);
        } else if (fi(L) || ui(L) || wf(L))
          fi(L) || ui(L) ? l.element = L : l.element = L.canvas, l.width = l.element.width, l.height = l.element.height, l.channels = 4;
        else if (Lf(L))
          l.element = L, l.width = L.width, l.height = L.height, l.channels = 4;
        else if (Rf(L))
          l.element = L, l.width = L.naturalWidth, l.height = L.naturalHeight, l.channels = 4;
        else if (Of(L))
          l.element = L, l.width = L.videoWidth, l.height = L.videoHeight, l.channels = 4;
        else if (si(L)) {
          var m = l.width || L[0].length, s = l.height || L.length, g = l.channels;
          Je(L[0][0]) ? g = g || L[0][0].length : g = g || 1;
          for (var w = zr.shape(L), B = 1, U = 0; U < w.length; ++U)
            B *= w[U];
          var k = li(l, B);
          zr.flatten(L, w, "", k), di(l, k), l.alignment = 1, l.width = m, l.height = s, l.channels = g, l.format = l.internalformat = Kr[g], l.needsFree = !0;
        }
        l.type === wr ? c(
          h.extensions.indexOf("oes_texture_float") >= 0,
          "oes_texture_float extension not enabled"
        ) : l.type === ur && c(
          h.extensions.indexOf("oes_texture_half_float") >= 0,
          "oes_texture_half_float extension not enabled"
        );
      }
      function $(l, F, L) {
        var ce = l.element, De = l.data, f = l.internalformat, t = l.format, p = l.type, E = l.width, S = l.height;
        Ee(l), ce ? e.texImage2D(F, L, t, t, p, ce) : l.compressed ? e.compressedTexImage2D(F, L, f, E, S, 0, De) : l.needsCopy ? (C(), e.copyTexImage2D(
          F,
          L,
          t,
          l.xOffset,
          l.yOffset,
          E,
          S,
          0
        )) : e.texImage2D(F, L, t, E, S, 0, t, p, De || null);
      }
      function ge(l, F, L, ce, De) {
        var f = l.element, t = l.data, p = l.internalformat, E = l.format, S = l.type, y = l.width, v = l.height;
        Ee(l), f ? e.texSubImage2D(
          F,
          De,
          L,
          ce,
          E,
          S,
          f
        ) : l.compressed ? e.compressedTexSubImage2D(
          F,
          De,
          L,
          ce,
          p,
          y,
          v,
          t
        ) : l.needsCopy ? (C(), e.copyTexSubImage2D(
          F,
          De,
          L,
          ce,
          l.xOffset,
          l.yOffset,
          y,
          v
        )) : e.texSubImage2D(
          F,
          De,
          L,
          ce,
          y,
          v,
          E,
          S,
          t
        );
      }
      var we = [];
      function de() {
        return we.pop() || new ie();
      }
      function Ge(l) {
        l.needsFree && rt.freeType(l.data), ie.call(l), we.push(l);
      }
      function Ae() {
        j.call(this), this.genMipmaps = !1, this.mipmapHint = Yr, this.mipmask = 0, this.images = Array(16);
      }
      function Ce(l, F, L) {
        var ce = l.images[0] = de();
        l.mipmask = 1, ce.width = l.width = F, ce.height = l.height = L, ce.channels = l.channels = 4;
      }
      function Ue(l, F) {
        var L = null;
        if (zn(F))
          L = l.images[0] = de(), ne(L, l), Z(L, F), l.mipmask = 1;
        else if (ye(l, F), Array.isArray(F.mipmap))
          for (var ce = F.mipmap, De = 0; De < ce.length; ++De)
            L = l.images[De] = de(), ne(L, l), L.width >>= De, L.height >>= De, Z(L, ce[De]), l.mipmask |= 1 << De;
        else
          L = l.images[0] = de(), ne(L, l), Z(L, F), l.mipmask = 1;
        ne(l, l.images[0]), l.compressed && (l.internalformat === Gn || l.internalformat === Dn || l.internalformat === Mn || l.internalformat === Nn) && c(
          l.width % 4 === 0 && l.height % 4 === 0,
          "for compressed texture formats, mipmap level 0 must have width and height that are a multiple of 4"
        );
      }
      function at(l, F) {
        for (var L = l.images, ce = 0; ce < L.length; ++ce) {
          if (!L[ce])
            return;
          $(L[ce], F, ce);
        }
      }
      var ct = [];
      function ke() {
        var l = ct.pop() || new Ae();
        j.call(l), l.mipmask = 0;
        for (var F = 0; F < 16; ++F)
          l.images[F] = null;
        return l;
      }
      function ot(l) {
        for (var F = l.images, L = 0; L < F.length; ++L)
          F[L] && Ge(F[L]), F[L] = null;
        ct.push(l);
      }
      function Ye() {
        this.minFilter = Pn, this.magFilter = Pn, this.wrapS = In, this.wrapT = In, this.anisotropic = 1, this.genMipmaps = !1, this.mipmapHint = Yr;
      }
      function it(l, F) {
        if ("min" in F) {
          var L = F.min;
          c.parameter(L, W), l.minFilter = W[L], Tf.indexOf(l.minFilter) >= 0 && !("faces" in F) && (l.genMipmaps = !0);
        }
        if ("mag" in F) {
          var ce = F.mag;
          c.parameter(ce, Q), l.magFilter = Q[ce];
        }
        var De = l.wrapS, f = l.wrapT;
        if ("wrap" in F) {
          var t = F.wrap;
          typeof t == "string" ? (c.parameter(t, q), De = f = q[t]) : Array.isArray(t) && (c.parameter(t[0], q), c.parameter(t[1], q), De = q[t[0]], f = q[t[1]]);
        } else {
          if ("wrapS" in F) {
            var p = F.wrapS;
            c.parameter(p, q), De = q[p];
          }
          if ("wrapT" in F) {
            var E = F.wrapT;
            c.parameter(E, q), f = q[E];
          }
        }
        if (l.wrapS = De, l.wrapT = f, "anisotropic" in F) {
          var S = F.anisotropic;
          c(
            typeof S == "number" && S >= 1 && S <= h.maxAnisotropic,
            "aniso samples must be between 1 and "
          ), l.anisotropic = F.anisotropic;
        }
        if ("mipmap" in F) {
          var y = !1;
          switch (typeof F.mipmap) {
            case "string":
              c.parameter(
                F.mipmap,
                V,
                "invalid mipmap hint"
              ), l.mipmapHint = V[F.mipmap], l.genMipmaps = !0, y = !0;
              break;
            case "boolean":
              y = l.genMipmaps = F.mipmap;
              break;
            case "object":
              c(Array.isArray(F.mipmap), "invalid mipmap type"), l.genMipmaps = !1, y = !0;
              break;
            default:
              c.raise("invalid mipmap type");
          }
          y && !("min" in F) && (l.minFilter = Un);
        }
      }
      function st(l, F) {
        e.texParameteri(F, mf, l.minFilter), e.texParameteri(F, hf, l.magFilter), e.texParameteri(F, uf, l.wrapS), e.texParameteri(F, cf, l.wrapT), o.ext_texture_filter_anisotropic && e.texParameteri(F, bf, l.anisotropic), l.genMipmaps && (e.hint(vf, l.mipmapHint), e.generateMipmap(F));
      }
      var ft = 0, lt = {}, mt = h.maxTextureUnits, et = Array(mt).map(function() {
        return null;
      });
      function Le(l) {
        j.call(this), this.mipmask = 0, this.internalformat = Qt, this.id = ft++, this.refCount = 1, this.target = l, this.texture = e.createTexture(), this.unit = -1, this.bindCount = 0, this.texInfo = new Ye(), G.profile && (this.stats = { size: 0 });
      }
      function pt(l) {
        e.activeTexture(Lr), e.bindTexture(l.target, l.texture);
      }
      function Xe() {
        var l = et[0];
        l ? e.bindTexture(l.target, l.texture) : e.bindTexture(Bt, null);
      }
      function _e(l) {
        var F = l.texture;
        c(F, "must not double destroy texture");
        var L = l.unit, ce = l.target;
        L >= 0 && (e.activeTexture(Lr + L), e.bindTexture(ce, null), et[L] = null), e.deleteTexture(F), l.texture = null, l.params = null, l.pixels = null, l.refCount = 0, delete lt[l.id], R.textureCount--;
      }
      _(Le.prototype, {
        bind: function() {
          var l = this;
          l.bindCount += 1;
          var F = l.unit;
          if (F < 0) {
            for (var L = 0; L < mt; ++L) {
              var ce = et[L];
              if (ce) {
                if (ce.bindCount > 0)
                  continue;
                ce.unit = -1;
              }
              et[L] = l, F = L;
              break;
            }
            F >= mt && c.raise("insufficient number of texture units"), G.profile && R.maxTextureUnits < F + 1 && (R.maxTextureUnits = F + 1), l.unit = F, e.activeTexture(Lr + F), e.bindTexture(l.target, l.texture);
          }
          return F;
        },
        unbind: function() {
          this.bindCount -= 1;
        },
        decRef: function() {
          --this.refCount <= 0 && _e(this);
        }
      });
      function Me(l, F) {
        var L = new Le(Bt);
        lt[L.id] = L, R.textureCount++;
        function ce(t, p) {
          var E = L.texInfo;
          Ye.call(E);
          var S = ke();
          return typeof t == "number" ? typeof p == "number" ? Ce(S, t | 0, p | 0) : Ce(S, t | 0, t | 0) : t ? (c.type(t, "object", "invalid arguments to regl.texture"), it(E, t), Ue(S, t)) : Ce(S, 1, 1), E.genMipmaps && (S.mipmask = (S.width << 1) - 1), L.mipmask = S.mipmask, ne(L, S), c.texture2D(E, S, h), L.internalformat = S.internalformat, ce.width = S.width, ce.height = S.height, pt(L), at(S, Bt), st(E, Bt), Xe(), ot(S), G.profile && (L.stats.size = Qr(
            L.internalformat,
            L.type,
            S.width,
            S.height,
            E.genMipmaps,
            !1
          )), ce.format = K[L.internalformat], ce.type = se[L.type], ce.mag = z[E.magFilter], ce.min = ue[E.minFilter], ce.wrapS = X[E.wrapS], ce.wrapT = X[E.wrapT], ce;
        }
        function De(t, p, E, S) {
          c(!!t, "must specify image data");
          var y = p | 0, v = E | 0, b = S | 0, u = de();
          return ne(u, L), u.width = 0, u.height = 0, Z(u, t), u.width = u.width || (L.width >> b) - y, u.height = u.height || (L.height >> b) - v, c(
            L.type === u.type && L.format === u.format && L.internalformat === u.internalformat,
            "incompatible format for texture.subimage"
          ), c(
            y >= 0 && v >= 0 && y + u.width <= L.width && v + u.height <= L.height,
            "texture.subimage write out of bounds"
          ), c(
            L.mipmask & 1 << b,
            "missing mipmap data"
          ), c(
            u.data || u.element || u.needsCopy,
            "missing image data"
          ), pt(L), ge(u, Bt, y, v, b), Xe(), Ge(u), ce;
        }
        function f(t, p) {
          var E = t | 0, S = p | 0 || E;
          if (E === L.width && S === L.height)
            return ce;
          ce.width = L.width = E, ce.height = L.height = S, pt(L);
          for (var y = 0; L.mipmask >> y; ++y) {
            var v = E >> y, b = S >> y;
            if (!v || !b)
              break;
            e.texImage2D(
              Bt,
              y,
              L.format,
              v,
              b,
              0,
              L.format,
              L.type,
              null
            );
          }
          return Xe(), G.profile && (L.stats.size = Qr(
            L.internalformat,
            L.type,
            E,
            S,
            !1,
            !1
          )), ce;
        }
        return ce(l, F), ce.subimage = De, ce.resize = f, ce._reglType = "texture2d", ce._texture = L, G.profile && (ce.stats = L.stats), ce.destroy = function() {
          L.decRef();
        }, ce;
      }
      function Pe(l, F, L, ce, De, f) {
        var t = new Le(wn);
        lt[t.id] = t, R.cubeCount++;
        var p = new Array(6);
        function E(v, b, u, m, s, g) {
          var w, B = t.texInfo;
          for (Ye.call(B), w = 0; w < 6; ++w)
            p[w] = ke();
          if (typeof v == "number" || !v) {
            var U = v | 0 || 1;
            for (w = 0; w < 6; ++w)
              Ce(p[w], U, U);
          } else if (typeof v == "object")
            if (b)
              Ue(p[0], v), Ue(p[1], b), Ue(p[2], u), Ue(p[3], m), Ue(p[4], s), Ue(p[5], g);
            else if (it(B, v), ye(t, v), "faces" in v) {
              var k = v.faces;
              for (c(
                Array.isArray(k) && k.length === 6,
                "cube faces must be a length 6 array"
              ), w = 0; w < 6; ++w)
                c(
                  typeof k[w] == "object" && !!k[w],
                  "invalid input for cube map face"
                ), ne(p[w], t), Ue(p[w], k[w]);
            } else
              for (w = 0; w < 6; ++w)
                Ue(p[w], v);
          else
            c.raise("invalid arguments to cube map");
          for (ne(t, p[0]), h.npotTextureCube || c(Ua(t.width) && Ua(t.height), "your browser does not support non power or two texture dimensions"), B.genMipmaps ? t.mipmask = (p[0].width << 1) - 1 : t.mipmask = p[0].mipmask, c.textureCube(t, B, p, h), t.internalformat = p[0].internalformat, E.width = p[0].width, E.height = p[0].height, pt(t), w = 0; w < 6; ++w)
            at(p[w], Vr + w);
          for (st(B, wn), Xe(), G.profile && (t.stats.size = Qr(
            t.internalformat,
            t.type,
            E.width,
            E.height,
            B.genMipmaps,
            !0
          )), E.format = K[t.internalformat], E.type = se[t.type], E.mag = z[B.magFilter], E.min = ue[B.minFilter], E.wrapS = X[B.wrapS], E.wrapT = X[B.wrapT], w = 0; w < 6; ++w)
            ot(p[w]);
          return E;
        }
        function S(v, b, u, m, s) {
          c(!!b, "must specify image data"), c(typeof v == "number" && v === (v | 0) && v >= 0 && v < 6, "invalid face");
          var g = u | 0, w = m | 0, B = s | 0, U = de();
          return ne(U, t), U.width = 0, U.height = 0, Z(U, b), U.width = U.width || (t.width >> B) - g, U.height = U.height || (t.height >> B) - w, c(
            t.type === U.type && t.format === U.format && t.internalformat === U.internalformat,
            "incompatible format for texture.subimage"
          ), c(
            g >= 0 && w >= 0 && g + U.width <= t.width && w + U.height <= t.height,
            "texture.subimage write out of bounds"
          ), c(
            t.mipmask & 1 << B,
            "missing mipmap data"
          ), c(
            U.data || U.element || U.needsCopy,
            "missing image data"
          ), pt(t), ge(U, Vr + v, g, w, B), Xe(), Ge(U), E;
        }
        function y(v) {
          var b = v | 0;
          if (b !== t.width) {
            E.width = t.width = b, E.height = t.height = b, pt(t);
            for (var u = 0; u < 6; ++u)
              for (var m = 0; t.mipmask >> m; ++m)
                e.texImage2D(
                  Vr + u,
                  m,
                  t.format,
                  b >> m,
                  b >> m,
                  0,
                  t.format,
                  t.type,
                  null
                );
            return Xe(), G.profile && (t.stats.size = Qr(
              t.internalformat,
              t.type,
              E.width,
              E.height,
              !1,
              !0
            )), E;
          }
        }
        return E(l, F, L, ce, De, f), E.subimage = S, E.resize = y, E._reglType = "textureCube", E._texture = t, G.profile && (E.stats = t.stats), E.destroy = function() {
          t.decRef();
        }, E;
      }
      function tt() {
        for (var l = 0; l < mt; ++l)
          e.activeTexture(Lr + l), e.bindTexture(Bt, null), et[l] = null;
        wt(lt).forEach(_e), R.cubeCount = 0, R.textureCount = 0;
      }
      G.profile && (R.getTotalTextureSize = function() {
        var l = 0;
        return Object.keys(lt).forEach(function(F) {
          l += lt[F].stats.size;
        }), l;
      });
      function Pt() {
        for (var l = 0; l < mt; ++l) {
          var F = et[l];
          F && (F.bindCount = 0, F.unit = -1, et[l] = null);
        }
        wt(lt).forEach(function(L) {
          L.texture = e.createTexture(), e.bindTexture(L.target, L.texture);
          for (var ce = 0; ce < 32; ++ce)
            if (L.mipmask & 1 << ce)
              if (L.target === Bt)
                e.texImage2D(
                  Bt,
                  ce,
                  L.internalformat,
                  L.width >> ce,
                  L.height >> ce,
                  0,
                  L.internalformat,
                  L.type,
                  null
                );
              else
                for (var De = 0; De < 6; ++De)
                  e.texImage2D(
                    Vr + De,
                    ce,
                    L.internalformat,
                    L.width >> ce,
                    L.height >> ce,
                    0,
                    L.internalformat,
                    L.type,
                    null
                  );
          st(L.texInfo, L.target);
        });
      }
      function ir() {
        for (var l = 0; l < mt; ++l) {
          var F = et[l];
          F && (F.bindCount = 0, F.unit = -1, et[l] = null), e.activeTexture(Lr + l), e.bindTexture(Bt, null), e.bindTexture(wn, null);
        }
      }
      return {
        create2D: Me,
        createCube: Pe,
        clear: tt,
        getTexture: function(l) {
          return null;
        },
        restore: Pt,
        refresh: ir
      };
    }
    var jt = 36161, Zr = 32854, hi = 32855, mi = 36194, pi = 33189, vi = 36168, yi = 34041, _i = 35907, bi = 34836, gi = 34842, xi = 34843, Mt = [];
    Mt[Zr] = 2, Mt[hi] = 2, Mt[mi] = 2, Mt[pi] = 2, Mt[vi] = 1, Mt[yi] = 4, Mt[_i] = 4, Mt[bi] = 16, Mt[gi] = 8, Mt[xi] = 6;
    function Ei(e, o, h) {
      return Mt[e] * o * h;
    }
    var Df = function(e, o, h, C, P) {
      var R = {
        rgba4: Zr,
        rgb565: mi,
        "rgb5 a1": hi,
        depth: pi,
        stencil: vi,
        "depth stencil": yi
      };
      o.ext_srgb && (R.srgba = _i), o.ext_color_buffer_half_float && (R.rgba16f = gi, R.rgb16f = xi), o.webgl_color_buffer_float && (R.rgba32f = bi);
      var G = [];
      Object.keys(R).forEach(function(H) {
        var te = R[H];
        G[te] = H;
      });
      var V = 0, q = {};
      function Q(H) {
        this.id = V++, this.refCount = 1, this.renderbuffer = H, this.format = Zr, this.width = 0, this.height = 0, P.profile && (this.stats = { size: 0 });
      }
      Q.prototype.decRef = function() {
        --this.refCount <= 0 && W(this);
      };
      function W(H) {
        var te = H.renderbuffer;
        c(te, "must not double destroy renderbuffer"), e.bindRenderbuffer(jt, null), e.deleteRenderbuffer(te), H.renderbuffer = null, H.refCount = 0, delete q[H.id], C.renderbufferCount--;
      }
      function J(H, te) {
        var A = new Q(e.createRenderbuffer());
        q[A.id] = A, C.renderbufferCount++;
        function D(se, z) {
          var ue = 0, X = 0, re = Zr;
          if (typeof se == "object" && se) {
            var j = se;
            if ("shape" in j) {
              var ne = j.shape;
              c(
                Array.isArray(ne) && ne.length >= 2,
                "invalid renderbuffer shape"
              ), ue = ne[0] | 0, X = ne[1] | 0;
            } else
              "radius" in j && (ue = X = j.radius | 0), "width" in j && (ue = j.width | 0), "height" in j && (X = j.height | 0);
            "format" in j && (c.parameter(
              j.format,
              R,
              "invalid renderbuffer format"
            ), re = R[j.format]);
          } else
            typeof se == "number" ? (ue = se | 0, typeof z == "number" ? X = z | 0 : X = ue) : se ? c.raise("invalid arguments to renderbuffer constructor") : ue = X = 1;
          if (c(
            ue > 0 && X > 0 && ue <= h.maxRenderbufferSize && X <= h.maxRenderbufferSize,
            "invalid renderbuffer size"
          ), !(ue === A.width && X === A.height && re === A.format))
            return D.width = A.width = ue, D.height = A.height = X, A.format = re, e.bindRenderbuffer(jt, A.renderbuffer), e.renderbufferStorage(jt, re, ue, X), c(
              e.getError() === 0,
              "invalid render buffer format"
            ), P.profile && (A.stats.size = Ei(A.format, A.width, A.height)), D.format = G[A.format], D;
        }
        function K(se, z) {
          var ue = se | 0, X = z | 0 || ue;
          return ue === A.width && X === A.height || (c(
            ue > 0 && X > 0 && ue <= h.maxRenderbufferSize && X <= h.maxRenderbufferSize,
            "invalid renderbuffer size"
          ), D.width = A.width = ue, D.height = A.height = X, e.bindRenderbuffer(jt, A.renderbuffer), e.renderbufferStorage(jt, A.format, ue, X), c(
            e.getError() === 0,
            "invalid render buffer format"
          ), P.profile && (A.stats.size = Ei(
            A.format,
            A.width,
            A.height
          ))), D;
        }
        return D(H, te), D.resize = K, D._reglType = "renderbuffer", D._renderbuffer = A, P.profile && (D.stats = A.stats), D.destroy = function() {
          A.decRef();
        }, D;
      }
      P.profile && (C.getTotalRenderbufferSize = function() {
        var H = 0;
        return Object.keys(q).forEach(function(te) {
          H += q[te].stats.size;
        }), H;
      });
      function ae() {
        wt(q).forEach(function(H) {
          H.renderbuffer = e.createRenderbuffer(), e.bindRenderbuffer(jt, H.renderbuffer), e.renderbufferStorage(jt, H.format, H.width, H.height);
        }), e.bindRenderbuffer(jt, null);
      }
      return {
        create: J,
        clear: function() {
          wt(q).forEach(W);
        },
        restore: ae
      };
    }, Ut = 36160, jn = 36161, Jt = 3553, Jr = 34069, Ai = 36064, Ti = 36096, Si = 36128, wi = 33306, Li = 36053, Mf = 36054, Nf = 36055, kf = 36057, Bf = 36061, If = 36193, Pf = 5121, Uf = 5126, Ri = 6407, Oi = 6408, $f = 6402, zf = [
      Ri,
      Oi
    ], Xn = [];
    Xn[Oi] = 4, Xn[Ri] = 3;
    var en = [];
    en[Pf] = 1, en[Uf] = 4, en[If] = 2;
    var jf = 32854, Xf = 32855, Vf = 36194, Hf = 33189, qf = 36168, Ci = 34041, Wf = 35907, Yf = 34836, Kf = 34842, Qf = 34843, Zf = [
      jf,
      Xf,
      Vf,
      Wf,
      Kf,
      Qf,
      Yf
    ], hr = {};
    hr[Li] = "complete", hr[Mf] = "incomplete attachment", hr[kf] = "incomplete dimensions", hr[Nf] = "incomplete, missing attachment", hr[Bf] = "unsupported";
    function Jf(e, o, h, C, P, R) {
      var G = {
        cur: null,
        next: null,
        dirty: !1,
        setFBO: null
      }, V = ["rgba"], q = ["rgba4", "rgb565", "rgb5 a1"];
      o.ext_srgb && q.push("srgba"), o.ext_color_buffer_half_float && q.push("rgba16f", "rgb16f"), o.webgl_color_buffer_float && q.push("rgba32f");
      var Q = ["uint8"];
      o.oes_texture_half_float && Q.push("half float", "float16"), o.oes_texture_float && Q.push("float", "float32");
      function W(ie, Z, $) {
        this.target = ie, this.texture = Z, this.renderbuffer = $;
        var ge = 0, we = 0;
        Z ? (ge = Z.width, we = Z.height) : $ && (ge = $.width, we = $.height), this.width = ge, this.height = we;
      }
      function J(ie) {
        ie && (ie.texture && ie.texture._texture.decRef(), ie.renderbuffer && ie.renderbuffer._renderbuffer.decRef());
      }
      function ae(ie, Z, $) {
        if (ie)
          if (ie.texture) {
            var ge = ie.texture._texture, we = Math.max(1, ge.width), de = Math.max(1, ge.height);
            c(
              we === Z && de === $,
              "inconsistent width/height for supplied texture"
            ), ge.refCount += 1;
          } else {
            var Ge = ie.renderbuffer._renderbuffer;
            c(
              Ge.width === Z && Ge.height === $,
              "inconsistent width/height for renderbuffer"
            ), Ge.refCount += 1;
          }
      }
      function H(ie, Z) {
        Z && (Z.texture ? e.framebufferTexture2D(
          Ut,
          ie,
          Z.target,
          Z.texture._texture.texture,
          0
        ) : e.framebufferRenderbuffer(
          Ut,
          ie,
          jn,
          Z.renderbuffer._renderbuffer.renderbuffer
        ));
      }
      function te(ie) {
        var Z = Jt, $ = null, ge = null, we = ie;
        typeof ie == "object" && (we = ie.data, "target" in ie && (Z = ie.target | 0)), c.type(we, "function", "invalid attachment data");
        var de = we._reglType;
        return de === "texture2d" ? ($ = we, c(Z === Jt)) : de === "textureCube" ? ($ = we, c(
          Z >= Jr && Z < Jr + 6,
          "invalid cube map target"
        )) : de === "renderbuffer" ? (ge = we, Z = jn) : c.raise("invalid regl object for attachment"), new W(Z, $, ge);
      }
      function A(ie, Z, $, ge, we) {
        if ($) {
          var de = C.create2D({
            width: ie,
            height: Z,
            format: ge,
            type: we
          });
          return de._texture.refCount = 0, new W(Jt, de, null);
        } else {
          var Ge = P.create({
            width: ie,
            height: Z,
            format: ge
          });
          return Ge._renderbuffer.refCount = 0, new W(jn, null, Ge);
        }
      }
      function D(ie) {
        return ie && (ie.texture || ie.renderbuffer);
      }
      function K(ie, Z, $) {
        ie && (ie.texture ? ie.texture.resize(Z, $) : ie.renderbuffer && ie.renderbuffer.resize(Z, $), ie.width = Z, ie.height = $);
      }
      var se = 0, z = {};
      function ue() {
        this.id = se++, z[this.id] = this, this.framebuffer = e.createFramebuffer(), this.width = 0, this.height = 0, this.colorAttachments = [], this.depthAttachment = null, this.stencilAttachment = null, this.depthStencilAttachment = null;
      }
      function X(ie) {
        ie.colorAttachments.forEach(J), J(ie.depthAttachment), J(ie.stencilAttachment), J(ie.depthStencilAttachment);
      }
      function re(ie) {
        var Z = ie.framebuffer;
        c(Z, "must not double destroy framebuffer"), e.deleteFramebuffer(Z), ie.framebuffer = null, R.framebufferCount--, delete z[ie.id];
      }
      function j(ie) {
        var Z;
        e.bindFramebuffer(Ut, ie.framebuffer);
        var $ = ie.colorAttachments;
        for (Z = 0; Z < $.length; ++Z)
          H(Ai + Z, $[Z]);
        for (Z = $.length; Z < h.maxColorAttachments; ++Z)
          e.framebufferTexture2D(
            Ut,
            Ai + Z,
            Jt,
            null,
            0
          );
        e.framebufferTexture2D(
          Ut,
          wi,
          Jt,
          null,
          0
        ), e.framebufferTexture2D(
          Ut,
          Ti,
          Jt,
          null,
          0
        ), e.framebufferTexture2D(
          Ut,
          Si,
          Jt,
          null,
          0
        ), H(Ti, ie.depthAttachment), H(Si, ie.stencilAttachment), H(wi, ie.depthStencilAttachment);
        var ge = e.checkFramebufferStatus(Ut);
        !e.isContextLost() && ge !== Li && c.raise("framebuffer configuration not supported, status = " + hr[ge]), e.bindFramebuffer(Ut, G.next ? G.next.framebuffer : null), G.cur = G.next, e.getError();
      }
      function ne(ie, Z) {
        var $ = new ue();
        R.framebufferCount++;
        function ge(de, Ge) {
          var Ae;
          c(
            G.next !== $,
            "can not update framebuffer which is currently in use"
          );
          var Ce = 0, Ue = 0, at = !0, ct = !0, ke = null, ot = !0, Ye = "rgba", it = "uint8", st = 1, ft = null, lt = null, mt = null, et = !1;
          if (typeof de == "number")
            Ce = de | 0, Ue = Ge | 0 || Ce;
          else if (!de)
            Ce = Ue = 1;
          else {
            c.type(de, "object", "invalid arguments for framebuffer");
            var Le = de;
            if ("shape" in Le) {
              var pt = Le.shape;
              c(
                Array.isArray(pt) && pt.length >= 2,
                "invalid shape for framebuffer"
              ), Ce = pt[0], Ue = pt[1];
            } else
              "radius" in Le && (Ce = Ue = Le.radius), "width" in Le && (Ce = Le.width), "height" in Le && (Ue = Le.height);
            ("color" in Le || "colors" in Le) && (ke = Le.color || Le.colors, Array.isArray(ke) && c(
              ke.length === 1 || o.webgl_draw_buffers,
              "multiple render targets not supported"
            )), ke || ("colorCount" in Le && (st = Le.colorCount | 0, c(st > 0, "invalid color buffer count")), "colorTexture" in Le && (ot = !!Le.colorTexture, Ye = "rgba4"), "colorType" in Le && (it = Le.colorType, ot ? (c(
              o.oes_texture_float || !(it === "float" || it === "float32"),
              "you must enable OES_texture_float in order to use floating point framebuffer objects"
            ), c(
              o.oes_texture_half_float || !(it === "half float" || it === "float16"),
              "you must enable OES_texture_half_float in order to use 16-bit floating point framebuffer objects"
            )) : it === "half float" || it === "float16" ? (c(
              o.ext_color_buffer_half_float,
              "you must enable EXT_color_buffer_half_float to use 16-bit render buffers"
            ), Ye = "rgba16f") : (it === "float" || it === "float32") && (c(
              o.webgl_color_buffer_float,
              "you must enable WEBGL_color_buffer_float in order to use 32-bit floating point renderbuffers"
            ), Ye = "rgba32f"), c.oneOf(it, Q, "invalid color type")), "colorFormat" in Le && (Ye = Le.colorFormat, V.indexOf(Ye) >= 0 ? ot = !0 : q.indexOf(Ye) >= 0 ? ot = !1 : ot ? c.oneOf(
              Le.colorFormat,
              V,
              "invalid color format for texture"
            ) : c.oneOf(
              Le.colorFormat,
              q,
              "invalid color format for renderbuffer"
            ))), ("depthTexture" in Le || "depthStencilTexture" in Le) && (et = !!(Le.depthTexture || Le.depthStencilTexture), c(
              !et || o.webgl_depth_texture,
              "webgl_depth_texture extension not supported"
            )), "depth" in Le && (typeof Le.depth == "boolean" ? at = Le.depth : (ft = Le.depth, ct = !1)), "stencil" in Le && (typeof Le.stencil == "boolean" ? ct = Le.stencil : (lt = Le.stencil, at = !1)), "depthStencil" in Le && (typeof Le.depthStencil == "boolean" ? at = ct = Le.depthStencil : (mt = Le.depthStencil, at = !1, ct = !1));
          }
          var Xe = null, _e = null, Me = null, Pe = null;
          if (Array.isArray(ke))
            Xe = ke.map(te);
          else if (ke)
            Xe = [te(ke)];
          else
            for (Xe = new Array(st), Ae = 0; Ae < st; ++Ae)
              Xe[Ae] = A(
                Ce,
                Ue,
                ot,
                Ye,
                it
              );
          c(
            o.webgl_draw_buffers || Xe.length <= 1,
            "you must enable the WEBGL_draw_buffers extension in order to use multiple color buffers."
          ), c(
            Xe.length <= h.maxColorAttachments,
            "too many color attachments, not supported"
          ), Ce = Ce || Xe[0].width, Ue = Ue || Xe[0].height, ft ? _e = te(ft) : at && !ct && (_e = A(
            Ce,
            Ue,
            et,
            "depth",
            "uint32"
          )), lt ? Me = te(lt) : ct && !at && (Me = A(
            Ce,
            Ue,
            !1,
            "stencil",
            "uint8"
          )), mt ? Pe = te(mt) : !ft && !lt && ct && at && (Pe = A(
            Ce,
            Ue,
            et,
            "depth stencil",
            "depth stencil"
          )), c(
            !!ft + !!lt + !!mt <= 1,
            "invalid framebuffer configuration, can specify exactly one depth/stencil attachment"
          );
          var tt = null;
          for (Ae = 0; Ae < Xe.length; ++Ae)
            if (ae(Xe[Ae], Ce, Ue), c(
              !Xe[Ae] || Xe[Ae].texture && zf.indexOf(Xe[Ae].texture._texture.format) >= 0 || Xe[Ae].renderbuffer && Zf.indexOf(Xe[Ae].renderbuffer._renderbuffer.format) >= 0,
              "framebuffer color attachment " + Ae + " is invalid"
            ), Xe[Ae] && Xe[Ae].texture) {
              var Pt = Xn[Xe[Ae].texture._texture.format] * en[Xe[Ae].texture._texture.type];
              tt === null ? tt = Pt : c(
                tt === Pt,
                "all color attachments much have the same number of bits per pixel."
              );
            }
          return ae(_e, Ce, Ue), c(
            !_e || _e.texture && _e.texture._texture.format === $f || _e.renderbuffer && _e.renderbuffer._renderbuffer.format === Hf,
            "invalid depth attachment for framebuffer object"
          ), ae(Me, Ce, Ue), c(
            !Me || Me.renderbuffer && Me.renderbuffer._renderbuffer.format === qf,
            "invalid stencil attachment for framebuffer object"
          ), ae(Pe, Ce, Ue), c(
            !Pe || Pe.texture && Pe.texture._texture.format === Ci || Pe.renderbuffer && Pe.renderbuffer._renderbuffer.format === Ci,
            "invalid depth-stencil attachment for framebuffer object"
          ), X($), $.width = Ce, $.height = Ue, $.colorAttachments = Xe, $.depthAttachment = _e, $.stencilAttachment = Me, $.depthStencilAttachment = Pe, ge.color = Xe.map(D), ge.depth = D(_e), ge.stencil = D(Me), ge.depthStencil = D(Pe), ge.width = $.width, ge.height = $.height, j($), ge;
        }
        function we(de, Ge) {
          c(
            G.next !== $,
            "can not resize a framebuffer which is currently in use"
          );
          var Ae = Math.max(de | 0, 1), Ce = Math.max(Ge | 0 || Ae, 1);
          if (Ae === $.width && Ce === $.height)
            return ge;
          for (var Ue = $.colorAttachments, at = 0; at < Ue.length; ++at)
            K(Ue[at], Ae, Ce);
          return K($.depthAttachment, Ae, Ce), K($.stencilAttachment, Ae, Ce), K($.depthStencilAttachment, Ae, Ce), $.width = ge.width = Ae, $.height = ge.height = Ce, j($), ge;
        }
        return ge(ie, Z), _(ge, {
          resize: we,
          _reglType: "framebuffer",
          _framebuffer: $,
          destroy: function() {
            re($), X($);
          },
          use: function(de) {
            G.setFBO({
              framebuffer: ge
            }, de);
          }
        });
      }
      function ye(ie) {
        var Z = Array(6);
        function $(we) {
          var de;
          c(
            Z.indexOf(G.next) < 0,
            "can not update framebuffer which is currently in use"
          );
          var Ge = {
            color: null
          }, Ae = 0, Ce = null, Ue = "rgba", at = "uint8", ct = 1;
          if (typeof we == "number")
            Ae = we | 0;
          else if (!we)
            Ae = 1;
          else {
            c.type(we, "object", "invalid arguments for framebuffer");
            var ke = we;
            if ("shape" in ke) {
              var ot = ke.shape;
              c(
                Array.isArray(ot) && ot.length >= 2,
                "invalid shape for framebuffer"
              ), c(
                ot[0] === ot[1],
                "cube framebuffer must be square"
              ), Ae = ot[0];
            } else
              "radius" in ke && (Ae = ke.radius | 0), "width" in ke ? (Ae = ke.width | 0, "height" in ke && c(ke.height === Ae, "must be square")) : "height" in ke && (Ae = ke.height | 0);
            ("color" in ke || "colors" in ke) && (Ce = ke.color || ke.colors, Array.isArray(Ce) && c(
              Ce.length === 1 || o.webgl_draw_buffers,
              "multiple render targets not supported"
            )), Ce || ("colorCount" in ke && (ct = ke.colorCount | 0, c(ct > 0, "invalid color buffer count")), "colorType" in ke && (c.oneOf(
              ke.colorType,
              Q,
              "invalid color type"
            ), at = ke.colorType), "colorFormat" in ke && (Ue = ke.colorFormat, c.oneOf(
              ke.colorFormat,
              V,
              "invalid color format for texture"
            ))), "depth" in ke && (Ge.depth = ke.depth), "stencil" in ke && (Ge.stencil = ke.stencil), "depthStencil" in ke && (Ge.depthStencil = ke.depthStencil);
          }
          var Ye;
          if (Ce)
            if (Array.isArray(Ce))
              for (Ye = [], de = 0; de < Ce.length; ++de)
                Ye[de] = Ce[de];
            else
              Ye = [Ce];
          else {
            Ye = Array(ct);
            var it = {
              radius: Ae,
              format: Ue,
              type: at
            };
            for (de = 0; de < ct; ++de)
              Ye[de] = C.createCube(it);
          }
          for (Ge.color = Array(Ye.length), de = 0; de < Ye.length; ++de) {
            var st = Ye[de];
            c(
              typeof st == "function" && st._reglType === "textureCube",
              "invalid cube map"
            ), Ae = Ae || st.width, c(
              st.width === Ae && st.height === Ae,
              "invalid cube map shape"
            ), Ge.color[de] = {
              target: Jr,
              data: Ye[de]
            };
          }
          for (de = 0; de < 6; ++de) {
            for (var ft = 0; ft < Ye.length; ++ft)
              Ge.color[ft].target = Jr + de;
            de > 0 && (Ge.depth = Z[0].depth, Ge.stencil = Z[0].stencil, Ge.depthStencil = Z[0].depthStencil), Z[de] ? Z[de](Ge) : Z[de] = ne(Ge);
          }
          return _($, {
            width: Ae,
            height: Ae,
            color: Ye
          });
        }
        function ge(we) {
          var de, Ge = we | 0;
          if (c(
            Ge > 0 && Ge <= h.maxCubeMapSize,
            "invalid radius for cube fbo"
          ), Ge === $.width)
            return $;
          var Ae = $.color;
          for (de = 0; de < Ae.length; ++de)
            Ae[de].resize(Ge);
          for (de = 0; de < 6; ++de)
            Z[de].resize(Ge);
          return $.width = $.height = Ge, $;
        }
        return $(ie), _($, {
          faces: Z,
          resize: ge,
          _reglType: "framebufferCube",
          destroy: function() {
            Z.forEach(function(we) {
              we.destroy();
            });
          }
        });
      }
      function Ee() {
        G.cur = null, G.next = null, G.dirty = !0, wt(z).forEach(function(ie) {
          ie.framebuffer = e.createFramebuffer(), j(ie);
        });
      }
      return _(G, {
        getFramebuffer: function(ie) {
          if (typeof ie == "function" && ie._reglType === "framebuffer") {
            var Z = ie._framebuffer;
            if (Z instanceof ue)
              return Z;
          }
          return null;
        },
        create: ne,
        createCube: ye,
        clear: function() {
          wt(z).forEach(re);
        },
        restore: Ee
      });
    }
    var eu = 5126, Fi = 34962;
    function Vn() {
      this.state = 0, this.x = 0, this.y = 0, this.z = 0, this.w = 0, this.buffer = null, this.size = 0, this.normalized = !1, this.type = eu, this.offset = 0, this.stride = 0, this.divisor = 0;
    }
    function tu(e, o, h, C, P) {
      for (var R = h.maxAttributes, G = new Array(R), V = 0; V < R; ++V)
        G[V] = new Vn();
      var q = 0, Q = {}, W = {
        Record: Vn,
        scope: {},
        state: G,
        currentVAO: null,
        targetVAO: null,
        restore: ae() ? z : function() {
        },
        createVAO: ue,
        getVAO: te,
        destroyBuffer: J,
        setVAO: ae() ? A : D,
        clear: ae() ? K : function() {
        }
      };
      function J(X) {
        for (var re = 0; re < G.length; ++re) {
          var j = G[re];
          j.buffer === X && (e.disableVertexAttribArray(re), j.buffer = null);
        }
      }
      function ae() {
        return o.oes_vertex_array_object;
      }
      function H() {
        return o.angle_instanced_arrays;
      }
      function te(X) {
        return typeof X == "function" && X._vao ? X._vao : null;
      }
      function A(X) {
        if (X !== W.currentVAO) {
          var re = ae();
          X ? re.bindVertexArrayOES(X.vao) : re.bindVertexArrayOES(null), W.currentVAO = X;
        }
      }
      function D(X) {
        if (X !== W.currentVAO) {
          if (X)
            X.bindAttrs();
          else
            for (var re = H(), j = 0; j < G.length; ++j) {
              var ne = G[j];
              ne.buffer ? (e.enableVertexAttribArray(j), e.vertexAttribPointer(j, ne.size, ne.type, ne.normalized, ne.stride, ne.offfset), re && ne.divisor && re.vertexAttribDivisorANGLE(j, ne.divisor)) : (e.disableVertexAttribArray(j), e.vertexAttrib4f(j, ne.x, ne.y, ne.z, ne.w));
            }
          W.currentVAO = X;
        }
      }
      function K() {
        wt(Q).forEach(function(X) {
          X.destroy();
        });
      }
      function se() {
        this.id = ++q, this.attributes = [];
        var X = ae();
        X ? this.vao = X.createVertexArrayOES() : this.vao = null, Q[this.id] = this, this.buffers = [];
      }
      se.prototype.bindAttrs = function() {
        for (var X = H(), re = this.attributes, j = 0; j < re.length; ++j) {
          var ne = re[j];
          ne.buffer ? (e.enableVertexAttribArray(j), e.bindBuffer(Fi, ne.buffer.buffer), e.vertexAttribPointer(j, ne.size, ne.type, ne.normalized, ne.stride, ne.offset), X && ne.divisor && X.vertexAttribDivisorANGLE(j, ne.divisor)) : (e.disableVertexAttribArray(j), e.vertexAttrib4f(j, ne.x, ne.y, ne.z, ne.w));
        }
        for (var ye = re.length; ye < R; ++ye)
          e.disableVertexAttribArray(ye);
      }, se.prototype.refresh = function() {
        var X = ae();
        X && (X.bindVertexArrayOES(this.vao), this.bindAttrs(), W.currentVAO = this);
      }, se.prototype.destroy = function() {
        if (this.vao) {
          var X = ae();
          this === W.currentVAO && (W.currentVAO = null, X.bindVertexArrayOES(null)), X.deleteVertexArrayOES(this.vao), this.vao = null;
        }
        Q[this.id] && (delete Q[this.id], C.vaoCount -= 1);
      };
      function z() {
        var X = ae();
        X && wt(Q).forEach(function(re) {
          re.refresh();
        });
      }
      function ue(X) {
        var re = new se();
        C.vaoCount += 1;
        function j(ne) {
          c(Array.isArray(ne), "arguments to vertex array constructor must be an array"), c(ne.length < R, "too many attributes"), c(ne.length > 0, "must specify at least one attribute");
          var ye = {}, Ee = re.attributes;
          Ee.length = ne.length;
          for (var ie = 0; ie < ne.length; ++ie) {
            var Z = ne[ie], $ = Ee[ie] = new Vn(), ge = Z.data || Z;
            if (Array.isArray(ge) || d(ge) || Dt(ge)) {
              var we;
              re.buffers[ie] && (we = re.buffers[ie], d(ge) && we._buffer.byteLength >= ge.byteLength ? we.subdata(ge) : (we.destroy(), re.buffers[ie] = null)), re.buffers[ie] || (we = re.buffers[ie] = P.create(Z, Fi, !1, !0)), $.buffer = P.getBuffer(we), $.size = $.buffer.dimension | 0, $.normalized = !1, $.type = $.buffer.dtype, $.offset = 0, $.stride = 0, $.divisor = 0, $.state = 1, ye[ie] = 1;
            } else
              P.getBuffer(Z) ? ($.buffer = P.getBuffer(Z), $.size = $.buffer.dimension | 0, $.normalized = !1, $.type = $.buffer.dtype, $.offset = 0, $.stride = 0, $.divisor = 0, $.state = 1) : P.getBuffer(Z.buffer) ? ($.buffer = P.getBuffer(Z.buffer), $.size = (+Z.size || $.buffer.dimension) | 0, $.normalized = !!Z.normalized || !1, "type" in Z ? (c.parameter(Z.type, Yt, "invalid buffer type"), $.type = Yt[Z.type]) : $.type = $.buffer.dtype, $.offset = (Z.offset || 0) | 0, $.stride = (Z.stride || 0) | 0, $.divisor = (Z.divisor || 0) | 0, $.state = 1, c($.size >= 1 && $.size <= 4, "size must be between 1 and 4"), c($.offset >= 0, "invalid offset"), c($.stride >= 0 && $.stride <= 255, "stride must be between 0 and 255"), c($.divisor >= 0, "divisor must be positive"), c(!$.divisor || !!o.angle_instanced_arrays, "ANGLE_instanced_arrays must be enabled to use divisor")) : "x" in Z ? (c(ie > 0, "first attribute must not be a constant"), $.x = +Z.x || 0, $.y = +Z.y || 0, $.z = +Z.z || 0, $.w = +Z.w || 0, $.state = 2) : c(!1, "invalid attribute spec for location " + ie);
          }
          for (var de = 0; de < re.buffers.length; ++de)
            !ye[de] && re.buffers[de] && (re.buffers[de].destroy(), re.buffers[de] = null);
          return re.refresh(), j;
        }
        return j.destroy = function() {
          for (var ne = 0; ne < re.buffers.length; ++ne)
            re.buffers[ne] && re.buffers[ne].destroy();
          re.buffers.length = 0, re.destroy();
        }, j._vao = re, j._reglType = "vao", j(X);
      }
      return W;
    }
    var Gi = 35632, ru = 35633, nu = 35718, au = 35721;
    function iu(e, o, h, C) {
      var P = {}, R = {};
      function G(A, D, K, se) {
        this.name = A, this.id = D, this.location = K, this.info = se;
      }
      function V(A, D) {
        for (var K = 0; K < A.length; ++K)
          if (A[K].id === D.id) {
            A[K].location = D.location;
            return;
          }
        A.push(D);
      }
      function q(A, D, K) {
        var se = A === Gi ? P : R, z = se[D];
        if (!z) {
          var ue = o.str(D);
          z = e.createShader(A), e.shaderSource(z, ue), e.compileShader(z), c.shaderError(e, z, ue, A, K), se[D] = z;
        }
        return z;
      }
      var Q = {}, W = [], J = 0;
      function ae(A, D) {
        this.id = J++, this.fragId = A, this.vertId = D, this.program = null, this.uniforms = [], this.attributes = [], this.refCount = 1, C.profile && (this.stats = {
          uniformsCount: 0,
          attributesCount: 0
        });
      }
      function H(A, D, K) {
        var se, z, ue = q(Gi, A.fragId), X = q(ru, A.vertId), re = A.program = e.createProgram();
        if (e.attachShader(re, ue), e.attachShader(re, X), K)
          for (se = 0; se < K.length; ++se) {
            var j = K[se];
            e.bindAttribLocation(re, j[0], j[1]);
          }
        e.linkProgram(re), c.linkError(
          e,
          re,
          o.str(A.fragId),
          o.str(A.vertId),
          D
        );
        var ne = e.getProgramParameter(re, nu);
        C.profile && (A.stats.uniformsCount = ne);
        var ye = A.uniforms;
        for (se = 0; se < ne; ++se)
          if (z = e.getActiveUniform(re, se), z)
            if (z.size > 1)
              for (var Ee = 0; Ee < z.size; ++Ee) {
                var ie = z.name.replace("[0]", "[" + Ee + "]");
                V(ye, new G(
                  ie,
                  o.id(ie),
                  e.getUniformLocation(re, ie),
                  z
                ));
              }
            else
              V(ye, new G(
                z.name,
                o.id(z.name),
                e.getUniformLocation(re, z.name),
                z
              ));
        var Z = e.getProgramParameter(re, au);
        C.profile && (A.stats.attributesCount = Z);
        var $ = A.attributes;
        for (se = 0; se < Z; ++se)
          z = e.getActiveAttrib(re, se), z && V($, new G(
            z.name,
            o.id(z.name),
            e.getAttribLocation(re, z.name),
            z
          ));
      }
      C.profile && (h.getMaxUniformsCount = function() {
        var A = 0;
        return W.forEach(function(D) {
          D.stats.uniformsCount > A && (A = D.stats.uniformsCount);
        }), A;
      }, h.getMaxAttributesCount = function() {
        var A = 0;
        return W.forEach(function(D) {
          D.stats.attributesCount > A && (A = D.stats.attributesCount);
        }), A;
      });
      function te() {
        P = {}, R = {};
        for (var A = 0; A < W.length; ++A)
          H(W[A], null, W[A].attributes.map(function(D) {
            return [D.location, D.name];
          }));
      }
      return {
        clear: function() {
          var A = e.deleteShader.bind(e);
          wt(P).forEach(A), P = {}, wt(R).forEach(A), R = {}, W.forEach(function(D) {
            e.deleteProgram(D.program);
          }), W.length = 0, Q = {}, h.shaderCount = 0;
        },
        program: function(A, D, K, se) {
          c.command(A >= 0, "missing vertex shader", K), c.command(D >= 0, "missing fragment shader", K);
          var z = Q[D];
          z || (z = Q[D] = {});
          var ue = z[A];
          if (ue && (ue.refCount++, !se))
            return ue;
          var X = new ae(D, A);
          return h.shaderCount++, H(X, K, se), ue || (z[A] = X), W.push(X), _(X, {
            destroy: function() {
              if (X.refCount--, X.refCount <= 0) {
                e.deleteProgram(X.program);
                var re = W.indexOf(X);
                W.splice(re, 1), h.shaderCount--;
              }
              z[X.vertId].refCount <= 0 && (e.deleteShader(R[X.vertId]), delete R[X.vertId], delete Q[X.fragId][X.vertId]), Object.keys(Q[X.fragId]).length || (e.deleteShader(P[X.fragId]), delete P[X.fragId], delete Q[X.fragId]);
            }
          });
        },
        restore: te,
        shader: q,
        frag: -1,
        vert: -1
      };
    }
    var ou = 6408, Rr = 5121, su = 3333, tn = 5126;
    function fu(e, o, h, C, P, R, G) {
      function V(W) {
        var J;
        o.next === null ? (c(
          P.preserveDrawingBuffer,
          'you must create a webgl context with "preserveDrawingBuffer":true in order to read pixels from the drawing buffer'
        ), J = Rr) : (c(
          o.next.colorAttachments[0].texture !== null,
          "You cannot read from a renderbuffer"
        ), J = o.next.colorAttachments[0].texture._texture.type, R.oes_texture_float ? (c(
          J === Rr || J === tn,
          "Reading from a framebuffer is only allowed for the types 'uint8' and 'float'"
        ), J === tn && c(G.readFloat, "Reading 'float' values is not permitted in your browser. For a fallback, please see: https://www.npmjs.com/package/glsl-read-float")) : c(
          J === Rr,
          "Reading from a framebuffer is only allowed for the type 'uint8'"
        ));
        var ae = 0, H = 0, te = C.framebufferWidth, A = C.framebufferHeight, D = null;
        d(W) ? D = W : W && (c.type(W, "object", "invalid arguments to regl.read()"), ae = W.x | 0, H = W.y | 0, c(
          ae >= 0 && ae < C.framebufferWidth,
          "invalid x offset for regl.read"
        ), c(
          H >= 0 && H < C.framebufferHeight,
          "invalid y offset for regl.read"
        ), te = (W.width || C.framebufferWidth - ae) | 0, A = (W.height || C.framebufferHeight - H) | 0, D = W.data || null), D && (J === Rr ? c(
          D instanceof Uint8Array,
          "buffer must be 'Uint8Array' when reading from a framebuffer of type 'uint8'"
        ) : J === tn && c(
          D instanceof Float32Array,
          "buffer must be 'Float32Array' when reading from a framebuffer of type 'float'"
        )), c(
          te > 0 && te + ae <= C.framebufferWidth,
          "invalid width for read pixels"
        ), c(
          A > 0 && A + H <= C.framebufferHeight,
          "invalid height for read pixels"
        ), h();
        var K = te * A * 4;
        return D || (J === Rr ? D = new Uint8Array(K) : J === tn && (D = D || new Float32Array(K))), c.isTypedArray(D, "data buffer for regl.read() must be a typedarray"), c(D.byteLength >= K, "data buffer for regl.read() too small"), e.pixelStorei(su, 4), e.readPixels(
          ae,
          H,
          te,
          A,
          ou,
          J,
          D
        ), D;
      }
      function q(W) {
        var J;
        return o.setFBO({
          framebuffer: W.framebuffer
        }, function() {
          J = V(W);
        }), J;
      }
      function Q(W) {
        return !W || !("framebuffer" in W) ? V(W) : q(W);
      }
      return Q;
    }
    function mr(e) {
      return Array.prototype.slice.call(e);
    }
    function pr(e) {
      return mr(e).join("");
    }
    function uu() {
      var e = 0, o = [], h = [];
      function C(J) {
        for (var ae = 0; ae < h.length; ++ae)
          if (h[ae] === J)
            return o[ae];
        var H = "g" + e++;
        return o.push(H), h.push(J), H;
      }
      function P() {
        var J = [];
        function ae() {
          J.push.apply(J, mr(arguments));
        }
        var H = [];
        function te() {
          var A = "v" + e++;
          return H.push(A), arguments.length > 0 && (J.push(A, "="), J.push.apply(J, mr(arguments)), J.push(";")), A;
        }
        return _(ae, {
          def: te,
          toString: function() {
            return pr([
              H.length > 0 ? "var " + H.join(",") + ";" : "",
              pr(J)
            ]);
          }
        });
      }
      function R() {
        var J = P(), ae = P(), H = J.toString, te = ae.toString;
        function A(D, K) {
          ae(D, K, "=", J.def(D, K), ";");
        }
        return _(function() {
          J.apply(J, mr(arguments));
        }, {
          def: J.def,
          entry: J,
          exit: ae,
          save: A,
          set: function(D, K, se) {
            A(D, K), J(D, K, "=", se, ";");
          },
          toString: function() {
            return H() + te();
          }
        });
      }
      function G() {
        var J = pr(arguments), ae = R(), H = R(), te = ae.toString, A = H.toString;
        return _(ae, {
          then: function() {
            return ae.apply(ae, mr(arguments)), this;
          },
          else: function() {
            return H.apply(H, mr(arguments)), this;
          },
          toString: function() {
            var D = A();
            return D && (D = "else{" + D + "}"), pr([
              "if(",
              J,
              "){",
              te(),
              "}",
              D
            ]);
          }
        });
      }
      var V = P(), q = {};
      function Q(J, ae) {
        var H = [];
        function te() {
          var z = "a" + H.length;
          return H.push(z), z;
        }
        ae = ae || 0;
        for (var A = 0; A < ae; ++A)
          te();
        var D = R(), K = D.toString, se = q[J] = _(D, {
          arg: te,
          toString: function() {
            return pr([
              "function(",
              H.join(),
              "){",
              K(),
              "}"
            ]);
          }
        });
        return se;
      }
      function W() {
        var J = [
          '"use strict";',
          V,
          "return {"
        ];
        Object.keys(q).forEach(function(te) {
          J.push('"', te, '":', q[te].toString(), ",");
        }), J.push("}");
        var ae = pr(J).replace(/;/g, `;
`).replace(/}/g, `}
`).replace(/{/g, `{
`), H = Function.apply(null, o.concat(ae));
        return H.apply(null, h);
      }
      return {
        global: V,
        link: C,
        block: P,
        proc: Q,
        scope: R,
        cond: G,
        compile: W
      };
    }
    var vr = "xyzw".split(""), Di = 5121, yr = 1, Hn = 2, qn = 0, Wn = 1, Yn = 2, Kn = 3, rn = 4, Mi = 5, Ni = 6, ki = "dither", Bi = "blend.enable", Ii = "blend.color", Qn = "blend.equation", Zn = "blend.func", Pi = "depth.enable", Ui = "depth.func", $i = "depth.range", zi = "depth.mask", Jn = "colorMask", ji = "cull.enable", Xi = "cull.face", ea = "frontFace", ta = "lineWidth", Vi = "polygonOffset.enable", ra = "polygonOffset.offset", Hi = "sample.alpha", qi = "sample.enable", na = "sample.coverage", Wi = "stencil.enable", Yi = "stencil.mask", aa = "stencil.func", ia = "stencil.opFront", Or = "stencil.opBack", Ki = "scissor.enable", nn = "scissor.box", $t = "viewport", Cr = "profile", er = "framebuffer", Fr = "vert", Gr = "frag", tr = "elements", rr = "primitive", nr = "count", an = "offset", on = "instances", Dr = "vao", oa = "Width", sa = "Height", _r = er + oa, br = er + sa, cu = $t + oa, lu = $t + sa, Qi = "drawingBuffer", Zi = Qi + oa, Ji = Qi + sa, du = [
      Zn,
      Qn,
      aa,
      ia,
      Or,
      na,
      $t,
      nn,
      ra
    ], gr = 34962, hu = 34963, mu = 35632, pu = 35633, eo = 3553, vu = 34067, yu = 2884, _u = 3042, bu = 3024, gu = 2960, xu = 2929, Eu = 3089, Au = 32823, Tu = 32926, Su = 32928, fa = 5126, sn = 35664, fn = 35665, un = 35666, ua = 5124, cn = 35667, ln = 35668, dn = 35669, ca = 35670, hn = 35671, mn = 35672, pn = 35673, Mr = 35674, Nr = 35675, kr = 35676, Br = 35678, Ir = 35680, to = 4, Pr = 1028, ar = 1029, ro = 2304, la = 2305, wu = 32775, Lu = 32776, Ru = 519, Xt = 7680, no = 0, ao = 1, io = 32774, Ou = 513, oo = 36160, Cu = 36064, It = {
      0: 0,
      1: 1,
      zero: 0,
      one: 1,
      "src color": 768,
      "one minus src color": 769,
      "src alpha": 770,
      "one minus src alpha": 771,
      "dst color": 774,
      "one minus dst color": 775,
      "dst alpha": 772,
      "one minus dst alpha": 773,
      "constant color": 32769,
      "one minus constant color": 32770,
      "constant alpha": 32771,
      "one minus constant alpha": 32772,
      "src alpha saturate": 776
    }, so = [
      "constant color, constant alpha",
      "one minus constant color, constant alpha",
      "constant color, one minus constant alpha",
      "one minus constant color, one minus constant alpha",
      "constant alpha, constant color",
      "constant alpha, one minus constant color",
      "one minus constant alpha, constant color",
      "one minus constant alpha, one minus constant color"
    ], xr = {
      never: 512,
      less: 513,
      "<": 513,
      equal: 514,
      "=": 514,
      "==": 514,
      "===": 514,
      lequal: 515,
      "<=": 515,
      greater: 516,
      ">": 516,
      notequal: 517,
      "!=": 517,
      "!==": 517,
      gequal: 518,
      ">=": 518,
      always: 519
    }, Vt = {
      0: 0,
      zero: 0,
      keep: 7680,
      replace: 7681,
      increment: 7682,
      decrement: 7683,
      "increment wrap": 34055,
      "decrement wrap": 34056,
      invert: 5386
    }, fo = {
      frag: mu,
      vert: pu
    }, da = {
      cw: ro,
      ccw: la
    };
    function vn(e) {
      return Array.isArray(e) || d(e) || Dt(e);
    }
    function uo(e) {
      return e.sort(function(o, h) {
        return o === $t ? -1 : h === $t ? 1 : o < h ? -1 : 1;
      });
    }
    function bt(e, o, h, C) {
      this.thisDep = e, this.contextDep = o, this.propDep = h, this.append = C;
    }
    function Ht(e) {
      return e && !(e.thisDep || e.contextDep || e.propDep);
    }
    function nt(e) {
      return new bt(!1, !1, !1, e);
    }
    function At(e, o) {
      var h = e.type;
      if (h === qn) {
        var C = e.data.length;
        return new bt(
          !0,
          C >= 1,
          C >= 2,
          o
        );
      } else if (h === rn) {
        var P = e.data;
        return new bt(
          P.thisDep,
          P.contextDep,
          P.propDep,
          o
        );
      } else {
        if (h === Mi)
          return new bt(
            !1,
            !1,
            !1,
            o
          );
        if (h === Ni) {
          for (var R = !1, G = !1, V = !1, q = 0; q < e.data.length; ++q) {
            var Q = e.data[q];
            if (Q.type === Wn)
              V = !0;
            else if (Q.type === Yn)
              G = !0;
            else if (Q.type === Kn)
              R = !0;
            else if (Q.type === qn) {
              R = !0;
              var W = Q.data;
              W >= 1 && (G = !0), W >= 2 && (V = !0);
            } else
              Q.type === rn && (R = R || Q.data.thisDep, G = G || Q.data.contextDep, V = V || Q.data.propDep);
          }
          return new bt(
            R,
            G,
            V,
            o
          );
        } else
          return new bt(
            h === Kn,
            h === Yn,
            h === Wn,
            o
          );
      }
    }
    var co = new bt(!1, !1, !1, function() {
    });
    function Fu(e, o, h, C, P, R, G, V, q, Q, W, J, ae, H, te) {
      var A = Q.Record, D = {
        add: 32774,
        subtract: 32778,
        "reverse subtract": 32779
      };
      h.ext_blend_minmax && (D.min = wu, D.max = Lu);
      var K = h.angle_instanced_arrays, se = h.webgl_draw_buffers, z = {
        dirty: !0,
        profile: te.profile
      }, ue = {}, X = [], re = {}, j = {};
      function ne(f) {
        return f.replace(".", "_");
      }
      function ye(f, t, p) {
        var E = ne(f);
        X.push(f), ue[E] = z[E] = !!p, re[E] = t;
      }
      function Ee(f, t, p) {
        var E = ne(f);
        X.push(f), Array.isArray(p) ? (z[E] = p.slice(), ue[E] = p.slice()) : z[E] = ue[E] = p, j[E] = t;
      }
      ye(ki, bu), ye(Bi, _u), Ee(Ii, "blendColor", [0, 0, 0, 0]), Ee(
        Qn,
        "blendEquationSeparate",
        [io, io]
      ), Ee(
        Zn,
        "blendFuncSeparate",
        [ao, no, ao, no]
      ), ye(Pi, xu, !0), Ee(Ui, "depthFunc", Ou), Ee($i, "depthRange", [0, 1]), Ee(zi, "depthMask", !0), Ee(Jn, Jn, [!0, !0, !0, !0]), ye(ji, yu), Ee(Xi, "cullFace", ar), Ee(ea, ea, la), Ee(ta, ta, 1), ye(Vi, Au), Ee(ra, "polygonOffset", [0, 0]), ye(Hi, Tu), ye(qi, Su), Ee(na, "sampleCoverage", [1, !1]), ye(Wi, gu), Ee(Yi, "stencilMask", -1), Ee(aa, "stencilFunc", [Ru, 0, -1]), Ee(
        ia,
        "stencilOpSeparate",
        [Pr, Xt, Xt, Xt]
      ), Ee(
        Or,
        "stencilOpSeparate",
        [ar, Xt, Xt, Xt]
      ), ye(Ki, Eu), Ee(
        nn,
        "scissor",
        [0, 0, e.drawingBufferWidth, e.drawingBufferHeight]
      ), Ee(
        $t,
        $t,
        [0, 0, e.drawingBufferWidth, e.drawingBufferHeight]
      );
      var ie = {
        gl: e,
        context: ae,
        strings: o,
        next: ue,
        current: z,
        draw: J,
        elements: R,
        buffer: P,
        shader: W,
        attributes: Q.state,
        vao: Q,
        uniforms: q,
        framebuffer: V,
        extensions: h,
        timer: H,
        isBufferArgs: vn
      }, Z = {
        primTypes: or,
        compareFuncs: xr,
        blendFuncs: It,
        blendEquations: D,
        stencilOps: Vt,
        glTypes: Yt,
        orientationType: da
      };
      c.optional(function() {
        ie.isArrayLike = Je;
      }), se && (Z.backBuffer = [ar], Z.drawBuffer = Et(C.maxDrawbuffers, function(f) {
        return f === 0 ? [0] : Et(f, function(t) {
          return Cu + t;
        });
      }));
      var $ = 0;
      function ge() {
        var f = uu(), t = f.link, p = f.global;
        f.id = $++, f.batchId = "0";
        var E = t(ie), S = f.shared = {
          props: "a0"
        };
        Object.keys(ie).forEach(function(m) {
          S[m] = p.def(E, ".", m);
        }), c.optional(function() {
          f.CHECK = t(c), f.commandStr = c.guessCommand(), f.command = t(f.commandStr), f.assert = function(m, s, g) {
            m(
              "if(!(",
              s,
              "))",
              this.CHECK,
              ".commandRaise(",
              t(g),
              ",",
              this.command,
              ");"
            );
          }, Z.invalidBlendCombinations = so;
        });
        var y = f.next = {}, v = f.current = {};
        Object.keys(j).forEach(function(m) {
          Array.isArray(z[m]) && (y[m] = p.def(S.next, ".", m), v[m] = p.def(S.current, ".", m));
        });
        var b = f.constants = {};
        Object.keys(Z).forEach(function(m) {
          b[m] = p.def(JSON.stringify(Z[m]));
        }), f.invoke = function(m, s) {
          switch (s.type) {
            case qn:
              var g = [
                "this",
                S.context,
                S.props,
                f.batchId
              ];
              return m.def(
                t(s.data),
                ".call(",
                g.slice(0, Math.max(s.data.length + 1, 4)),
                ")"
              );
            case Wn:
              return m.def(S.props, s.data);
            case Yn:
              return m.def(S.context, s.data);
            case Kn:
              return m.def("this", s.data);
            case rn:
              return s.data.append(f, m), s.data.ref;
            case Mi:
              return s.data.toString();
            case Ni:
              return s.data.map(function(w) {
                return f.invoke(m, w);
              });
          }
        }, f.attribCache = {};
        var u = {};
        return f.scopeAttrib = function(m) {
          var s = o.id(m);
          if (s in u)
            return u[s];
          var g = Q.scope[s];
          g || (g = Q.scope[s] = new A());
          var w = u[s] = t(g);
          return w;
        }, f;
      }
      function we(f) {
        var t = f.static, p = f.dynamic, E;
        if (Cr in t) {
          var S = !!t[Cr];
          E = nt(function(v, b) {
            return S;
          }), E.enable = S;
        } else if (Cr in p) {
          var y = p[Cr];
          E = At(y, function(v, b) {
            return v.invoke(b, y);
          });
        }
        return E;
      }
      function de(f, t) {
        var p = f.static, E = f.dynamic;
        if (er in p) {
          var S = p[er];
          return S ? (S = V.getFramebuffer(S), c.command(S, "invalid framebuffer object"), nt(function(v, b) {
            var u = v.link(S), m = v.shared;
            b.set(
              m.framebuffer,
              ".next",
              u
            );
            var s = m.context;
            return b.set(
              s,
              "." + _r,
              u + ".width"
            ), b.set(
              s,
              "." + br,
              u + ".height"
            ), u;
          })) : nt(function(v, b) {
            var u = v.shared;
            b.set(
              u.framebuffer,
              ".next",
              "null"
            );
            var m = u.context;
            return b.set(
              m,
              "." + _r,
              m + "." + Zi
            ), b.set(
              m,
              "." + br,
              m + "." + Ji
            ), "null";
          });
        } else if (er in E) {
          var y = E[er];
          return At(y, function(v, b) {
            var u = v.invoke(b, y), m = v.shared, s = m.framebuffer, g = b.def(
              s,
              ".getFramebuffer(",
              u,
              ")"
            );
            c.optional(function() {
              v.assert(
                b,
                "!" + u + "||" + g,
                "invalid framebuffer object"
              );
            }), b.set(
              s,
              ".next",
              g
            );
            var w = m.context;
            return b.set(
              w,
              "." + _r,
              g + "?" + g + ".width:" + w + "." + Zi
            ), b.set(
              w,
              "." + br,
              g + "?" + g + ".height:" + w + "." + Ji
            ), g;
          });
        } else
          return null;
      }
      function Ge(f, t, p) {
        var E = f.static, S = f.dynamic;
        function y(u) {
          if (u in E) {
            var m = E[u];
            c.commandType(m, "object", "invalid " + u, p.commandStr);
            var s = !0, g = m.x | 0, w = m.y | 0, B, U;
            return "width" in m ? (B = m.width | 0, c.command(B >= 0, "invalid " + u, p.commandStr)) : s = !1, "height" in m ? (U = m.height | 0, c.command(U >= 0, "invalid " + u, p.commandStr)) : s = !1, new bt(
              !s && t && t.thisDep,
              !s && t && t.contextDep,
              !s && t && t.propDep,
              function(me, Re) {
                var he = me.shared.context, be = B;
                "width" in m || (be = Re.def(he, ".", _r, "-", g));
                var Te = U;
                return "height" in m || (Te = Re.def(he, ".", br, "-", w)), [g, w, be, Te];
              }
            );
          } else if (u in S) {
            var k = S[u], Y = At(k, function(me, Re) {
              var he = me.invoke(Re, k);
              c.optional(function() {
                me.assert(
                  Re,
                  he + "&&typeof " + he + '==="object"',
                  "invalid " + u
                );
              });
              var be = me.shared.context, Te = Re.def(he, ".x|0"), $e = Re.def(he, ".y|0"), Ke = Re.def(
                '"width" in ',
                he,
                "?",
                he,
                ".width|0:",
                "(",
                be,
                ".",
                _r,
                "-",
                Te,
                ")"
              ), gt = Re.def(
                '"height" in ',
                he,
                "?",
                he,
                ".height|0:",
                "(",
                be,
                ".",
                br,
                "-",
                $e,
                ")"
              );
              return c.optional(function() {
                me.assert(
                  Re,
                  Ke + ">=0&&" + gt + ">=0",
                  "invalid " + u
                );
              }), [Te, $e, Ke, gt];
            });
            return t && (Y.thisDep = Y.thisDep || t.thisDep, Y.contextDep = Y.contextDep || t.contextDep, Y.propDep = Y.propDep || t.propDep), Y;
          } else
            return t ? new bt(
              t.thisDep,
              t.contextDep,
              t.propDep,
              function(me, Re) {
                var he = me.shared.context;
                return [
                  0,
                  0,
                  Re.def(he, ".", _r),
                  Re.def(he, ".", br)
                ];
              }
            ) : null;
        }
        var v = y($t);
        if (v) {
          var b = v;
          v = new bt(
            v.thisDep,
            v.contextDep,
            v.propDep,
            function(u, m) {
              var s = b.append(u, m), g = u.shared.context;
              return m.set(
                g,
                "." + cu,
                s[2]
              ), m.set(
                g,
                "." + lu,
                s[3]
              ), s;
            }
          );
        }
        return {
          viewport: v,
          scissor_box: y(nn)
        };
      }
      function Ae(f, t) {
        var p = f.static, E = typeof p[Gr] == "string" && typeof p[Fr] == "string";
        if (E) {
          if (Object.keys(t.dynamic).length > 0)
            return null;
          var S = t.static, y = Object.keys(S);
          if (y.length > 0 && typeof S[y[0]] == "number") {
            for (var v = [], b = 0; b < y.length; ++b)
              c(typeof S[y[b]] == "number", "must specify all vertex attribute locations when using vaos"), v.push([S[y[b]] | 0, y[b]]);
            return v;
          }
        }
        return null;
      }
      function Ce(f, t, p) {
        var E = f.static, S = f.dynamic;
        function y(s) {
          if (s in E) {
            var g = o.id(E[s]);
            c.optional(function() {
              W.shader(fo[s], g, c.guessCommand());
            });
            var w = nt(function() {
              return g;
            });
            return w.id = g, w;
          } else if (s in S) {
            var B = S[s];
            return At(B, function(U, k) {
              var Y = U.invoke(k, B), me = k.def(U.shared.strings, ".id(", Y, ")");
              return c.optional(function() {
                k(
                  U.shared.shader,
                  ".shader(",
                  fo[s],
                  ",",
                  me,
                  ",",
                  U.command,
                  ");"
                );
              }), me;
            });
          }
          return null;
        }
        var v = y(Gr), b = y(Fr), u = null, m;
        return Ht(v) && Ht(b) ? (u = W.program(b.id, v.id, null, p), m = nt(function(s, g) {
          return s.link(u);
        })) : m = new bt(
          v && v.thisDep || b && b.thisDep,
          v && v.contextDep || b && b.contextDep,
          v && v.propDep || b && b.propDep,
          function(s, g) {
            var w = s.shared.shader, B;
            v ? B = v.append(s, g) : B = g.def(w, ".", Gr);
            var U;
            b ? U = b.append(s, g) : U = g.def(w, ".", Fr);
            var k = w + ".program(" + U + "," + B;
            return c.optional(function() {
              k += "," + s.command;
            }), g.def(k + ")");
          }
        ), {
          frag: v,
          vert: b,
          progVar: m,
          program: u
        };
      }
      function Ue(f, t) {
        var p = f.static, E = f.dynamic;
        function S() {
          if (tr in p) {
            var s = p[tr];
            vn(s) ? s = R.getElements(R.create(s, !0)) : s && (s = R.getElements(s), c.command(s, "invalid elements", t.commandStr));
            var g = nt(function(B, U) {
              if (s) {
                var k = B.link(s);
                return B.ELEMENTS = k, k;
              }
              return B.ELEMENTS = null, null;
            });
            return g.value = s, g;
          } else if (tr in E) {
            var w = E[tr];
            return At(w, function(B, U) {
              var k = B.shared, Y = k.isBufferArgs, me = k.elements, Re = B.invoke(U, w), he = U.def("null"), be = U.def(Y, "(", Re, ")"), Te = B.cond(be).then(he, "=", me, ".createStream(", Re, ");").else(he, "=", me, ".getElements(", Re, ");");
              return c.optional(function() {
                B.assert(
                  Te.else,
                  "!" + Re + "||" + he,
                  "invalid elements"
                );
              }), U.entry(Te), U.exit(
                B.cond(be).then(me, ".destroyStream(", he, ");")
              ), B.ELEMENTS = he, he;
            });
          }
          return null;
        }
        var y = S();
        function v() {
          if (rr in p) {
            var s = p[rr];
            return c.commandParameter(s, or, "invalid primitve", t.commandStr), nt(function(w, B) {
              return or[s];
            });
          } else if (rr in E) {
            var g = E[rr];
            return At(g, function(w, B) {
              var U = w.constants.primTypes, k = w.invoke(B, g);
              return c.optional(function() {
                w.assert(
                  B,
                  k + " in " + U,
                  "invalid primitive, must be one of " + Object.keys(or)
                );
              }), B.def(U, "[", k, "]");
            });
          } else if (y)
            return Ht(y) ? y.value ? nt(function(w, B) {
              return B.def(w.ELEMENTS, ".primType");
            }) : nt(function() {
              return to;
            }) : new bt(
              y.thisDep,
              y.contextDep,
              y.propDep,
              function(w, B) {
                var U = w.ELEMENTS;
                return B.def(U, "?", U, ".primType:", to);
              }
            );
          return null;
        }
        function b(s, g) {
          if (s in p) {
            var w = p[s] | 0;
            return c.command(!g || w >= 0, "invalid " + s, t.commandStr), nt(function(U, k) {
              return g && (U.OFFSET = w), w;
            });
          } else if (s in E) {
            var B = E[s];
            return At(B, function(U, k) {
              var Y = U.invoke(k, B);
              return g && (U.OFFSET = Y, c.optional(function() {
                U.assert(
                  k,
                  Y + ">=0",
                  "invalid " + s
                );
              })), Y;
            });
          } else if (g && y)
            return nt(function(U, k) {
              return U.OFFSET = "0", 0;
            });
          return null;
        }
        var u = b(an, !0);
        function m() {
          if (nr in p) {
            var s = p[nr] | 0;
            return c.command(
              typeof s == "number" && s >= 0,
              "invalid vertex count",
              t.commandStr
            ), nt(function() {
              return s;
            });
          } else if (nr in E) {
            var g = E[nr];
            return At(g, function(U, k) {
              var Y = U.invoke(k, g);
              return c.optional(function() {
                U.assert(
                  k,
                  "typeof " + Y + '==="number"&&' + Y + ">=0&&" + Y + "===(" + Y + "|0)",
                  "invalid vertex count"
                );
              }), Y;
            });
          } else if (y)
            if (Ht(y)) {
              if (y)
                return u ? new bt(
                  u.thisDep,
                  u.contextDep,
                  u.propDep,
                  function(U, k) {
                    var Y = k.def(
                      U.ELEMENTS,
                      ".vertCount-",
                      U.OFFSET
                    );
                    return c.optional(function() {
                      U.assert(
                        k,
                        Y + ">=0",
                        "invalid vertex offset/element buffer too small"
                      );
                    }), Y;
                  }
                ) : nt(function(U, k) {
                  return k.def(U.ELEMENTS, ".vertCount");
                });
              var w = nt(function() {
                return -1;
              });
              return c.optional(function() {
                w.MISSING = !0;
              }), w;
            } else {
              var B = new bt(
                y.thisDep || u.thisDep,
                y.contextDep || u.contextDep,
                y.propDep || u.propDep,
                function(U, k) {
                  var Y = U.ELEMENTS;
                  return U.OFFSET ? k.def(
                    Y,
                    "?",
                    Y,
                    ".vertCount-",
                    U.OFFSET,
                    ":-1"
                  ) : k.def(Y, "?", Y, ".vertCount:-1");
                }
              );
              return c.optional(function() {
                B.DYNAMIC = !0;
              }), B;
            }
          return null;
        }
        return {
          elements: y,
          primitive: v(),
          count: m(),
          instances: b(on, !1),
          offset: u
        };
      }
      function at(f, t) {
        var p = f.static, E = f.dynamic, S = {};
        return X.forEach(function(y) {
          var v = ne(y);
          function b(u, m) {
            if (y in p) {
              var s = u(p[y]);
              S[v] = nt(function() {
                return s;
              });
            } else if (y in E) {
              var g = E[y];
              S[v] = At(g, function(w, B) {
                return m(w, B, w.invoke(B, g));
              });
            }
          }
          switch (y) {
            case ji:
            case Bi:
            case ki:
            case Wi:
            case Pi:
            case Ki:
            case Vi:
            case Hi:
            case qi:
            case zi:
              return b(
                function(u) {
                  return c.commandType(u, "boolean", y, t.commandStr), u;
                },
                function(u, m, s) {
                  return c.optional(function() {
                    u.assert(
                      m,
                      "typeof " + s + '==="boolean"',
                      "invalid flag " + y,
                      u.commandStr
                    );
                  }), s;
                }
              );
            case Ui:
              return b(
                function(u) {
                  return c.commandParameter(u, xr, "invalid " + y, t.commandStr), xr[u];
                },
                function(u, m, s) {
                  var g = u.constants.compareFuncs;
                  return c.optional(function() {
                    u.assert(
                      m,
                      s + " in " + g,
                      "invalid " + y + ", must be one of " + Object.keys(xr)
                    );
                  }), m.def(g, "[", s, "]");
                }
              );
            case $i:
              return b(
                function(u) {
                  return c.command(
                    Je(u) && u.length === 2 && typeof u[0] == "number" && typeof u[1] == "number" && u[0] <= u[1],
                    "depth range is 2d array",
                    t.commandStr
                  ), u;
                },
                function(u, m, s) {
                  c.optional(function() {
                    u.assert(
                      m,
                      u.shared.isArrayLike + "(" + s + ")&&" + s + ".length===2&&typeof " + s + '[0]==="number"&&typeof ' + s + '[1]==="number"&&' + s + "[0]<=" + s + "[1]",
                      "depth range must be a 2d array"
                    );
                  });
                  var g = m.def("+", s, "[0]"), w = m.def("+", s, "[1]");
                  return [g, w];
                }
              );
            case Zn:
              return b(
                function(u) {
                  c.commandType(u, "object", "blend.func", t.commandStr);
                  var m = "srcRGB" in u ? u.srcRGB : u.src, s = "srcAlpha" in u ? u.srcAlpha : u.src, g = "dstRGB" in u ? u.dstRGB : u.dst, w = "dstAlpha" in u ? u.dstAlpha : u.dst;
                  return c.commandParameter(m, It, v + ".srcRGB", t.commandStr), c.commandParameter(s, It, v + ".srcAlpha", t.commandStr), c.commandParameter(g, It, v + ".dstRGB", t.commandStr), c.commandParameter(w, It, v + ".dstAlpha", t.commandStr), c.command(
                    so.indexOf(m + ", " + g) === -1,
                    "unallowed blending combination (srcRGB, dstRGB) = (" + m + ", " + g + ")",
                    t.commandStr
                  ), [
                    It[m],
                    It[g],
                    It[s],
                    It[w]
                  ];
                },
                function(u, m, s) {
                  var g = u.constants.blendFuncs;
                  c.optional(function() {
                    u.assert(
                      m,
                      s + "&&typeof " + s + '==="object"',
                      "invalid blend func, must be an object"
                    );
                  });
                  function w(he, be) {
                    var Te = m.def(
                      '"',
                      he,
                      be,
                      '" in ',
                      s,
                      "?",
                      s,
                      ".",
                      he,
                      be,
                      ":",
                      s,
                      ".",
                      he
                    );
                    return c.optional(function() {
                      u.assert(
                        m,
                        Te + " in " + g,
                        "invalid " + y + "." + he + be + ", must be one of " + Object.keys(It)
                      );
                    }), Te;
                  }
                  var B = w("src", "RGB"), U = w("dst", "RGB");
                  c.optional(function() {
                    var he = u.constants.invalidBlendCombinations;
                    u.assert(
                      m,
                      he + ".indexOf(" + B + '+", "+' + U + ") === -1 ",
                      "unallowed blending combination for (srcRGB, dstRGB)"
                    );
                  });
                  var k = m.def(g, "[", B, "]"), Y = m.def(g, "[", w("src", "Alpha"), "]"), me = m.def(g, "[", U, "]"), Re = m.def(g, "[", w("dst", "Alpha"), "]");
                  return [k, me, Y, Re];
                }
              );
            case Qn:
              return b(
                function(u) {
                  if (typeof u == "string")
                    return c.commandParameter(u, D, "invalid " + y, t.commandStr), [
                      D[u],
                      D[u]
                    ];
                  if (typeof u == "object")
                    return c.commandParameter(
                      u.rgb,
                      D,
                      y + ".rgb",
                      t.commandStr
                    ), c.commandParameter(
                      u.alpha,
                      D,
                      y + ".alpha",
                      t.commandStr
                    ), [
                      D[u.rgb],
                      D[u.alpha]
                    ];
                  c.commandRaise("invalid blend.equation", t.commandStr);
                },
                function(u, m, s) {
                  var g = u.constants.blendEquations, w = m.def(), B = m.def(), U = u.cond("typeof ", s, '==="string"');
                  return c.optional(function() {
                    function k(Y, me, Re) {
                      u.assert(
                        Y,
                        Re + " in " + g,
                        "invalid " + me + ", must be one of " + Object.keys(D)
                      );
                    }
                    k(U.then, y, s), u.assert(
                      U.else,
                      s + "&&typeof " + s + '==="object"',
                      "invalid " + y
                    ), k(U.else, y + ".rgb", s + ".rgb"), k(U.else, y + ".alpha", s + ".alpha");
                  }), U.then(
                    w,
                    "=",
                    B,
                    "=",
                    g,
                    "[",
                    s,
                    "];"
                  ), U.else(
                    w,
                    "=",
                    g,
                    "[",
                    s,
                    ".rgb];",
                    B,
                    "=",
                    g,
                    "[",
                    s,
                    ".alpha];"
                  ), m(U), [w, B];
                }
              );
            case Ii:
              return b(
                function(u) {
                  return c.command(
                    Je(u) && u.length === 4,
                    "blend.color must be a 4d array",
                    t.commandStr
                  ), Et(4, function(m) {
                    return +u[m];
                  });
                },
                function(u, m, s) {
                  return c.optional(function() {
                    u.assert(
                      m,
                      u.shared.isArrayLike + "(" + s + ")&&" + s + ".length===4",
                      "blend.color must be a 4d array"
                    );
                  }), Et(4, function(g) {
                    return m.def("+", s, "[", g, "]");
                  });
                }
              );
            case Yi:
              return b(
                function(u) {
                  return c.commandType(u, "number", v, t.commandStr), u | 0;
                },
                function(u, m, s) {
                  return c.optional(function() {
                    u.assert(
                      m,
                      "typeof " + s + '==="number"',
                      "invalid stencil.mask"
                    );
                  }), m.def(s, "|0");
                }
              );
            case aa:
              return b(
                function(u) {
                  c.commandType(u, "object", v, t.commandStr);
                  var m = u.cmp || "keep", s = u.ref || 0, g = "mask" in u ? u.mask : -1;
                  return c.commandParameter(m, xr, y + ".cmp", t.commandStr), c.commandType(s, "number", y + ".ref", t.commandStr), c.commandType(g, "number", y + ".mask", t.commandStr), [
                    xr[m],
                    s,
                    g
                  ];
                },
                function(u, m, s) {
                  var g = u.constants.compareFuncs;
                  c.optional(function() {
                    function k() {
                      u.assert(
                        m,
                        Array.prototype.join.call(arguments, ""),
                        "invalid stencil.func"
                      );
                    }
                    k(s + "&&typeof ", s, '==="object"'), k(
                      '!("cmp" in ',
                      s,
                      ")||(",
                      s,
                      ".cmp in ",
                      g,
                      ")"
                    );
                  });
                  var w = m.def(
                    '"cmp" in ',
                    s,
                    "?",
                    g,
                    "[",
                    s,
                    ".cmp]",
                    ":",
                    Xt
                  ), B = m.def(s, ".ref|0"), U = m.def(
                    '"mask" in ',
                    s,
                    "?",
                    s,
                    ".mask|0:-1"
                  );
                  return [w, B, U];
                }
              );
            case ia:
            case Or:
              return b(
                function(u) {
                  c.commandType(u, "object", v, t.commandStr);
                  var m = u.fail || "keep", s = u.zfail || "keep", g = u.zpass || "keep";
                  return c.commandParameter(m, Vt, y + ".fail", t.commandStr), c.commandParameter(s, Vt, y + ".zfail", t.commandStr), c.commandParameter(g, Vt, y + ".zpass", t.commandStr), [
                    y === Or ? ar : Pr,
                    Vt[m],
                    Vt[s],
                    Vt[g]
                  ];
                },
                function(u, m, s) {
                  var g = u.constants.stencilOps;
                  c.optional(function() {
                    u.assert(
                      m,
                      s + "&&typeof " + s + '==="object"',
                      "invalid " + y
                    );
                  });
                  function w(B) {
                    return c.optional(function() {
                      u.assert(
                        m,
                        '!("' + B + '" in ' + s + ")||(" + s + "." + B + " in " + g + ")",
                        "invalid " + y + "." + B + ", must be one of " + Object.keys(Vt)
                      );
                    }), m.def(
                      '"',
                      B,
                      '" in ',
                      s,
                      "?",
                      g,
                      "[",
                      s,
                      ".",
                      B,
                      "]:",
                      Xt
                    );
                  }
                  return [
                    y === Or ? ar : Pr,
                    w("fail"),
                    w("zfail"),
                    w("zpass")
                  ];
                }
              );
            case ra:
              return b(
                function(u) {
                  c.commandType(u, "object", v, t.commandStr);
                  var m = u.factor | 0, s = u.units | 0;
                  return c.commandType(m, "number", v + ".factor", t.commandStr), c.commandType(s, "number", v + ".units", t.commandStr), [m, s];
                },
                function(u, m, s) {
                  c.optional(function() {
                    u.assert(
                      m,
                      s + "&&typeof " + s + '==="object"',
                      "invalid " + y
                    );
                  });
                  var g = m.def(s, ".factor|0"), w = m.def(s, ".units|0");
                  return [g, w];
                }
              );
            case Xi:
              return b(
                function(u) {
                  var m = 0;
                  return u === "front" ? m = Pr : u === "back" && (m = ar), c.command(!!m, v, t.commandStr), m;
                },
                function(u, m, s) {
                  return c.optional(function() {
                    u.assert(
                      m,
                      s + '==="front"||' + s + '==="back"',
                      "invalid cull.face"
                    );
                  }), m.def(s, '==="front"?', Pr, ":", ar);
                }
              );
            case ta:
              return b(
                function(u) {
                  return c.command(
                    typeof u == "number" && u >= C.lineWidthDims[0] && u <= C.lineWidthDims[1],
                    "invalid line width, must be a positive number between " + C.lineWidthDims[0] + " and " + C.lineWidthDims[1],
                    t.commandStr
                  ), u;
                },
                function(u, m, s) {
                  return c.optional(function() {
                    u.assert(
                      m,
                      "typeof " + s + '==="number"&&' + s + ">=" + C.lineWidthDims[0] + "&&" + s + "<=" + C.lineWidthDims[1],
                      "invalid line width"
                    );
                  }), s;
                }
              );
            case ea:
              return b(
                function(u) {
                  return c.commandParameter(u, da, v, t.commandStr), da[u];
                },
                function(u, m, s) {
                  return c.optional(function() {
                    u.assert(
                      m,
                      s + '==="cw"||' + s + '==="ccw"',
                      "invalid frontFace, must be one of cw,ccw"
                    );
                  }), m.def(s + '==="cw"?' + ro + ":" + la);
                }
              );
            case Jn:
              return b(
                function(u) {
                  return c.command(
                    Je(u) && u.length === 4,
                    "color.mask must be length 4 array",
                    t.commandStr
                  ), u.map(function(m) {
                    return !!m;
                  });
                },
                function(u, m, s) {
                  return c.optional(function() {
                    u.assert(
                      m,
                      u.shared.isArrayLike + "(" + s + ")&&" + s + ".length===4",
                      "invalid color.mask"
                    );
                  }), Et(4, function(g) {
                    return "!!" + s + "[" + g + "]";
                  });
                }
              );
            case na:
              return b(
                function(u) {
                  c.command(typeof u == "object" && u, v, t.commandStr);
                  var m = "value" in u ? u.value : 1, s = !!u.invert;
                  return c.command(
                    typeof m == "number" && m >= 0 && m <= 1,
                    "sample.coverage.value must be a number between 0 and 1",
                    t.commandStr
                  ), [m, s];
                },
                function(u, m, s) {
                  c.optional(function() {
                    u.assert(
                      m,
                      s + "&&typeof " + s + '==="object"',
                      "invalid sample.coverage"
                    );
                  });
                  var g = m.def(
                    '"value" in ',
                    s,
                    "?+",
                    s,
                    ".value:1"
                  ), w = m.def("!!", s, ".invert");
                  return [g, w];
                }
              );
          }
        }), S;
      }
      function ct(f, t) {
        var p = f.static, E = f.dynamic, S = {};
        return Object.keys(p).forEach(function(y) {
          var v = p[y], b;
          if (typeof v == "number" || typeof v == "boolean")
            b = nt(function() {
              return v;
            });
          else if (typeof v == "function") {
            var u = v._reglType;
            u === "texture2d" || u === "textureCube" ? b = nt(function(m) {
              return m.link(v);
            }) : u === "framebuffer" || u === "framebufferCube" ? (c.command(
              v.color.length > 0,
              'missing color attachment for framebuffer sent to uniform "' + y + '"',
              t.commandStr
            ), b = nt(function(m) {
              return m.link(v.color[0]);
            })) : c.commandRaise('invalid data for uniform "' + y + '"', t.commandStr);
          } else
            Je(v) ? b = nt(function(m) {
              var s = m.global.def(
                "[",
                Et(v.length, function(g) {
                  return c.command(
                    typeof v[g] == "number" || typeof v[g] == "boolean",
                    "invalid uniform " + y,
                    m.commandStr
                  ), v[g];
                }),
                "]"
              );
              return s;
            }) : c.commandRaise('invalid or missing data for uniform "' + y + '"', t.commandStr);
          b.value = v, S[y] = b;
        }), Object.keys(E).forEach(function(y) {
          var v = E[y];
          S[y] = At(v, function(b, u) {
            return b.invoke(u, v);
          });
        }), S;
      }
      function ke(f, t) {
        var p = f.static, E = f.dynamic, S = {};
        return Object.keys(p).forEach(function(y) {
          var v = p[y], b = o.id(y), u = new A();
          if (vn(v))
            u.state = yr, u.buffer = P.getBuffer(
              P.create(v, gr, !1, !0)
            ), u.type = 0;
          else {
            var m = P.getBuffer(v);
            if (m)
              u.state = yr, u.buffer = m, u.type = 0;
            else if (c.command(
              typeof v == "object" && v,
              "invalid data for attribute " + y,
              t.commandStr
            ), "constant" in v) {
              var s = v.constant;
              u.buffer = "null", u.state = Hn, typeof s == "number" ? u.x = s : (c.command(
                Je(s) && s.length > 0 && s.length <= 4,
                "invalid constant for attribute " + y,
                t.commandStr
              ), vr.forEach(function(me, Re) {
                Re < s.length && (u[me] = s[Re]);
              }));
            } else {
              vn(v.buffer) ? m = P.getBuffer(
                P.create(v.buffer, gr, !1, !0)
              ) : m = P.getBuffer(v.buffer), c.command(!!m, 'missing buffer for attribute "' + y + '"', t.commandStr);
              var g = v.offset | 0;
              c.command(
                g >= 0,
                'invalid offset for attribute "' + y + '"',
                t.commandStr
              );
              var w = v.stride | 0;
              c.command(
                w >= 0 && w < 256,
                'invalid stride for attribute "' + y + '", must be integer betweeen [0, 255]',
                t.commandStr
              );
              var B = v.size | 0;
              c.command(
                !("size" in v) || B > 0 && B <= 4,
                'invalid size for attribute "' + y + '", must be 1,2,3,4',
                t.commandStr
              );
              var U = !!v.normalized, k = 0;
              "type" in v && (c.commandParameter(
                v.type,
                Yt,
                "invalid type for attribute " + y,
                t.commandStr
              ), k = Yt[v.type]);
              var Y = v.divisor | 0;
              "divisor" in v && (c.command(
                Y === 0 || K,
                'cannot specify divisor for attribute "' + y + '", instancing not supported',
                t.commandStr
              ), c.command(
                Y >= 0,
                'invalid divisor for attribute "' + y + '"',
                t.commandStr
              )), c.optional(function() {
                var me = t.commandStr, Re = [
                  "buffer",
                  "offset",
                  "divisor",
                  "normalized",
                  "type",
                  "size",
                  "stride"
                ];
                Object.keys(v).forEach(function(he) {
                  c.command(
                    Re.indexOf(he) >= 0,
                    'unknown parameter "' + he + '" for attribute pointer "' + y + '" (valid parameters are ' + Re + ")",
                    me
                  );
                });
              }), u.buffer = m, u.state = yr, u.size = B, u.normalized = U, u.type = k || m.dtype, u.offset = g, u.stride = w, u.divisor = Y;
            }
          }
          S[y] = nt(function(me, Re) {
            var he = me.attribCache;
            if (b in he)
              return he[b];
            var be = {
              isStream: !1
            };
            return Object.keys(u).forEach(function(Te) {
              be[Te] = u[Te];
            }), u.buffer && (be.buffer = me.link(u.buffer), be.type = be.type || be.buffer + ".dtype"), he[b] = be, be;
          });
        }), Object.keys(E).forEach(function(y) {
          var v = E[y];
          function b(u, m) {
            var s = u.invoke(m, v), g = u.shared, w = u.constants, B = g.isBufferArgs, U = g.buffer;
            c.optional(function() {
              u.assert(
                m,
                s + "&&(typeof " + s + '==="object"||typeof ' + s + '==="function")&&(' + B + "(" + s + ")||" + U + ".getBuffer(" + s + ")||" + U + ".getBuffer(" + s + ".buffer)||" + B + "(" + s + '.buffer)||("constant" in ' + s + "&&(typeof " + s + '.constant==="number"||' + g.isArrayLike + "(" + s + ".constant))))",
                'invalid dynamic attribute "' + y + '"'
              );
            });
            var k = {
              isStream: m.def(!1)
            }, Y = new A();
            Y.state = yr, Object.keys(Y).forEach(function(be) {
              k[be] = m.def("" + Y[be]);
            });
            var me = k.buffer, Re = k.type;
            m(
              "if(",
              B,
              "(",
              s,
              ")){",
              k.isStream,
              "=true;",
              me,
              "=",
              U,
              ".createStream(",
              gr,
              ",",
              s,
              ");",
              Re,
              "=",
              me,
              ".dtype;",
              "}else{",
              me,
              "=",
              U,
              ".getBuffer(",
              s,
              ");",
              "if(",
              me,
              "){",
              Re,
              "=",
              me,
              ".dtype;",
              '}else if("constant" in ',
              s,
              "){",
              k.state,
              "=",
              Hn,
              ";",
              "if(typeof " + s + '.constant === "number"){',
              k[vr[0]],
              "=",
              s,
              ".constant;",
              vr.slice(1).map(function(be) {
                return k[be];
              }).join("="),
              "=0;",
              "}else{",
              vr.map(function(be, Te) {
                return k[be] + "=" + s + ".constant.length>" + Te + "?" + s + ".constant[" + Te + "]:0;";
              }).join(""),
              "}}else{",
              "if(",
              B,
              "(",
              s,
              ".buffer)){",
              me,
              "=",
              U,
              ".createStream(",
              gr,
              ",",
              s,
              ".buffer);",
              "}else{",
              me,
              "=",
              U,
              ".getBuffer(",
              s,
              ".buffer);",
              "}",
              Re,
              '="type" in ',
              s,
              "?",
              w.glTypes,
              "[",
              s,
              ".type]:",
              me,
              ".dtype;",
              k.normalized,
              "=!!",
              s,
              ".normalized;"
            );
            function he(be) {
              m(k[be], "=", s, ".", be, "|0;");
            }
            return he("size"), he("offset"), he("stride"), he("divisor"), m("}}"), m.exit(
              "if(",
              k.isStream,
              "){",
              U,
              ".destroyStream(",
              me,
              ");",
              "}"
            ), k;
          }
          S[y] = At(v, b);
        }), S;
      }
      function ot(f, t) {
        var p = f.static, E = f.dynamic;
        if (Dr in p) {
          var S = p[Dr];
          return S !== null && Q.getVAO(S) === null && (S = Q.createVAO(S)), nt(function(v) {
            return v.link(Q.getVAO(S));
          });
        } else if (Dr in E) {
          var y = E[Dr];
          return At(y, function(v, b) {
            var u = v.invoke(b, y);
            return b.def(v.shared.vao + ".getVAO(" + u + ")");
          });
        }
        return null;
      }
      function Ye(f) {
        var t = f.static, p = f.dynamic, E = {};
        return Object.keys(t).forEach(function(S) {
          var y = t[S];
          E[S] = nt(function(v, b) {
            return typeof y == "number" || typeof y == "boolean" ? "" + y : v.link(y);
          });
        }), Object.keys(p).forEach(function(S) {
          var y = p[S];
          E[S] = At(y, function(v, b) {
            return v.invoke(b, y);
          });
        }), E;
      }
      function it(f, t, p, E, S) {
        var y = f.static, v = f.dynamic;
        c.optional(function() {
          var he = [
            er,
            Fr,
            Gr,
            tr,
            rr,
            an,
            nr,
            on,
            Cr,
            Dr
          ].concat(X);
          function be(Te) {
            Object.keys(Te).forEach(function($e) {
              c.command(
                he.indexOf($e) >= 0,
                'unknown parameter "' + $e + '"',
                S.commandStr
              );
            });
          }
          be(y), be(v);
        });
        var b = Ae(f, t), u = de(f), m = Ge(f, u, S), s = Ue(f, S), g = at(f, S), w = Ce(f, S, b);
        function B(he) {
          var be = m[he];
          be && (g[he] = be);
        }
        B($t), B(ne(nn));
        var U = Object.keys(g).length > 0, k = {
          framebuffer: u,
          draw: s,
          shader: w,
          state: g,
          dirty: U,
          scopeVAO: null,
          drawVAO: null,
          useVAO: !1,
          attributes: {}
        };
        if (k.profile = we(f), k.uniforms = ct(p, S), k.drawVAO = k.scopeVAO = ot(f), !k.drawVAO && w.program && !b && h.angle_instanced_arrays) {
          var Y = !0, me = w.program.attributes.map(function(he) {
            var be = t.static[he];
            return Y = Y && !!be, be;
          });
          if (Y && me.length > 0) {
            var Re = Q.getVAO(Q.createVAO(me));
            k.drawVAO = new bt(null, null, null, function(he, be) {
              return he.link(Re);
            }), k.useVAO = !0;
          }
        }
        return b ? k.useVAO = !0 : k.attributes = ke(t, S), k.context = Ye(E), k;
      }
      function st(f, t, p) {
        var E = f.shared, S = E.context, y = f.scope();
        Object.keys(p).forEach(function(v) {
          t.save(S, "." + v);
          var b = p[v], u = b.append(f, t);
          Array.isArray(u) ? y(S, ".", v, "=[", u.join(), "];") : y(S, ".", v, "=", u, ";");
        }), t(y);
      }
      function ft(f, t, p, E) {
        var S = f.shared, y = S.gl, v = S.framebuffer, b;
        se && (b = t.def(S.extensions, ".webgl_draw_buffers"));
        var u = f.constants, m = u.drawBuffer, s = u.backBuffer, g;
        p ? g = p.append(f, t) : g = t.def(v, ".next"), E || t("if(", g, "!==", v, ".cur){"), t(
          "if(",
          g,
          "){",
          y,
          ".bindFramebuffer(",
          oo,
          ",",
          g,
          ".framebuffer);"
        ), se && t(
          b,
          ".drawBuffersWEBGL(",
          m,
          "[",
          g,
          ".colorAttachments.length]);"
        ), t(
          "}else{",
          y,
          ".bindFramebuffer(",
          oo,
          ",null);"
        ), se && t(b, ".drawBuffersWEBGL(", s, ");"), t(
          "}",
          v,
          ".cur=",
          g,
          ";"
        ), E || t("}");
      }
      function lt(f, t, p) {
        var E = f.shared, S = E.gl, y = f.current, v = f.next, b = E.current, u = E.next, m = f.cond(b, ".dirty");
        X.forEach(function(s) {
          var g = ne(s);
          if (!(g in p.state)) {
            var w, B;
            if (g in v) {
              w = v[g], B = y[g];
              var U = Et(z[g].length, function(Y) {
                return m.def(w, "[", Y, "]");
              });
              m(f.cond(U.map(function(Y, me) {
                return Y + "!==" + B + "[" + me + "]";
              }).join("||")).then(
                S,
                ".",
                j[g],
                "(",
                U,
                ");",
                U.map(function(Y, me) {
                  return B + "[" + me + "]=" + Y;
                }).join(";"),
                ";"
              ));
            } else {
              w = m.def(u, ".", g);
              var k = f.cond(w, "!==", b, ".", g);
              m(k), g in re ? k(
                f.cond(w).then(S, ".enable(", re[g], ");").else(S, ".disable(", re[g], ");"),
                b,
                ".",
                g,
                "=",
                w,
                ";"
              ) : k(
                S,
                ".",
                j[g],
                "(",
                w,
                ");",
                b,
                ".",
                g,
                "=",
                w,
                ";"
              );
            }
          }
        }), Object.keys(p.state).length === 0 && m(b, ".dirty=false;"), t(m);
      }
      function mt(f, t, p, E) {
        var S = f.shared, y = f.current, v = S.current, b = S.gl;
        uo(Object.keys(p)).forEach(function(u) {
          var m = p[u];
          if (!(E && !E(m))) {
            var s = m.append(f, t);
            if (re[u]) {
              var g = re[u];
              Ht(m) ? s ? t(b, ".enable(", g, ");") : t(b, ".disable(", g, ");") : t(f.cond(s).then(b, ".enable(", g, ");").else(b, ".disable(", g, ");")), t(v, ".", u, "=", s, ";");
            } else if (Je(s)) {
              var w = y[u];
              t(
                b,
                ".",
                j[u],
                "(",
                s,
                ");",
                s.map(function(B, U) {
                  return w + "[" + U + "]=" + B;
                }).join(";"),
                ";"
              );
            } else
              t(
                b,
                ".",
                j[u],
                "(",
                s,
                ");",
                v,
                ".",
                u,
                "=",
                s,
                ";"
              );
          }
        });
      }
      function et(f, t) {
        K && (f.instancing = t.def(
          f.shared.extensions,
          ".angle_instanced_arrays"
        ));
      }
      function Le(f, t, p, E, S) {
        var y = f.shared, v = f.stats, b = y.current, u = y.timer, m = p.profile;
        function s() {
          return typeof performance > "u" ? "Date.now()" : "performance.now()";
        }
        var g, w;
        function B(he) {
          g = t.def(), he(g, "=", s(), ";"), typeof S == "string" ? he(v, ".count+=", S, ";") : he(v, ".count++;"), H && (E ? (w = t.def(), he(w, "=", u, ".getNumPendingQueries();")) : he(u, ".beginQuery(", v, ");"));
        }
        function U(he) {
          he(v, ".cpuTime+=", s(), "-", g, ";"), H && (E ? he(
            u,
            ".pushScopeStats(",
            w,
            ",",
            u,
            ".getNumPendingQueries(),",
            v,
            ");"
          ) : he(u, ".endQuery();"));
        }
        function k(he) {
          var be = t.def(b, ".profile");
          t(b, ".profile=", he, ";"), t.exit(b, ".profile=", be, ";");
        }
        var Y;
        if (m) {
          if (Ht(m)) {
            m.enable ? (B(t), U(t.exit), k("true")) : k("false");
            return;
          }
          Y = m.append(f, t), k(Y);
        } else
          Y = t.def(b, ".profile");
        var me = f.block();
        B(me), t("if(", Y, "){", me, "}");
        var Re = f.block();
        U(Re), t.exit("if(", Y, "){", Re, "}");
      }
      function pt(f, t, p, E, S) {
        var y = f.shared;
        function v(u) {
          switch (u) {
            case sn:
            case cn:
            case hn:
              return 2;
            case fn:
            case ln:
            case mn:
              return 3;
            case un:
            case dn:
            case pn:
              return 4;
            default:
              return 1;
          }
        }
        function b(u, m, s) {
          var g = y.gl, w = t.def(u, ".location"), B = t.def(y.attributes, "[", w, "]"), U = s.state, k = s.buffer, Y = [
            s.x,
            s.y,
            s.z,
            s.w
          ], me = [
            "buffer",
            "normalized",
            "offset",
            "stride"
          ];
          function Re() {
            t(
              "if(!",
              B,
              ".buffer){",
              g,
              ".enableVertexAttribArray(",
              w,
              ");}"
            );
            var be = s.type, Te;
            if (s.size ? Te = t.def(s.size, "||", m) : Te = m, t(
              "if(",
              B,
              ".type!==",
              be,
              "||",
              B,
              ".size!==",
              Te,
              "||",
              me.map(function(Ke) {
                return B + "." + Ke + "!==" + s[Ke];
              }).join("||"),
              "){",
              g,
              ".bindBuffer(",
              gr,
              ",",
              k,
              ".buffer);",
              g,
              ".vertexAttribPointer(",
              [
                w,
                Te,
                be,
                s.normalized,
                s.stride,
                s.offset
              ],
              ");",
              B,
              ".type=",
              be,
              ";",
              B,
              ".size=",
              Te,
              ";",
              me.map(function(Ke) {
                return B + "." + Ke + "=" + s[Ke] + ";";
              }).join(""),
              "}"
            ), K) {
              var $e = s.divisor;
              t(
                "if(",
                B,
                ".divisor!==",
                $e,
                "){",
                f.instancing,
                ".vertexAttribDivisorANGLE(",
                [w, $e],
                ");",
                B,
                ".divisor=",
                $e,
                ";}"
              );
            }
          }
          function he() {
            t(
              "if(",
              B,
              ".buffer){",
              g,
              ".disableVertexAttribArray(",
              w,
              ");",
              B,
              ".buffer=null;",
              "}if(",
              vr.map(function(be, Te) {
                return B + "." + be + "!==" + Y[Te];
              }).join("||"),
              "){",
              g,
              ".vertexAttrib4f(",
              w,
              ",",
              Y,
              ");",
              vr.map(function(be, Te) {
                return B + "." + be + "=" + Y[Te] + ";";
              }).join(""),
              "}"
            );
          }
          U === yr ? Re() : U === Hn ? he() : (t("if(", U, "===", yr, "){"), Re(), t("}else{"), he(), t("}"));
        }
        E.forEach(function(u) {
          var m = u.name, s = p.attributes[m], g;
          if (s) {
            if (!S(s))
              return;
            g = s.append(f, t);
          } else {
            if (!S(co))
              return;
            var w = f.scopeAttrib(m);
            c.optional(function() {
              f.assert(
                t,
                w + ".state",
                "missing attribute " + m
              );
            }), g = {}, Object.keys(new A()).forEach(function(B) {
              g[B] = t.def(w, ".", B);
            });
          }
          b(
            f.link(u),
            v(u.info.type),
            g
          );
        });
      }
      function Xe(f, t, p, E, S) {
        for (var y = f.shared, v = y.gl, b, u = 0; u < E.length; ++u) {
          var m = E[u], s = m.name, g = m.info.type, w = p.uniforms[s], B = f.link(m), U = B + ".location", k;
          if (w) {
            if (!S(w))
              continue;
            if (Ht(w)) {
              var Y = w.value;
              if (c.command(
                Y !== null && typeof Y < "u",
                'missing uniform "' + s + '"',
                f.commandStr
              ), g === Br || g === Ir) {
                c.command(
                  typeof Y == "function" && (g === Br && (Y._reglType === "texture2d" || Y._reglType === "framebuffer") || g === Ir && (Y._reglType === "textureCube" || Y._reglType === "framebufferCube")),
                  "invalid texture for uniform " + s,
                  f.commandStr
                );
                var me = f.link(Y._texture || Y.color[0]._texture);
                t(v, ".uniform1i(", U, ",", me + ".bind());"), t.exit(me, ".unbind();");
              } else if (g === Mr || g === Nr || g === kr) {
                c.optional(function() {
                  c.command(
                    Je(Y),
                    "invalid matrix for uniform " + s,
                    f.commandStr
                  ), c.command(
                    g === Mr && Y.length === 4 || g === Nr && Y.length === 9 || g === kr && Y.length === 16,
                    "invalid length for matrix uniform " + s,
                    f.commandStr
                  );
                });
                var Re = f.global.def("new Float32Array([" + Array.prototype.slice.call(Y) + "])"), he = 2;
                g === Nr ? he = 3 : g === kr && (he = 4), t(
                  v,
                  ".uniformMatrix",
                  he,
                  "fv(",
                  U,
                  ",false,",
                  Re,
                  ");"
                );
              } else {
                switch (g) {
                  case fa:
                    c.commandType(Y, "number", "uniform " + s, f.commandStr), b = "1f";
                    break;
                  case sn:
                    c.command(
                      Je(Y) && Y.length === 2,
                      "uniform " + s,
                      f.commandStr
                    ), b = "2f";
                    break;
                  case fn:
                    c.command(
                      Je(Y) && Y.length === 3,
                      "uniform " + s,
                      f.commandStr
                    ), b = "3f";
                    break;
                  case un:
                    c.command(
                      Je(Y) && Y.length === 4,
                      "uniform " + s,
                      f.commandStr
                    ), b = "4f";
                    break;
                  case ca:
                    c.commandType(Y, "boolean", "uniform " + s, f.commandStr), b = "1i";
                    break;
                  case ua:
                    c.commandType(Y, "number", "uniform " + s, f.commandStr), b = "1i";
                    break;
                  case hn:
                    c.command(
                      Je(Y) && Y.length === 2,
                      "uniform " + s,
                      f.commandStr
                    ), b = "2i";
                    break;
                  case cn:
                    c.command(
                      Je(Y) && Y.length === 2,
                      "uniform " + s,
                      f.commandStr
                    ), b = "2i";
                    break;
                  case mn:
                    c.command(
                      Je(Y) && Y.length === 3,
                      "uniform " + s,
                      f.commandStr
                    ), b = "3i";
                    break;
                  case ln:
                    c.command(
                      Je(Y) && Y.length === 3,
                      "uniform " + s,
                      f.commandStr
                    ), b = "3i";
                    break;
                  case pn:
                    c.command(
                      Je(Y) && Y.length === 4,
                      "uniform " + s,
                      f.commandStr
                    ), b = "4i";
                    break;
                  case dn:
                    c.command(
                      Je(Y) && Y.length === 4,
                      "uniform " + s,
                      f.commandStr
                    ), b = "4i";
                    break;
                }
                t(
                  v,
                  ".uniform",
                  b,
                  "(",
                  U,
                  ",",
                  Je(Y) ? Array.prototype.slice.call(Y) : Y,
                  ");"
                );
              }
              continue;
            } else
              k = w.append(f, t);
          } else {
            if (!S(co))
              continue;
            k = t.def(y.uniforms, "[", o.id(s), "]");
          }
          g === Br ? (c(!Array.isArray(k), "must specify a scalar prop for textures"), t(
            "if(",
            k,
            "&&",
            k,
            '._reglType==="framebuffer"){',
            k,
            "=",
            k,
            ".color[0];",
            "}"
          )) : g === Ir && (c(!Array.isArray(k), "must specify a scalar prop for cube maps"), t(
            "if(",
            k,
            "&&",
            k,
            '._reglType==="framebufferCube"){',
            k,
            "=",
            k,
            ".color[0];",
            "}"
          )), c.optional(function() {
            function gt(Nt, _o) {
              f.assert(
                t,
                Nt,
                'bad data or missing for uniform "' + s + '".  ' + _o
              );
            }
            function ha(Nt) {
              c(!Array.isArray(k), "must not specify an array type for uniform"), gt(
                "typeof " + k + '==="' + Nt + '"',
                "invalid type, expected " + Nt
              );
            }
            function Ot(Nt, _o) {
              Array.isArray(k) ? c(k.length === Nt, "must have length " + Nt) : gt(
                y.isArrayLike + "(" + k + ")&&" + k + ".length===" + Nt,
                "invalid vector, should have length " + Nt,
                f.commandStr
              );
            }
            function yo(Nt) {
              c(!Array.isArray(k), "must not specify a value type"), gt(
                "typeof " + k + '==="function"&&' + k + '._reglType==="texture' + (Nt === eo ? "2d" : "Cube") + '"',
                "invalid texture type",
                f.commandStr
              );
            }
            switch (g) {
              case ua:
                ha("number");
                break;
              case cn:
                Ot(2);
                break;
              case ln:
                Ot(3);
                break;
              case dn:
                Ot(4);
                break;
              case fa:
                ha("number");
                break;
              case sn:
                Ot(2);
                break;
              case fn:
                Ot(3);
                break;
              case un:
                Ot(4);
                break;
              case ca:
                ha("boolean");
                break;
              case hn:
                Ot(2);
                break;
              case mn:
                Ot(3);
                break;
              case pn:
                Ot(4);
                break;
              case Mr:
                Ot(4);
                break;
              case Nr:
                Ot(9);
                break;
              case kr:
                Ot(16);
                break;
              case Br:
                yo(eo);
                break;
              case Ir:
                yo(vu);
                break;
            }
          });
          var be = 1;
          switch (g) {
            case Br:
            case Ir:
              var Te = t.def(k, "._texture");
              t(v, ".uniform1i(", U, ",", Te, ".bind());"), t.exit(Te, ".unbind();");
              continue;
            case ua:
            case ca:
              b = "1i";
              break;
            case cn:
            case hn:
              b = "2i", be = 2;
              break;
            case ln:
            case mn:
              b = "3i", be = 3;
              break;
            case dn:
            case pn:
              b = "4i", be = 4;
              break;
            case fa:
              b = "1f";
              break;
            case sn:
              b = "2f", be = 2;
              break;
            case fn:
              b = "3f", be = 3;
              break;
            case un:
              b = "4f", be = 4;
              break;
            case Mr:
              b = "Matrix2fv";
              break;
            case Nr:
              b = "Matrix3fv";
              break;
            case kr:
              b = "Matrix4fv";
              break;
          }
          if (t(v, ".uniform", b, "(", U, ","), b.charAt(0) === "M") {
            var $e = Math.pow(g - Mr + 2, 2), Ke = f.global.def("new Float32Array(", $e, ")");
            Array.isArray(k) ? t(
              "false,(",
              Et($e, function(gt) {
                return Ke + "[" + gt + "]=" + k[gt];
              }),
              ",",
              Ke,
              ")"
            ) : t(
              "false,(Array.isArray(",
              k,
              ")||",
              k,
              " instanceof Float32Array)?",
              k,
              ":(",
              Et($e, function(gt) {
                return Ke + "[" + gt + "]=" + k + "[" + gt + "]";
              }),
              ",",
              Ke,
              ")"
            );
          } else
            be > 1 ? t(Et(be, function(gt) {
              return Array.isArray(k) ? k[gt] : k + "[" + gt + "]";
            })) : (c(!Array.isArray(k), "uniform value must not be an array"), t(k));
          t(");");
        }
      }
      function _e(f, t, p, E) {
        var S = f.shared, y = S.gl, v = S.draw, b = E.draw;
        function u() {
          var Te = b.elements, $e, Ke = t;
          return Te ? ((Te.contextDep && E.contextDynamic || Te.propDep) && (Ke = p), $e = Te.append(f, Ke)) : $e = Ke.def(v, ".", tr), $e && Ke(
            "if(" + $e + ")" + y + ".bindBuffer(" + hu + "," + $e + ".buffer.buffer);"
          ), $e;
        }
        function m() {
          var Te = b.count, $e, Ke = t;
          return Te ? ((Te.contextDep && E.contextDynamic || Te.propDep) && (Ke = p), $e = Te.append(f, Ke), c.optional(function() {
            Te.MISSING && f.assert(t, "false", "missing vertex count"), Te.DYNAMIC && f.assert(Ke, $e + ">=0", "missing vertex count");
          })) : ($e = Ke.def(v, ".", nr), c.optional(function() {
            f.assert(Ke, $e + ">=0", "missing vertex count");
          })), $e;
        }
        var s = u();
        function g(Te) {
          var $e = b[Te];
          return $e ? $e.contextDep && E.contextDynamic || $e.propDep ? $e.append(f, p) : $e.append(f, t) : t.def(v, ".", Te);
        }
        var w = g(rr), B = g(an), U = m();
        if (typeof U == "number") {
          if (U === 0)
            return;
        } else
          p("if(", U, "){"), p.exit("}");
        var k, Y;
        K && (k = g(on), Y = f.instancing);
        var me = s + ".type", Re = b.elements && Ht(b.elements);
        function he() {
          function Te() {
            p(Y, ".drawElementsInstancedANGLE(", [
              w,
              U,
              me,
              B + "<<((" + me + "-" + Di + ")>>1)",
              k
            ], ");");
          }
          function $e() {
            p(
              Y,
              ".drawArraysInstancedANGLE(",
              [w, B, U, k],
              ");"
            );
          }
          s ? Re ? Te() : (p("if(", s, "){"), Te(), p("}else{"), $e(), p("}")) : $e();
        }
        function be() {
          function Te() {
            p(y + ".drawElements(" + [
              w,
              U,
              me,
              B + "<<((" + me + "-" + Di + ")>>1)"
            ] + ");");
          }
          function $e() {
            p(y + ".drawArrays(" + [w, B, U] + ");");
          }
          s ? Re ? Te() : (p("if(", s, "){"), Te(), p("}else{"), $e(), p("}")) : $e();
        }
        K && (typeof k != "number" || k >= 0) ? typeof k == "string" ? (p("if(", k, ">0){"), he(), p("}else if(", k, "<0){"), be(), p("}")) : he() : be();
      }
      function Me(f, t, p, E, S) {
        var y = ge(), v = y.proc("body", S);
        return c.optional(function() {
          y.commandStr = t.commandStr, y.command = y.link(t.commandStr);
        }), K && (y.instancing = v.def(
          y.shared.extensions,
          ".angle_instanced_arrays"
        )), f(y, v, p, E), y.compile().body;
      }
      function Pe(f, t, p, E) {
        et(f, t), p.useVAO ? p.drawVAO ? t(f.shared.vao, ".setVAO(", p.drawVAO.append(f, t), ");") : t(f.shared.vao, ".setVAO(", f.shared.vao, ".targetVAO);") : (t(f.shared.vao, ".setVAO(null);"), pt(f, t, p, E.attributes, function() {
          return !0;
        })), Xe(f, t, p, E.uniforms, function() {
          return !0;
        }), _e(f, t, t, p);
      }
      function tt(f, t) {
        var p = f.proc("draw", 1);
        et(f, p), st(f, p, t.context), ft(f, p, t.framebuffer), lt(f, p, t), mt(f, p, t.state), Le(f, p, t, !1, !0);
        var E = t.shader.progVar.append(f, p);
        if (p(f.shared.gl, ".useProgram(", E, ".program);"), t.shader.program)
          Pe(f, p, t, t.shader.program);
        else {
          p(f.shared.vao, ".setVAO(null);");
          var S = f.global.def("{}"), y = p.def(E, ".id"), v = p.def(S, "[", y, "]");
          p(
            f.cond(v).then(v, ".call(this,a0);").else(
              v,
              "=",
              S,
              "[",
              y,
              "]=",
              f.link(function(b) {
                return Me(Pe, f, t, b, 1);
              }),
              "(",
              E,
              ");",
              v,
              ".call(this,a0);"
            )
          );
        }
        Object.keys(t.state).length > 0 && p(f.shared.current, ".dirty=true;");
      }
      function Pt(f, t, p, E) {
        f.batchId = "a1", et(f, t);
        function S() {
          return !0;
        }
        pt(f, t, p, E.attributes, S), Xe(f, t, p, E.uniforms, S), _e(f, t, t, p);
      }
      function ir(f, t, p, E) {
        et(f, t);
        var S = p.contextDep, y = t.def(), v = "a0", b = "a1", u = t.def();
        f.shared.props = u, f.batchId = y;
        var m = f.scope(), s = f.scope();
        t(
          m.entry,
          "for(",
          y,
          "=0;",
          y,
          "<",
          b,
          ";++",
          y,
          "){",
          u,
          "=",
          v,
          "[",
          y,
          "];",
          s,
          "}",
          m.exit
        );
        function g(me) {
          return me.contextDep && S || me.propDep;
        }
        function w(me) {
          return !g(me);
        }
        if (p.needsContext && st(f, s, p.context), p.needsFramebuffer && ft(f, s, p.framebuffer), mt(f, s, p.state, g), p.profile && g(p.profile) && Le(f, s, p, !1, !0), E)
          p.useVAO ? p.drawVAO ? g(p.drawVAO) ? s(f.shared.vao, ".setVAO(", p.drawVAO.append(f, s), ");") : m(f.shared.vao, ".setVAO(", p.drawVAO.append(f, m), ");") : m(f.shared.vao, ".setVAO(", f.shared.vao, ".targetVAO);") : (m(f.shared.vao, ".setVAO(null);"), pt(f, m, p, E.attributes, w), pt(f, s, p, E.attributes, g)), Xe(f, m, p, E.uniforms, w), Xe(f, s, p, E.uniforms, g), _e(f, m, s, p);
        else {
          var B = f.global.def("{}"), U = p.shader.progVar.append(f, s), k = s.def(U, ".id"), Y = s.def(B, "[", k, "]");
          s(
            f.shared.gl,
            ".useProgram(",
            U,
            ".program);",
            "if(!",
            Y,
            "){",
            Y,
            "=",
            B,
            "[",
            k,
            "]=",
            f.link(function(me) {
              return Me(
                Pt,
                f,
                p,
                me,
                2
              );
            }),
            "(",
            U,
            ");}",
            Y,
            ".call(this,a0[",
            y,
            "],",
            y,
            ");"
          );
        }
      }
      function l(f, t) {
        var p = f.proc("batch", 2);
        f.batchId = "0", et(f, p);
        var E = !1, S = !0;
        Object.keys(t.context).forEach(function(B) {
          E = E || t.context[B].propDep;
        }), E || (st(f, p, t.context), S = !1);
        var y = t.framebuffer, v = !1;
        y ? (y.propDep ? E = v = !0 : y.contextDep && E && (v = !0), v || ft(f, p, y)) : ft(f, p, null), t.state.viewport && t.state.viewport.propDep && (E = !0);
        function b(B) {
          return B.contextDep && E || B.propDep;
        }
        lt(f, p, t), mt(f, p, t.state, function(B) {
          return !b(B);
        }), (!t.profile || !b(t.profile)) && Le(f, p, t, !1, "a1"), t.contextDep = E, t.needsContext = S, t.needsFramebuffer = v;
        var u = t.shader.progVar;
        if (u.contextDep && E || u.propDep)
          ir(
            f,
            p,
            t,
            null
          );
        else {
          var m = u.append(f, p);
          if (p(f.shared.gl, ".useProgram(", m, ".program);"), t.shader.program)
            ir(
              f,
              p,
              t,
              t.shader.program
            );
          else {
            p(f.shared.vao, ".setVAO(null);");
            var s = f.global.def("{}"), g = p.def(m, ".id"), w = p.def(s, "[", g, "]");
            p(
              f.cond(w).then(w, ".call(this,a0,a1);").else(
                w,
                "=",
                s,
                "[",
                g,
                "]=",
                f.link(function(B) {
                  return Me(ir, f, t, B, 2);
                }),
                "(",
                m,
                ");",
                w,
                ".call(this,a0,a1);"
              )
            );
          }
        }
        Object.keys(t.state).length > 0 && p(f.shared.current, ".dirty=true;");
      }
      function F(f, t) {
        var p = f.proc("scope", 3);
        f.batchId = "a2";
        var E = f.shared, S = E.current;
        st(f, p, t.context), t.framebuffer && t.framebuffer.append(f, p), uo(Object.keys(t.state)).forEach(function(v) {
          var b = t.state[v], u = b.append(f, p);
          Je(u) ? u.forEach(function(m, s) {
            p.set(f.next[v], "[" + s + "]", m);
          }) : p.set(E.next, "." + v, u);
        }), Le(f, p, t, !0, !0), [tr, an, nr, on, rr].forEach(
          function(v) {
            var b = t.draw[v];
            b && p.set(E.draw, "." + v, "" + b.append(f, p));
          }
        ), Object.keys(t.uniforms).forEach(function(v) {
          var b = t.uniforms[v].append(f, p);
          Array.isArray(b) && (b = "[" + b.join() + "]"), p.set(
            E.uniforms,
            "[" + o.id(v) + "]",
            b
          );
        }), Object.keys(t.attributes).forEach(function(v) {
          var b = t.attributes[v].append(f, p), u = f.scopeAttrib(v);
          Object.keys(new A()).forEach(function(m) {
            p.set(u, "." + m, b[m]);
          });
        }), t.scopeVAO && p.set(E.vao, ".targetVAO", t.scopeVAO.append(f, p));
        function y(v) {
          var b = t.shader[v];
          b && p.set(E.shader, "." + v, b.append(f, p));
        }
        y(Fr), y(Gr), Object.keys(t.state).length > 0 && (p(S, ".dirty=true;"), p.exit(S, ".dirty=true;")), p("a1(", f.shared.context, ",a0,", f.batchId, ");");
      }
      function L(f) {
        if (!(typeof f != "object" || Je(f))) {
          for (var t = Object.keys(f), p = 0; p < t.length; ++p)
            if (St.isDynamic(f[t[p]]))
              return !0;
          return !1;
        }
      }
      function ce(f, t, p) {
        var E = t.static[p];
        if (!E || !L(E))
          return;
        var S = f.global, y = Object.keys(E), v = !1, b = !1, u = !1, m = f.global.def("{}");
        y.forEach(function(g) {
          var w = E[g];
          if (St.isDynamic(w)) {
            typeof w == "function" && (w = E[g] = St.unbox(w));
            var B = At(w, null);
            v = v || B.thisDep, u = u || B.propDep, b = b || B.contextDep;
          } else {
            switch (S(m, ".", g, "="), typeof w) {
              case "number":
                S(w);
                break;
              case "string":
                S('"', w, '"');
                break;
              case "object":
                Array.isArray(w) && S("[", w.join(), "]");
                break;
              default:
                S(f.link(w));
                break;
            }
            S(";");
          }
        });
        function s(g, w) {
          y.forEach(function(B) {
            var U = E[B];
            if (St.isDynamic(U)) {
              var k = g.invoke(w, U);
              w(m, ".", B, "=", k, ";");
            }
          });
        }
        t.dynamic[p] = new St.DynamicVariable(rn, {
          thisDep: v,
          contextDep: b,
          propDep: u,
          ref: m,
          append: s
        }), delete t.static[p];
      }
      function De(f, t, p, E, S) {
        var y = ge();
        y.stats = y.link(S), Object.keys(t.static).forEach(function(b) {
          ce(y, t, b);
        }), du.forEach(function(b) {
          ce(y, f, b);
        });
        var v = it(f, t, p, E, y);
        return tt(y, v), F(y, v), l(y, v), _(y.compile(), {
          destroy: function() {
            v.shader.program.destroy();
          }
        });
      }
      return {
        next: ue,
        current: z,
        procs: function() {
          var f = ge(), t = f.proc("poll"), p = f.proc("refresh"), E = f.block();
          t(E), p(E);
          var S = f.shared, y = S.gl, v = S.next, b = S.current;
          E(b, ".dirty=false;"), ft(f, t), ft(f, p, null, !0);
          var u;
          K && (u = f.link(K)), h.oes_vertex_array_object && p(f.link(h.oes_vertex_array_object), ".bindVertexArrayOES(null);");
          for (var m = 0; m < C.maxAttributes; ++m) {
            var s = p.def(S.attributes, "[", m, "]"), g = f.cond(s, ".buffer");
            g.then(
              y,
              ".enableVertexAttribArray(",
              m,
              ");",
              y,
              ".bindBuffer(",
              gr,
              ",",
              s,
              ".buffer.buffer);",
              y,
              ".vertexAttribPointer(",
              m,
              ",",
              s,
              ".size,",
              s,
              ".type,",
              s,
              ".normalized,",
              s,
              ".stride,",
              s,
              ".offset);"
            ).else(
              y,
              ".disableVertexAttribArray(",
              m,
              ");",
              y,
              ".vertexAttrib4f(",
              m,
              ",",
              s,
              ".x,",
              s,
              ".y,",
              s,
              ".z,",
              s,
              ".w);",
              s,
              ".buffer=null;"
            ), p(g), K && p(
              u,
              ".vertexAttribDivisorANGLE(",
              m,
              ",",
              s,
              ".divisor);"
            );
          }
          return p(
            f.shared.vao,
            ".currentVAO=null;",
            f.shared.vao,
            ".setVAO(",
            f.shared.vao,
            ".targetVAO);"
          ), Object.keys(re).forEach(function(w) {
            var B = re[w], U = E.def(v, ".", w), k = f.block();
            k(
              "if(",
              U,
              "){",
              y,
              ".enable(",
              B,
              ")}else{",
              y,
              ".disable(",
              B,
              ")}",
              b,
              ".",
              w,
              "=",
              U,
              ";"
            ), p(k), t(
              "if(",
              U,
              "!==",
              b,
              ".",
              w,
              "){",
              k,
              "}"
            );
          }), Object.keys(j).forEach(function(w) {
            var B = j[w], U = z[w], k, Y, me = f.block();
            if (me(y, ".", B, "("), Je(U)) {
              var Re = U.length;
              k = f.global.def(v, ".", w), Y = f.global.def(b, ".", w), me(
                Et(Re, function(he) {
                  return k + "[" + he + "]";
                }),
                ");",
                Et(Re, function(he) {
                  return Y + "[" + he + "]=" + k + "[" + he + "];";
                }).join("")
              ), t(
                "if(",
                Et(Re, function(he) {
                  return k + "[" + he + "]!==" + Y + "[" + he + "]";
                }).join("||"),
                "){",
                me,
                "}"
              );
            } else
              k = E.def(v, ".", w), Y = E.def(b, ".", w), me(
                k,
                ");",
                b,
                ".",
                w,
                "=",
                k,
                ";"
              ), t(
                "if(",
                k,
                "!==",
                Y,
                "){",
                me,
                "}"
              );
            p(me);
          }), f.compile();
        }(),
        compile: De
      };
    }
    function Gu() {
      return {
        vaoCount: 0,
        bufferCount: 0,
        elementsCount: 0,
        framebufferCount: 0,
        shaderCount: 0,
        textureCount: 0,
        cubeCount: 0,
        renderbufferCount: 0,
        maxTextureUnits: 0
      };
    }
    var Du = 34918, Mu = 34919, lo = 35007, Nu = function(e, o) {
      if (!o.ext_disjoint_timer_query)
        return null;
      var h = [];
      function C() {
        return h.pop() || o.ext_disjoint_timer_query.createQueryEXT();
      }
      function P(K) {
        h.push(K);
      }
      var R = [];
      function G(K) {
        var se = C();
        o.ext_disjoint_timer_query.beginQueryEXT(lo, se), R.push(se), H(R.length - 1, R.length, K);
      }
      function V() {
        o.ext_disjoint_timer_query.endQueryEXT(lo);
      }
      function q() {
        this.startQueryIndex = -1, this.endQueryIndex = -1, this.sum = 0, this.stats = null;
      }
      var Q = [];
      function W() {
        return Q.pop() || new q();
      }
      function J(K) {
        Q.push(K);
      }
      var ae = [];
      function H(K, se, z) {
        var ue = W();
        ue.startQueryIndex = K, ue.endQueryIndex = se, ue.sum = 0, ue.stats = z, ae.push(ue);
      }
      var te = [], A = [];
      function D() {
        var K, se, z = R.length;
        if (z !== 0) {
          A.length = Math.max(A.length, z + 1), te.length = Math.max(te.length, z + 1), te[0] = 0, A[0] = 0;
          var ue = 0;
          for (K = 0, se = 0; se < R.length; ++se) {
            var X = R[se];
            o.ext_disjoint_timer_query.getQueryObjectEXT(X, Mu) ? (ue += o.ext_disjoint_timer_query.getQueryObjectEXT(X, Du), P(X)) : R[K++] = X, te[se + 1] = ue, A[se + 1] = K;
          }
          for (R.length = K, K = 0, se = 0; se < ae.length; ++se) {
            var re = ae[se], j = re.startQueryIndex, ne = re.endQueryIndex;
            re.sum += te[ne] - te[j];
            var ye = A[j], Ee = A[ne];
            Ee === ye ? (re.stats.gpuTime += re.sum / 1e6, J(re)) : (re.startQueryIndex = ye, re.endQueryIndex = Ee, ae[K++] = re);
          }
          ae.length = K;
        }
      }
      return {
        beginQuery: G,
        endQuery: V,
        pushScopeStats: H,
        update: D,
        getNumPendingQueries: function() {
          return R.length;
        },
        clear: function() {
          h.push.apply(h, R);
          for (var K = 0; K < h.length; K++)
            o.ext_disjoint_timer_query.deleteQueryEXT(h[K]);
          R.length = 0, h.length = 0;
        },
        restore: function() {
          R.length = 0, h.length = 0;
        }
      };
    }, ku = 16384, Bu = 256, Iu = 1024, Pu = 34962, ho = "webglcontextlost", mo = "webglcontextrestored", po = 1, Uu = 2, $u = 3;
    function vo(e, o) {
      for (var h = 0; h < e.length; ++h)
        if (e[h] === o)
          return h;
      return -1;
    }
    function zu(e) {
      var o = Io(e);
      if (!o)
        return null;
      var h = o.gl, C = h.getContextAttributes(), P = h.isContextLost(), R = Po(h, o);
      if (!R)
        return null;
      var G = Do(), V = Gu(), q = R.extensions, Q = Nu(h, q), W = Aa(), J = h.drawingBufferWidth, ae = h.drawingBufferHeight, H = {
        tick: 0,
        time: 0,
        viewportWidth: J,
        viewportHeight: ae,
        framebufferWidth: J,
        framebufferHeight: ae,
        drawingBufferWidth: J,
        drawingBufferHeight: ae,
        pixelRatio: o.pixelRatio
      }, te = {}, A = {
        elements: null,
        primitive: 4,
        // GL_TRIANGLES
        count: -1,
        offset: 0,
        instances: -1
      }, D = ws(h, q), K = zs(
        h,
        V,
        o,
        z
      ), se = tu(
        h,
        q,
        D,
        V,
        K
      );
      function z(_e) {
        return se.destroyBuffer(_e);
      }
      var ue = ef(h, q, K, V), X = iu(h, G, V, o), re = Gf(
        h,
        q,
        D,
        function() {
          ye.procs.poll();
        },
        H,
        V,
        o
      ), j = Df(h, q, D, V, o), ne = Jf(
        h,
        q,
        D,
        re,
        j,
        V
      ), ye = Fu(
        h,
        G,
        q,
        D,
        K,
        ue,
        re,
        ne,
        te,
        se,
        X,
        A,
        H,
        Q,
        o
      ), Ee = fu(
        h,
        ne,
        ye.procs.poll,
        H,
        C,
        q,
        D
      ), ie = ye.next, Z = h.canvas, $ = [], ge = [], we = [], de = [o.onDestroy], Ge = null;
      function Ae() {
        if ($.length === 0) {
          Q && Q.update(), Ge = null;
          return;
        }
        Ge = _n.next(Ae), mt();
        for (var _e = $.length - 1; _e >= 0; --_e) {
          var Me = $[_e];
          Me && Me(H, null, 0);
        }
        h.flush(), Q && Q.update();
      }
      function Ce() {
        !Ge && $.length > 0 && (Ge = _n.next(Ae));
      }
      function Ue() {
        Ge && (_n.cancel(Ae), Ge = null);
      }
      function at(_e) {
        _e.preventDefault(), P = !0, Ue(), ge.forEach(function(Me) {
          Me();
        });
      }
      function ct(_e) {
        h.getError(), P = !1, R.restore(), X.restore(), K.restore(), re.restore(), j.restore(), ne.restore(), se.restore(), Q && Q.restore(), ye.procs.refresh(), Ce(), we.forEach(function(Me) {
          Me();
        });
      }
      Z && (Z.addEventListener(ho, at, !1), Z.addEventListener(mo, ct, !1));
      function ke() {
        $.length = 0, Ue(), Z && (Z.removeEventListener(ho, at), Z.removeEventListener(mo, ct)), X.clear(), ne.clear(), j.clear(), re.clear(), ue.clear(), K.clear(), se.clear(), Q && Q.clear(), de.forEach(function(_e) {
          _e();
        });
      }
      function ot(_e) {
        c(!!_e, "invalid args to regl({...})"), c.type(_e, "object", "invalid args to regl({...})");
        function Me(S) {
          var y = _({}, S);
          delete y.uniforms, delete y.attributes, delete y.context, delete y.vao, "stencil" in y && y.stencil.op && (y.stencil.opBack = y.stencil.opFront = y.stencil.op, delete y.stencil.op);
          function v(b) {
            if (b in y) {
              var u = y[b];
              delete y[b], Object.keys(u).forEach(function(m) {
                y[b + "." + m] = u[m];
              });
            }
          }
          return v("blend"), v("depth"), v("cull"), v("stencil"), v("polygonOffset"), v("scissor"), v("sample"), "vao" in S && (y.vao = S.vao), y;
        }
        function Pe(S, y) {
          var v = {}, b = {};
          return Object.keys(S).forEach(function(u) {
            var m = S[u];
            if (St.isDynamic(m)) {
              b[u] = St.unbox(m, u);
              return;
            } else if (y && Array.isArray(m)) {
              for (var s = 0; s < m.length; ++s)
                if (St.isDynamic(m[s])) {
                  b[u] = St.unbox(m, u);
                  return;
                }
            }
            v[u] = m;
          }), {
            dynamic: b,
            static: v
          };
        }
        var tt = Pe(_e.context || {}, !0), Pt = Pe(_e.uniforms || {}, !0), ir = Pe(_e.attributes || {}, !1), l = Pe(Me(_e), !1), F = {
          gpuTime: 0,
          cpuTime: 0,
          count: 0
        }, L = ye.compile(l, ir, Pt, tt, F), ce = L.draw, De = L.batch, f = L.scope, t = [];
        function p(S) {
          for (; t.length < S; )
            t.push(null);
          return t;
        }
        function E(S, y) {
          var v;
          if (P && c.raise("context lost"), typeof S == "function")
            return f.call(this, null, S, 0);
          if (typeof y == "function")
            if (typeof S == "number")
              for (v = 0; v < S; ++v)
                f.call(this, null, y, v);
            else if (Array.isArray(S))
              for (v = 0; v < S.length; ++v)
                f.call(this, S[v], y, v);
            else
              return f.call(this, S, y, 0);
          else if (typeof S == "number") {
            if (S > 0)
              return De.call(this, p(S | 0), S | 0);
          } else if (Array.isArray(S)) {
            if (S.length)
              return De.call(this, S, S.length);
          } else
            return ce.call(this, S);
        }
        return _(E, {
          stats: F,
          destroy: function() {
            L.destroy();
          }
        });
      }
      var Ye = ne.setFBO = ot({
        framebuffer: St.define.call(null, po, "framebuffer")
      });
      function it(_e, Me) {
        var Pe = 0;
        ye.procs.poll();
        var tt = Me.color;
        tt && (h.clearColor(+tt[0] || 0, +tt[1] || 0, +tt[2] || 0, +tt[3] || 0), Pe |= ku), "depth" in Me && (h.clearDepth(+Me.depth), Pe |= Bu), "stencil" in Me && (h.clearStencil(Me.stencil | 0), Pe |= Iu), c(!!Pe, "called regl.clear with no buffer specified"), h.clear(Pe);
      }
      function st(_e) {
        if (c(
          typeof _e == "object" && _e,
          "regl.clear() takes an object as input"
        ), "framebuffer" in _e)
          if (_e.framebuffer && _e.framebuffer_reglType === "framebufferCube")
            for (var Me = 0; Me < 6; ++Me)
              Ye(_({
                framebuffer: _e.framebuffer.faces[Me]
              }, _e), it);
          else
            Ye(_e, it);
        else
          it(null, _e);
      }
      function ft(_e) {
        c.type(_e, "function", "regl.frame() callback must be a function"), $.push(_e);
        function Me() {
          var Pe = vo($, _e);
          c(Pe >= 0, "cannot cancel a frame twice");
          function tt() {
            var Pt = vo($, tt);
            $[Pt] = $[$.length - 1], $.length -= 1, $.length <= 0 && Ue();
          }
          $[Pe] = tt;
        }
        return Ce(), {
          cancel: Me
        };
      }
      function lt() {
        var _e = ie.viewport, Me = ie.scissor_box;
        _e[0] = _e[1] = Me[0] = Me[1] = 0, H.viewportWidth = H.framebufferWidth = H.drawingBufferWidth = _e[2] = Me[2] = h.drawingBufferWidth, H.viewportHeight = H.framebufferHeight = H.drawingBufferHeight = _e[3] = Me[3] = h.drawingBufferHeight;
      }
      function mt() {
        H.tick += 1, H.time = Le(), lt(), ye.procs.poll();
      }
      function et() {
        re.refresh(), lt(), ye.procs.refresh(), Q && Q.update();
      }
      function Le() {
        return (Aa() - W) / 1e3;
      }
      et();
      function pt(_e, Me) {
        c.type(Me, "function", "listener callback must be a function");
        var Pe;
        switch (_e) {
          case "frame":
            return ft(Me);
          case "lost":
            Pe = ge;
            break;
          case "restore":
            Pe = we;
            break;
          case "destroy":
            Pe = de;
            break;
          default:
            c.raise("invalid event, must be one of frame,lost,restore,destroy");
        }
        return Pe.push(Me), {
          cancel: function() {
            for (var tt = 0; tt < Pe.length; ++tt)
              if (Pe[tt] === Me) {
                Pe[tt] = Pe[Pe.length - 1], Pe.pop();
                return;
              }
          }
        };
      }
      var Xe = _(ot, {
        // Clear current FBO
        clear: st,
        // Short cuts for dynamic variables
        prop: St.define.bind(null, po),
        context: St.define.bind(null, Uu),
        this: St.define.bind(null, $u),
        // executes an empty draw command
        draw: ot({}),
        // Resources
        buffer: function(_e) {
          return K.create(_e, Pu, !1, !1);
        },
        elements: function(_e) {
          return ue.create(_e, !1);
        },
        texture: re.create2D,
        cube: re.createCube,
        renderbuffer: j.create,
        framebuffer: ne.create,
        framebufferCube: ne.createCube,
        vao: se.createVAO,
        // Expose context attributes
        attributes: C,
        // Frame rendering
        frame: ft,
        on: pt,
        // System limits
        limits: D,
        hasExtension: function(_e) {
          return D.extensions.indexOf(_e.toLowerCase()) >= 0;
        },
        // Read pixels
        read: Ee,
        // Destroy regl and all associated resources
        destroy: ke,
        // Direct GL state manipulation
        _gl: h,
        _refresh: et,
        poll: function() {
          mt(), Q && Q.update();
        },
        // Current time
        now: Le,
        // regl Statistics Information
        stats: V
      });
      return o.onDone(null, Xe), Xe;
    }
    return zu;
  });
})(regl$1);
var reglExports = regl$1.exports;
const regl = /* @__PURE__ */ getDefaultExportFromCjs(reglExports), Mouse = mouseListen();
class HydraRenderer {
  constructor({
    pb: n = null,
    width: d = 1280,
    height: _ = 720,
    numSources: T = 4,
    numOutputs: N = 4,
    makeGlobal: le = !0,
    autoLoop: fe = !0,
    detectAudio: Oe = !0,
    enableStreamCapture: pe = !0,
    canvas: Ie,
    precision: ve,
    extendTransforms: Be = {}
    // add your own functions on init
  } = {}) {
    if (ArrayUtils.init(), this.pb = n, this.width = d, this.height = _, this.renderAll = !1, this.detectAudio = Oe, this._initCanvas(Ie), this.synth = {
      time: 0,
      bpm: 30,
      width: this.width,
      height: this.height,
      fps: void 0,
      stats: {
        fps: 0
      },
      speed: 1,
      mouse: Mouse,
      render: this._render.bind(this),
      setResolution: this.setResolution.bind(this),
      update: (je) => {
      },
      // user defined update function
      hush: this.hush.bind(this),
      tick: this.tick.bind(this)
    }, le && (window.loadScript = this.loadScript), this.timeSinceLastUpdate = 0, this._time = 0, ve && ["lowp", "mediump", "highp"].includes(ve.toLowerCase()))
      this.precision = ve.toLowerCase();
    else {
      let je = (/iPad|iPhone|iPod/.test(navigator.platform) || navigator.platform === "MacIntel" && navigator.maxTouchPoints > 1) && !window.MSStream;
      this.precision = je ? "highp" : "mediump";
    }
    if (this.extendTransforms = Be, this.saveFrame = !1, this.captureStream = null, this.generator = void 0, this._initRegl(), this._initOutputs(N), this._initSources(T), this._generateGlslTransforms(), this.synth.screencap = () => {
      this.saveFrame = !0;
    }, pe)
      try {
        this.captureStream = this.canvas.captureStream(25), this.synth.vidRecorder = new VideoRecorder(this.captureStream);
      } catch (je) {
        console.warn(`[hydra-synth warning]
new MediaSource() is not currently supported on iOS.`), console.error(je);
      }
    Oe && this._initAudio(), fe && loop(this.tick.bind(this)).start(), this.sandbox = new EvalSandbox(this.synth, le, ["speed", "update", "bpm", "fps"]);
  }
  eval(n) {
    this.sandbox.eval(n);
  }
  getScreenImage(n) {
    this.imageCallback = n, this.saveFrame = !0;
  }
  hush() {
    this.s.forEach((n) => {
      n.clear();
    }), this.o.forEach((n) => {
      this.synth.solid(0, 0, 0, 0).out(n);
    }), this.synth.render(this.o[0]), this.sandbox.set("update", (n) => {
    });
  }
  loadScript(n = "") {
    return new Promise((_, T) => {
      var N = document.createElement("script");
      N.onload = function() {
        console.log(`loaded script ${n}`), _();
      }, N.onerror = (le) => {
        console.log(`error loading script ${n}`, "log-error"), _();
      }, N.src = n, document.head.appendChild(N);
    });
  }
  setResolution(n, d) {
    this.canvas.width = n, this.canvas.height = d, this.width = n, this.height = d, this.sandbox.set("width", n), this.sandbox.set("height", d), console.log(this.width), this.o.forEach((_) => {
      _.resize(n, d);
    }), this.s.forEach((_) => {
      _.resize(n, d);
    }), this.regl._refresh(), console.log(this.canvas.width);
  }
  canvasToImage(n) {
    const d = document.createElement("a");
    d.style.display = "none";
    let _ = /* @__PURE__ */ new Date();
    d.download = `hydra-${_.getFullYear()}-${_.getMonth() + 1}-${_.getDate()}-${_.getHours()}.${_.getMinutes()}.${_.getSeconds()}.png`, document.body.appendChild(d);
    var T = this;
    this.canvas.toBlob((N) => {
      T.imageCallback ? (T.imageCallback(N), delete T.imageCallback) : (d.href = URL.createObjectURL(N), console.log(d.href), d.click());
    }, "image/png"), setTimeout(() => {
      document.body.removeChild(d), window.URL.revokeObjectURL(d.href);
    }, 300);
  }
  _initAudio() {
    this.synth.a = new Audio({
      numBins: 4,
      parentEl: this.canvas.parentNode
      // changeListener: ({audio}) => {
      //   that.a = audio.bins.map((_, index) =>
      //     (scale = 1, offset = 0) => () => (audio.fft[index] * scale + offset)
      //   )
      //
      //   if (that.makeGlobal) {
      //     that.a.forEach((a, index) => {
      //       const aname = `a${index}`
      //       window[aname] = a
      //     })
      //   }
      // }
    });
  }
  // create main output canvas and add to screen
  _initCanvas(n) {
    n ? (this.canvas = n, this.width = n.width, this.height = n.height) : (this.canvas = document.createElement("canvas"), this.canvas.width = this.width, this.canvas.height = this.height, this.canvas.style.width = "100%", this.canvas.style.height = "100%", this.canvas.style.imageRendering = "pixelated", document.body.appendChild(this.canvas));
  }
  _initRegl() {
    this.regl = regl({
      //  profile: true,
      canvas: this.canvas,
      pixelRatio: 1
      //,
      // extensions: [
      //   'oes_texture_half_float',
      //   'oes_texture_half_float_linear'
      // ],
      // optionalExtensions: [
      //   'oes_texture_float',
      //   'oes_texture_float_linear'
      //]
    }), this.regl.clear({
      color: [0, 0, 0, 1]
    }), this.renderAll = this.regl({
      frag: `
      precision ${this.precision} float;
      varying vec2 uv;
      uniform sampler2D tex0;
      uniform sampler2D tex1;
      uniform sampler2D tex2;
      uniform sampler2D tex3;

      void main () {
        vec2 st = vec2(1.0 - uv.x, uv.y);
        st*= vec2(2);
        vec2 q = floor(st).xy*(vec2(2.0, 1.0));
        int quad = int(q.x) + int(q.y);
        st.x += step(1., mod(st.y,2.0));
        st.y += step(1., mod(st.x,2.0));
        st = fract(st);
        if(quad==0){
          gl_FragColor = texture2D(tex0, st);
        } else if(quad==1){
          gl_FragColor = texture2D(tex1, st);
        } else if (quad==2){
          gl_FragColor = texture2D(tex2, st);
        } else {
          gl_FragColor = texture2D(tex3, st);
        }

      }
      `,
      vert: `
      precision ${this.precision} float;
      attribute vec2 position;
      varying vec2 uv;

      void main () {
        uv = position;
        gl_Position = vec4(1.0 - 2.0 * position, 0, 1);
      }`,
      attributes: {
        position: [
          [-2, 0],
          [0, -2],
          [2, 2]
        ]
      },
      uniforms: {
        tex0: this.regl.prop("tex0"),
        tex1: this.regl.prop("tex1"),
        tex2: this.regl.prop("tex2"),
        tex3: this.regl.prop("tex3")
      },
      count: 3,
      depth: { enable: !1 }
    }), this.renderFbo = this.regl({
      frag: `
      precision ${this.precision} float;
      varying vec2 uv;
      uniform vec2 resolution;
      uniform sampler2D tex0;

      void main () {
        gl_FragColor = texture2D(tex0, vec2(1.0 - uv.x, uv.y));
      }
      `,
      vert: `
      precision ${this.precision} float;
      attribute vec2 position;
      varying vec2 uv;

      void main () {
        uv = position;
        gl_Position = vec4(1.0 - 2.0 * position, 0, 1);
      }`,
      attributes: {
        position: [
          [-2, 0],
          [0, -2],
          [2, 2]
        ]
      },
      uniforms: {
        tex0: this.regl.prop("tex0"),
        resolution: this.regl.prop("resolution")
      },
      count: 3,
      depth: { enable: !1 }
    });
  }
  _initOutputs(n) {
    const d = this;
    this.o = Array(n).fill().map((_, T) => {
      var N = new Output({
        regl: this.regl,
        width: this.width,
        height: this.height,
        precision: this.precision,
        label: `o${T}`
      });
      return N.id = T, d.synth["o" + T] = N, N;
    }), this.output = this.o[0];
  }
  _initSources(n) {
    this.s = [];
    for (var d = 0; d < n; d++)
      this.createSource(d);
  }
  createSource(n) {
    let d = new HydraSource({ regl: this.regl, pb: this.pb, width: this.width, height: this.height, label: `s${n}` });
    return this.synth["s" + this.s.length] = d, this.s.push(d), d;
  }
  _generateGlslTransforms() {
    var n = this;
    this.generator = new GeneratorFactory({
      defaultOutput: this.o[0],
      defaultUniforms: this.o[0].uniforms,
      extendTransforms: this.extendTransforms,
      changeListener: ({ type: d, method: _, synth: T }) => {
        d === "add" && (n.synth[_] = T.generators[_], n.sandbox && n.sandbox.add(_));
      }
    }), this.synth.setFunction = this.generator.setFunction.bind(this.generator);
  }
  _render(n) {
    n ? (this.output = n, this.isRenderingAll = !1) : this.isRenderingAll = !0;
  }
  // dt in ms
  tick(n, d) {
    if (this.sandbox.tick(), this.detectAudio === !0 && this.synth.a.tick(), this.sandbox.set("time", this.synth.time += n * 1e-3 * this.synth.speed), this.timeSinceLastUpdate += n, !this.synth.fps || this.timeSinceLastUpdate >= 1e3 / this.synth.fps) {
      if (this.synth.stats.fps = Math.ceil(1e3 / this.timeSinceLastUpdate), this.synth.update)
        try {
          this.synth.update(this.timeSinceLastUpdate);
        } catch (_) {
          console.log(_);
        }
      for (let _ = 0; _ < this.s.length; _++)
        this.s[_].tick(this.synth.time);
      for (let _ = 0; _ < this.o.length; _++)
        this.o[_].tick({
          time: this.synth.time,
          mouse: this.synth.mouse,
          bpm: this.synth.bpm,
          resolution: [this.canvas.width, this.canvas.height]
        });
      this.isRenderingAll ? this.renderAll({
        tex0: this.o[0].getCurrent(),
        tex1: this.o[1].getCurrent(),
        tex2: this.o[2].getCurrent(),
        tex3: this.o[3].getCurrent(),
        resolution: [this.canvas.width, this.canvas.height]
      }) : this.renderFbo({
        tex0: this.output.getCurrent(),
        resolution: [this.canvas.width, this.canvas.height]
      }), this.timeSinceLastUpdate = 0;
    }
    this.saveFrame === !0 && (this.canvasToImage(), this.saveFrame = !1);
  }
}
function parseNumber(r, n, d, _) {
  const T = parseInt(r, 10);
  return isNaN$1(T, d, _) ? n : T;
}
function parseJSON(r, n) {
  let d = n;
  try {
    d = JSON.parse(r);
  } catch {
  }
  return d;
}
function parseOption(r, n, d) {
  return d.includes(r) ? r : n;
}
function isNaN$1(r, n, d) {
  return d ? Number.isNaN(r) || r < n || r > d : Number.isNaN(r) || r < n;
}
function hydraEval(code, synth, log = !1) {
  const {
    // synth settings
    render,
    update,
    setResolution,
    hush,
    setFunction,
    speed,
    bpm,
    width,
    height,
    time,
    mouse,
    stats,
    // default outputs
    o0,
    o1,
    o2,
    o3,
    // default sources
    s0,
    s1,
    s2,
    s3,
    // source generators
    noise,
    voronoi,
    osc,
    shape,
    gradient,
    src,
    solid,
    prev,
    // utils
    a,
    screencap,
    vidRecorder
  } = synth;
  log && (console.log(render), console.log(update), console.log(setResolution), console.log(hush), console.log(setFunction), console.log(speed), console.log(bpm), console.log(width), console.log(height), console.log(time), console.log(mouse), console.log(stats), console.log(o0), console.log(o1), console.log(o2), console.log(o3), console.log(s0), console.log(s1), console.log(s2), console.log(s3), console.log(noise), console.log(voronoi), console.log(osc), console.log(shape), console.log(gradient), console.log(src), console.log(solid), console.log(prev), console.log(a), console.log(screencap), console.log(vidRecorder)), eval(code);
}
const DEFAULT_OPTIONS = {
  canvas: null,
  width: window.innerWidth,
  height: window.innerHeight,
  autoLoop: !0,
  makeGlobal: !1,
  detectAudio: !1,
  numSources: 4,
  numOutputs: 4,
  extendTransforms: [],
  precision: null,
  pb: null
};
class HydraElement extends HTMLElement {
  /**
   * An array of attribute names to observe on the custom element.
   * @returns {string[]}
   */
  static get observedAttributes() {
    return [
      "width",
      "height",
      "global",
      "audio",
      "sources",
      "outputs",
      "precision"
    ];
  }
  /**
   * Creates an instance of Element.
   * @constructor
   */
  constructor() {
    super(), this._code = "", this._options = { ...DEFAULT_OPTIONS }, this.attachShadow({ mode: "open" });
  }
  /**
   * Returns the canvas element associated with this element.
   * @returns {HTMLCanvasElement} The canvas element.
   */
  get canvas() {
    return this._options.canvas;
  }
  /**
   * Setter for the canvas property.
   * @param {HTMLCanvasElement} value - The canvas element to set.
   */
  set canvas(n) {
    var d, _;
    this._options.canvas && ((_ = (d = this.shadowRoot) == null ? void 0 : d.querySelector("canvas")) == null || _.remove()), this._options.canvas = n, this._hydra && this._initHydra();
  }
  /**
   * Get the transforms of the element.
   * @returns {Array<Function>} The extended transforms.
   */
  get transforms() {
    return this._options.extendTransforms;
  }
  /**
   * Setter for the transforms property.
   * @param {Array<Function>} value - An array of functions to extend the transforms.
   */
  set transforms(n) {
    this._options.extendTransforms = n, this._hydra && this._options.extendTransforms.forEach((d) => this._hydra.synth.setFunction(d));
  }
  /**
   * Gets the value of pb.
   *
   * @returns {Object} The value of pb.
   */
  get pb() {
    return this._options.pb;
  }
  /**
   * Sets the value of pb option.
   * @param {Object} value - The value to set for pb.
   */
  set pb(n) {
    this._options.pb = n, this._hydra && this._initHydra();
  }
  /**
   * Get the code of the element.
   * @returns {string} The code of the element.
   */
  get code() {
    return this._code;
  }
  /**
   * Setter for the code property.
   * @param {string} value - The code to be set.
   */
  set code(n) {
    this._code = n, this._hydra && this._evalCode();
  }
  /**
   * Called when an observed attribute has been added, removed, updated, or replaced.
   * @param {string} attrName - The name of the attribute that was changed.
   * @param {string|null} oldValue - The previous value of the attribute, or null if it didn't exist before.
   * @param {string|null} newValue - The new value of the attribute, or null if it was removed.
   */
  attributeChangedCallback(n, d, _) {
    _ !== d && (this._options = this._getNewOptions(n, _), this._initCanvas(), this._initHydra(), this._evalCode());
  }
  /**
   * Invoked each time the custom element is appended into a document-connected element.
   * If the element has a code block in its textContent, it will be evaluated and rendered on the canvas.
   * If the canvas or hydra instance are not initialized, they will be initialized.
   * @returns {void}
   */
  connectedCallback() {
    this._code === "" && this.textContent && (this._code = this.textContent, this.textContent = ""), this._options.canvas || this._initCanvas(), this._hydra || this._initHydra(), this._code !== "" && this._evalCode();
  }
  /**
   * Updates the element's state based on the elapsed time since the last tick.
   * @param {number} dt - The elapsed time in seconds.
   */
  tick(n) {
    this._hydra && this._hydra.tick(n);
  }
  /**
   * Initializes the canvas element for the element.
   * @private
   */
  _initCanvas() {
    var n, d, _;
    (d = (n = this.shadowRoot) == null ? void 0 : n.querySelector("canvas")) == null || d.remove(), this._options.canvas = document.createElement("canvas"), this._options.canvas.width = this._options.width, this._options.canvas.height = this._options.height, this._options.canvas.style.width = "100%", this._options.canvas.style.height = "100%", (_ = this.shadowRoot) == null || _.appendChild(this._options.canvas);
  }
  /**
   * Initializes the Hydra instance with the provided options and extends the transforms with the provided functions.
   * @private
   */
  _initHydra() {
    this._hydra = new HydraRenderer({ ...this._options }), this._options.extendTransforms.forEach((n) => this._hydra.synth.setFunction(n));
  }
  /**
   * Evaluates the code in a new async function and executes it.
   * @private
   */
  _evalCode() {
    const n = `(async () => { ${this._code} })()`;
    this._options.makeGlobal ? (globalThis._hydra = this._hydra, this._hydra.sandbox.eval(n)) : hydraEval(n, this._hydra.synth);
  }
  /**
   * Returns a new options object with the updated value for the specified attribute.
   * @param {string} attrName - The name of the attribute to update.
   * @param {any} newValue - The new value for the attribute.
   * @returns {Object} - A new options object with the updated attribute value.
   * @private
   */
  _getNewOptions(n, d) {
    switch (n) {
      case "width":
        return { ...this._options, width: parseNumber(d, DEFAULT_OPTIONS.width, 0) };
      case "height":
        return { ...this._options, height: parseNumber(d, DEFAULT_OPTIONS.height, 0) };
      case "global":
        return { ...this._options, makeGlobal: parseJSON(d, DEFAULT_OPTIONS.makeGlobal) };
      case "audio":
        return { ...this._options, detectAudio: parseJSON(d, DEFAULT_OPTIONS.detectAudio) };
      case "sources":
        return { ...this._options, numSources: parseNumber(d, DEFAULT_OPTIONS.numSources, 0) };
      case "outputs":
        return { ...this._options, numOutputs: parseNumber(d, DEFAULT_OPTIONS.numOutputs, 0) };
      case "precision":
        return { ...this._options, precision: parseOption(d, DEFAULT_OPTIONS.precision, ["highp", "mediump", "lowp"]) };
      default:
        return { ...this._options };
    }
  }
}
window.customElements.define("hydra-element", HydraElement);
